

   MEMBER('WEBORDER.clw')                                  ! This is a MEMBER module


   INCLUDE('ABTOOLBA.INC'),ONCE
   INCLUDE('ABWINDOW.INC'),ONCE

                     MAP
                       INCLUDE('WEBOR001.INC'),ONCE        !Local module procedure declarations
                       INCLUDE('WEBOR002.INC'),ONCE        !Req'd for module callout resolution
                       INCLUDE('WEBOR003.INC'),ONCE        !Req'd for module callout resolution
                     END



Main PROCEDURE                                             ! Generated from procedure template - Frame

FilesOpened          BYTE                                  !
AppFrame             APPLICATION('Application'),AT(,,400,240),FONT('MS Sans Serif',8,COLOR:Black,),STATUS(-1,80,120,45),SYSTEM,MAX,RESIZE,IMM
                       MENUBAR
                         MENU('&File'),USE(?FileMenu)
                           ITEM('&Print Setup ...'),USE(?PrintSetup),MSG('Setup printer'),STD(STD:PrintSetup)
                           ITEM,SEPARATOR
                           ITEM('E&xit'),USE(?Exit),MSG('Exit this application'),STD(STD:Close)
                         END
                         MENU('&Edit'),USE(?EditMenu)
                           ITEM('Cu&t'),USE(?Cut),MSG('Remove item to Windows Clipboard'),STD(STD:Cut)
                           ITEM('&Copy'),USE(?Copy),MSG('Copy item to Windows Clipboard'),STD(STD:Copy)
                           ITEM('&Paste'),USE(?Paste),MSG('Paste contents of Windows Clipboard'),STD(STD:Paste)
                         END
                         MENU('&Browse'),USE(?BrowseMenu)
                           ITEM('Browse Customer Information File'),USE(?BrowseCustomer),MSG('Browse Customer Information File')
                           ITEM('Browse Product Information File'),USE(?BrowseProduct),MSG('Browse Product Information File')
                         END
                         MENU('&Window'),USE(?WindowMenu),MSG('Create and Arrange windows'),STD(STD:WindowList)
                           ITEM('T&ile'),USE(?Tile),MSG('Make all open windows visible'),STD(STD:TileWindow)
                           ITEM('&Cascade'),USE(?Cascade),MSG('Stack all open windows'),STD(STD:CascadeWindow)
                           ITEM('&Arrange Icons'),USE(?Arrange),MSG('Align all window icons'),STD(STD:ArrangeIcons)
                         END
                         MENU('&Help'),USE(?HelpMenu),MSG('Windows Help')
                           ITEM('&Contents'),USE(?Helpindex),MSG('View the contents of the help file'),STD(STD:HelpIndex)
                           ITEM('&Search for Help On...'),USE(?HelpSearch),MSG('Search for help on a subject'),STD(STD:HelpSearch)
                           ITEM('&How to Use Help'),USE(?HelpOnHelp),MSG('How to use Windows Help'),STD(STD:HelpOnHelp)
                         END
                       END
                       TOOLBAR,AT(0,0,400,22)
                         BUTTON,AT(4,2,16,14),USE(?Toolbar:Top,Toolbar:Top),DISABLE,TIP('Go to the First Page'),ICON('VCRFIRST.ICO'),FLAT
                         BUTTON,AT(20,2,16,14),USE(?Toolbar:PageUp,Toolbar:PageUp),DISABLE,TIP('Go to the Prior Page'),ICON('VCRPRIOR.ICO'),FLAT
                         BUTTON,AT(36,2,16,14),USE(?Toolbar:Up,Toolbar:Up),DISABLE,TIP('Go to the Prior Record'),ICON('VCRUP.ICO'),FLAT
                         BUTTON,AT(52,2,16,14),USE(?Toolbar:Locate,Toolbar:Locate),DISABLE,TIP('Locate record'),ICON('FIND.ICO'),FLAT
                         BUTTON,AT(68,2,16,14),USE(?Toolbar:Down,Toolbar:Down),DISABLE,TIP('Go to the Next Record'),ICON('VCRDOWN.ICO'),FLAT
                         BUTTON,AT(84,2,16,14),USE(?Toolbar:PageDown,Toolbar:PageDown),DISABLE,TIP('Go to the Next Page'),ICON('VCRNEXT.ICO'),FLAT
                         BUTTON,AT(100,2,16,14),USE(?Toolbar:Bottom,Toolbar:Bottom),DISABLE,TIP('Go to the Last Page'),ICON('VCRLAST.ICO'),FLAT
                         BUTTON,AT(120,2,16,14),USE(?Toolbar:Select,Toolbar:Select),DISABLE,TIP('Select This Record'),ICON('MARK.ICO'),FLAT
                         BUTTON,AT(136,2,16,14),USE(?Toolbar:Insert,Toolbar:Insert),DISABLE,TIP('Insert a New Record'),ICON('INSERT.ICO'),FLAT
                         BUTTON,AT(152,2,16,14),USE(?Toolbar:Change,Toolbar:Change),DISABLE,TIP('Edit This Record'),ICON('EDIT.ICO'),FLAT
                         BUTTON,AT(168,2,16,14),USE(?Toolbar:Delete,Toolbar:Delete),DISABLE,TIP('Delete This Record'),ICON('DELETE.ICO'),FLAT
                         BUTTON,AT(188,2,16,14),USE(?Toolbar:History,Toolbar:History),DISABLE,TIP('Previous value'),ICON('DITTO.ICO'),FLAT
                         BUTTON,AT(204,2,16,14),USE(?Toolbar:Help,Toolbar:Help),DISABLE,TIP('Get Help'),ICON('HELP.ICO'),FLAT
                       END
                     END
MainFrame            CLASS(WebFrameClass),MODULE('WEBOR001.clw')
CopyControlsToWindow   PROCEDURE(*WebWindowClass,BYTE,BYTE),VIRTUAL
TakeEvent              PROCEDURE,SIGNED,VIRTUAL
                     END
WebWindow            CLASS(WebWindowClass)
                     END
IC:CurControl        &WebControlClass                      ! Temporary control pointer
IC:CurFrame          &WebFrameClass

ThisWindow           CLASS(WindowManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
Kill                   PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
TakeAccepted           PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
TakeEvent              PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
                     END

Toolbar              ToolbarClass

  CODE
  GlobalResponse = ThisWindow.Run()                        ! Opens the window and starts an Accept Loop

!---------------------------------------------------------------------------
DefineListboxStyle ROUTINE
!|
!| This routine create all the styles to be shared in this window
!| It`s called after the window open
!|
!---------------------------------------------------------------------------
Menu::FileMenu ROUTINE                                     ! Code for menu items on ?FileMenu
Menu::EditMenu ROUTINE                                     ! Code for menu items on ?EditMenu
Menu::BrowseMenu ROUTINE                                   ! Code for menu items on ?BrowseMenu
  CASE ACCEPTED()
  OF ?BrowseCustomer
    START(BrowseCustomer, 050000)
  OF ?BrowseProduct
    START(BrowseProduct, 050000)
  END
Menu::WindowMenu ROUTINE                                   ! Code for menu items on ?WindowMenu
Menu::HelpMenu ROUTINE                                     ! Code for menu items on ?HelpMenu

ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('Main')
  SELF.Request = GlobalRequest                             ! Store the incoming request
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = 1
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors                              ! Set this windows ErrorManager to the global ErrorManager
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)                                     ! Clear GlobalRequest after storing locally
  CLEAR(GlobalResponse)
  MainFrame.FrameWindow &= AppFrame
  SELF.Open(AppFrame)                                      ! Open window
  COMPILE ('**CW7**',_CWVER_=7000)
      AppFrame{PROP:TabBarVisible}  = False
  !**CW7**
  Do DefineListboxStyle
  !- Initialise the internet classes
  WebWindow.Init(WebServer, HtmlManager, AppFrame{PROP:text} & ' (Main)')
  WebWindow.SetFormatOptions(2, 2, 6, 13)
  WebWindow.MenubarType = PROP:above
  WebWindow.CreateClose = CLOSE:Always
  WebWindow.SetPageBackground(12632256, 'Crumpled.gif')
  WebWindow.BorderWidth = 2
  WebWindow.SheetBorderWidth = 2
  WebWindow.OptionBorderWidth = 2
  WebWindow.GroupBorderWidth = 2
  WebWindow.CreateCaption = 1
  SetWebActiveFrame(MainFrame)
  INIMgr.Fetch('Main',AppFrame)                            ! Restore window settings from non-volatile store
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.Opened
    INIMgr.Update('Main',AppFrame)                         ! Save window data to non-volatile store
  END
  WebWindow.Kill
  SetWebActiveFrame()
  IF (WebServer.Active)
    POST(EVENT:NewPage)
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.TakeAccepted PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receive all EVENT:Accepted's
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
    CASE ACCEPTED()
    OF ?Toolbar:Top
    OROF ?Toolbar:PageUp
    OROF ?Toolbar:Up
    OROF ?Toolbar:Locate
    OROF ?Toolbar:Down
    OROF ?Toolbar:PageDown
    OROF ?Toolbar:Bottom
    OROF ?Toolbar:Select
    OROF ?Toolbar:Insert
    OROF ?Toolbar:Change
    OROF ?Toolbar:Delete
    OROF ?Toolbar:History
    OROF ?Toolbar:Help
      IF SYSTEM{PROP:Active} <> THREAD()
        POST(EVENT:Accepted,ACCEPTED(),SYSTEM{Prop:Active} )
        CYCLE
      END
    ELSE
      DO Menu::FileMenu                                    ! Process menu items on ?FileMenu menu
      DO Menu::EditMenu                                    ! Process menu items on ?EditMenu menu
      DO Menu::BrowseMenu                                  ! Process menu items on ?BrowseMenu menu
      DO Menu::WindowMenu                                  ! Process menu items on ?WindowMenu menu
      DO Menu::HelpMenu                                    ! Process menu items on ?HelpMenu menu
    END
  ReturnValue = PARENT.TakeAccepted()
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


ThisWindow.TakeEvent PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receives all events
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
    IF WebWindow.TakeEvent()
      BREAK
    END
  ReturnValue = PARENT.TakeEvent()
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue

MainFrame.CopyControlsToWindow PROCEDURE(*WebWindowClass OwnerWindow, BYTE MergeMenu, BYTE MergeTool)
  CODE
  IF MergeTool
    SELF.CopyControlToWindow(OwnerWindow, ?Toolbar:Top)
    SELF.CopyControlToWindow(OwnerWindow, ?Toolbar:PageUp)
    SELF.CopyControlToWindow(OwnerWindow, ?Toolbar:Up)
    SELF.CopyControlToWindow(OwnerWindow, ?Toolbar:Locate)
    SELF.CopyControlToWindow(OwnerWindow, ?Toolbar:Down)
    SELF.CopyControlToWindow(OwnerWindow, ?Toolbar:PageDown)
    SELF.CopyControlToWindow(OwnerWindow, ?Toolbar:Bottom)
    SELF.CopyControlToWindow(OwnerWindow, ?Toolbar:Select)
    SELF.CopyControlToWindow(OwnerWindow, ?Toolbar:Insert)
    SELF.CopyControlToWindow(OwnerWindow, ?Toolbar:Change)
    SELF.CopyControlToWindow(OwnerWindow, ?Toolbar:Delete)
    SELF.CopyControlToWindow(OwnerWindow, ?Toolbar:Help)
  END


MainFrame.TakeEvent     PROCEDURE

FirstIteration       SIGNED(1)

  CODE
  LOOP
    RETURN REPLY:NONE
  END
  RETURN REPLY:BREAK

