

   MEMBER('WEBORDER.clw')                                  ! This is a MEMBER module


   INCLUDE('ABBROWSE.INC'),ONCE
   INCLUDE('ABPOPUP.INC'),ONCE
   INCLUDE('ABRESIZE.INC'),ONCE
   INCLUDE('ABTOOLBA.INC'),ONCE
   INCLUDE('ABWINDOW.INC'),ONCE

                     MAP
                       INCLUDE('WEBOR004.INC'),ONCE        !Local module procedure declarations
                       INCLUDE('WEBOR006.INC'),ONCE        !Req'd for module callout resolution
                       INCLUDE('WEBOR007.INC'),ONCE        !Req'd for module callout resolution
                     END



UpdateCustomer PROCEDURE                                   ! Generated from procedure template - Window

CurrentTab           STRING(80)                            !
FilesOpened          BYTE                                  !
ActionMessage        CSTRING(40)                           !
BRW2::View:Browse    VIEW(Orders)
                       PROJECT(ORD:CustNo)
                       PROJECT(ORD:OrderNo)
                       PROJECT(ORD:OrderDate)
                       PROJECT(ORD:Reference)
                       PROJECT(ORD:ShipTo)
                       PROJECT(ORD:ShipAddress)
                       PROJECT(ORD:ShipCity)
                       PROJECT(ORD:ShipState)
                       PROJECT(ORD:ShipZip)
                     END
Queue:Browse:2       QUEUE                            !Queue declaration for browse/combo box using ?Browse:2
ORD:CustNo             LIKE(ORD:CustNo)               !List box control field - type derived from field
ORD:OrderNo            LIKE(ORD:OrderNo)              !List box control field - type derived from field
ORD:OrderDate          LIKE(ORD:OrderDate)            !List box control field - type derived from field
ORD:Reference          LIKE(ORD:Reference)            !List box control field - type derived from field
ORD:ShipTo             LIKE(ORD:ShipTo)               !List box control field - type derived from field
ORD:ShipAddress        LIKE(ORD:ShipAddress)          !List box control field - type derived from field
ORD:ShipCity           LIKE(ORD:ShipCity)             !List box control field - type derived from field
ORD:ShipState          LIKE(ORD:ShipState)            !List box control field - type derived from field
ORD:ShipZip            LIKE(ORD:ShipZip)              !List box control field - type derived from field
Mark                   BYTE                           !Entry's marked status
ViewPosition           STRING(1024)                   !Entry's view position
                     END
History::CUST:Record LIKE(CUST:RECORD),THREAD
QuickWindow          WINDOW('Update the Customer File'),AT(,,208,154),FONT('MS Sans Serif',8,COLOR:Black,),IMM,HLP('UpdateCustomer'),SYSTEM,GRAY,RESIZE,MDI
                       SHEET,AT(4,4,200,128),USE(?CurrentTab)
                         TAB('General'),USE(?Tab:1)
                           PROMPT('Customer Number:'),AT(8,20),USE(?CUST:CustNo:Prompt)
                           STRING(@n05),AT(76,20,40,10),USE(CUST:CustNo)
                           PROMPT('Customer:'),AT(8,34),USE(?CUST:Name:Prompt)
                           ENTRY(@s30),AT(76,34,124,10),USE(CUST:Name),LEFT,MSG('Customer Name'),REQ
                           PROMPT('Address:'),AT(8,48),USE(?CUST:Address:Prompt)
                           ENTRY(@s30),AT(76,48,124,10),USE(CUST:Address),LEFT,MSG('Customer Address Line 1')
                           PROMPT('City:'),AT(8,62),USE(?CUST:City:Prompt)
                           ENTRY(@s20),AT(76,62,84,10),USE(CUST:City),MSG('Customer City'),INS
                           PROMPT('State:'),AT(8,76),USE(?CUST:State:Prompt)
                           ENTRY(@s2),AT(76,76,40,10),USE(CUST:State),LEFT,MSG('Customer State'),UPR
                           PROMPT('Zip Code:'),AT(8,90),USE(?CUST:Zip:Prompt)
                           ENTRY(@n05),AT(76,90,40,10),USE(CUST:Zip),LEFT,MSG('Customer Zip Code')
                           PROMPT('Telephone:'),AT(8,104),USE(?CUST:Phone:Prompt)
                           ENTRY(@P(###) ###-####P),AT(76,104,64,10),USE(CUST:Phone),LEFT,MSG('Telephone Number')
                           PROMPT('Contact Person:'),AT(8,118),USE(?CUST:Contact:Prompt)
                           ENTRY(@s20),AT(76,118,84,10),USE(CUST:Contact),LEFT,MSG('Contact Person')
                         END
                         TAB('Orders'),USE(?Tab:2)
                           LIST,AT(8,20,192,108),USE(?Browse:2),IMM,HVSCROLL,MSG('Browsing Records'),FORMAT('28R(2)|M~Cust~C(0)@n06@36R(2)|M~Order No~C(0)@n06@80R(2)|M~Order date~C(0)@d1@80' &|
   'L(2)|M~Reference~L(2)@s24@80L(2)|M~Ship to~L(2)@s32@80L(2)|M~Address~L(2)@s32@80' &|
   'L(2)|M~City~L(2)@s22@12L(2)|M~ST~L(2)@s2@24R(2)|M~Zip~C(0)@n05@'),FROM(Queue:Browse:2)
                           BUTTON('&Insert'),AT(57,96,45,14),USE(?Insert:3),HIDE
                           BUTTON('&Change'),AT(106,96,45,14),USE(?Change:3),HIDE
                           BUTTON('&Delete'),AT(155,96,45,14),USE(?Delete:3),HIDE
                         END
                       END
                       BUTTON('OK'),AT(110,136,45,14),USE(?OK),DEFAULT
                       BUTTON('Cancel'),AT(159,136,45,14),USE(?Cancel)
                       BUTTON('Help'),AT(159,4,45,14),USE(?Help),HIDE,STD(STD:Help)
                     END
WebWindow            CLASS(WebWindowClass)
                     END
IC:CurControl        &WebControlClass                      ! Temporary control pointer
IC:CurFrame          &WebFrameClass

ThisWindow           CLASS(WindowManager)
Ask                    PROCEDURE(),DERIVED                 ! Method added to host embed code
Init                   PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
Kill                   PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
Run                    PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
Run                    PROCEDURE(USHORT Number,BYTE Request),BYTE,PROC,DERIVED ! Method added to host embed code
TakeAccepted           PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
TakeEvent              PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
                     END

Toolbar              ToolbarClass
BRW2                 CLASS(BrowseClass)                    ! Browse using ?Browse:2
Q                      &Queue:Browse:2                !Reference to browse queue
Fetch                  PROCEDURE(BYTE Direction),DERIVED   ! Method added to host embed code
Init                   PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM) ! Method added to host embed code
                     END

BRW2::Sort0:Locator  StepLocatorClass                      ! Default Locator
BRW2::Sort0:StepClass StepLongClass                        ! Default Step Manager
ToolbarForm          ToolbarUpdateClass                    ! Form Toolbar Manager
Resizer              CLASS(WindowResizeClass)
Init                   PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False) ! Method added to host embed code
                     END

CurCtrlFeq          LONG
FieldColorQueue     QUEUE
Feq                   LONG
OldColor              LONG
                    END

  CODE
  GlobalResponse = ThisWindow.Run()                        ! Opens the window and starts an Accept Loop

!---------------------------------------------------------------------------
DefineListboxStyle ROUTINE
!|
!| This routine create all the styles to be shared in this window
!| It`s called after the window open
!|
!---------------------------------------------------------------------------

ThisWindow.Ask PROCEDURE

  CODE
  CASE SELF.Request                                        ! Configure the action message text
  OF ViewRecord
    ActionMessage = 'View Record'
  OF InsertRecord
    ActionMessage = 'Adding a Customer Record'
  OF ChangeRecord
    ActionMessage = 'Changing a Customer Record'
  END
  QuickWindow{Prop:Text} = ActionMessage                   ! Display status message in title bar
  PARENT.Ask


ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('UpdateCustomer')
  SELF.Request = GlobalRequest                             ! Store the incoming request
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?CUST:CustNo:Prompt
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors                              ! Set this windows ErrorManager to the global ErrorManager
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)                                     ! Clear GlobalRequest after storing locally
  CLEAR(GlobalResponse)
  SELF.HistoryKey = 734
  SELF.AddHistoryFile(CUST:Record,History::CUST:Record)
  SELF.AddHistoryField(?CUST:CustNo,1)
  SELF.AddHistoryField(?CUST:Name,2)
  SELF.AddHistoryField(?CUST:Address,3)
  SELF.AddHistoryField(?CUST:City,4)
  SELF.AddHistoryField(?CUST:State,5)
  SELF.AddHistoryField(?CUST:Zip,6)
  SELF.AddHistoryField(?CUST:Phone,7)
  SELF.AddHistoryField(?CUST:Contact,8)
  SELF.AddUpdateFile(Access:Customer)
  SELF.AddItem(?Cancel,RequestCancelled)                   ! Add the cancel control to the window manager
  Relate:Customer.SetOpenRelated()
  Relate:Customer.Open                                     ! File Customer used by this procedure, so make sure it's RelationManager is open
  Relate:State.Open                                        ! File State used by this procedure, so make sure it's RelationManager is open
  SELF.FilesOpened = True
  SELF.Primary &= Relate:Customer
  IF SELF.Request = ViewRecord AND NOT SELF.BatchProcessing ! Setup actions for ViewOnly Mode
    SELF.InsertAction = Insert:None
    SELF.DeleteAction = Delete:None
    SELF.ChangeAction = Change:None
    SELF.CancelAction = Cancel:Cancel
    SELF.OkControl = 0
  ELSE
    SELF.ChangeAction = Change:Caller                      ! Changes allowed
    SELF.OkControl = ?OK
    IF SELF.PrimeUpdate() THEN RETURN Level:Notify.
  END
  BRW2.Init(?Browse:2,Queue:Browse:2.ViewPosition,BRW2::View:Browse,Queue:Browse:2,Relate:Orders,SELF) ! Initialize the browse manager
  SELF.Open(QuickWindow)                                   ! Open window
  Do DefineListboxStyle
  !- Initialise the internet classes
  WebWindow.Init(WebServer, HtmlManager, QuickWindow{PROP:text} & ' (UpdateCustomer)')
  WebWindow.SetFormatOptions(2, 2, 6, 13)
  WebWindow.MenubarType = PROP:above
  WebWindow.CreateClose = CLOSE:Always
  WebWindow.SetPageBackground(12632256, 'Crumpled.gif')
  WebWindow.BorderWidth = 2
  WebWindow.SheetBorderWidth = 2
  WebWindow.OptionBorderWidth = 2
  WebWindow.GroupBorderWidth = 2
  WebWindow.CreateCaption = 1
  
  IC:CurControl &= WebWindow.AddControl(?Browse:2)
  IC:CurControl.SetQueue(Queue:Browse:2)
  IF (WebServer.Active)
    IC:CurFrame &= GetWebActiveFrame()
    IC:CurFrame.CopyControlsToWindow(WebWindow, TRUE, TRUE)
  END
  BRW2.Q &= Queue:Browse:2
  BRW2::Sort0:StepClass.Init(+ScrollSort:AllowAlpha)       ! Moveable thumb based upon ORD:OrderNo for sort order 1
  BRW2.AddSortOrder(BRW2::Sort0:StepClass,ORD:ByCustomer)  ! Add the sort order for ORD:ByCustomer for sort order 1
  BRW2.AddRange(ORD:CustNo,Relate:Orders,Relate:Customer)  ! Add file relationship range limit for sort order 1
  BRW2.AddLocator(BRW2::Sort0:Locator)                     ! Browse has a locator for sort order 1
  BRW2::Sort0:Locator.Init(,ORD:OrderNo,1,BRW2)            ! Initialize the browse locator using  using key: ORD:ByCustomer , ORD:OrderNo
  BRW2.AddField(ORD:CustNo,BRW2.Q.ORD:CustNo)              ! Field ORD:CustNo is a hot field or requires assignment from browse
  BRW2.AddField(ORD:OrderNo,BRW2.Q.ORD:OrderNo)            ! Field ORD:OrderNo is a hot field or requires assignment from browse
  BRW2.AddField(ORD:OrderDate,BRW2.Q.ORD:OrderDate)        ! Field ORD:OrderDate is a hot field or requires assignment from browse
  BRW2.AddField(ORD:Reference,BRW2.Q.ORD:Reference)        ! Field ORD:Reference is a hot field or requires assignment from browse
  BRW2.AddField(ORD:ShipTo,BRW2.Q.ORD:ShipTo)              ! Field ORD:ShipTo is a hot field or requires assignment from browse
  BRW2.AddField(ORD:ShipAddress,BRW2.Q.ORD:ShipAddress)    ! Field ORD:ShipAddress is a hot field or requires assignment from browse
  BRW2.AddField(ORD:ShipCity,BRW2.Q.ORD:ShipCity)          ! Field ORD:ShipCity is a hot field or requires assignment from browse
  BRW2.AddField(ORD:ShipState,BRW2.Q.ORD:ShipState)        ! Field ORD:ShipState is a hot field or requires assignment from browse
  BRW2.AddField(ORD:ShipZip,BRW2.Q.ORD:ShipZip)            ! Field ORD:ShipZip is a hot field or requires assignment from browse
  Resizer.Init(AppStrategy:Surface,Resize:SetMinSize)      ! Controls like list boxes will resize, whilst controls like buttons will move
  SELF.AddItem(Resizer)                                    ! Add resizer to window manager
  INIMgr.Fetch('UpdateCustomer',QuickWindow)               ! Restore window settings from non-volatile store
  Resizer.Resize                                           ! Reset required after window size altered by INI manager
  BRW2.AskProcedure = 2
  ToolBarForm.HelpButton=?Help
  SELF.AddItem(ToolbarForm)
  BRW2.AddToolbarTarget(Toolbar)                           ! Browse accepts toolbar control
  BRW2.ToolbarItem.HelpButton = ?Help
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:Customer.Close
    Relate:State.Close
  END
  IF SELF.Opened
    INIMgr.Update('UpdateCustomer',QuickWindow)            ! Save window data to non-volatile store
  END
  WebWindow.Kill
  IF (WebServer.Active)
    POST(EVENT:NewPage)
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.Run PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Run()
  IF SELF.Request = ViewRecord                             ! In View Only mode always signal RequestCancelled
    ReturnValue = RequestCancelled
  END
  RETURN ReturnValue


ThisWindow.Run PROCEDURE(USHORT Number,BYTE Request)

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Run(Number,Request)
  IF SELF.Request = ViewRecord
    ReturnValue = RequestCancelled                         ! Always return RequestCancelled if the form was opened in ViewRecord mode
  ELSE
    GlobalRequest = Request
    EXECUTE Number
      SelectState
      UpdateOrders
    END
    ReturnValue = GlobalResponse
  END
  RETURN ReturnValue


ThisWindow.TakeAccepted PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receive all EVENT:Accepted's
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
  ReturnValue = PARENT.TakeAccepted()
    CASE ACCEPTED()
    OF ?CUST:State
      ST:StateCode = CUST:State
      IF Access:State.TryFetch(ST:ByCode)
        IF SELF.Run(1,SelectRecord) = RequestCompleted
          CUST:State = ST:StateCode
        ELSE
          SELECT(?CUST:State)
          CYCLE
        END
      END
      ThisWindow.Reset(0)
      IF Access:Customer.TryValidateField(5)               ! Attempt to validate CUST:State in Customer
        SELECT(?CUST:State)
        QuickWindow{Prop:AcceptAll} = False
        CYCLE
      ELSE
        FieldColorQueue.Feq = ?CUST:State
        GET(FieldColorQueue, FieldColorQueue.Feq)
        IF ~ERRORCODE()
          ?CUST:State{Prop:FontColor} = FieldColorQueue.OldColor
          DELETE(FieldColorQueue)
        END
      END
    OF ?OK
      ThisWindow.Update
      IF SELF.Request = ViewRecord AND NOT SELF.BatchProcessing THEN
         POST(EVENT:CloseWindow)
      END
    END
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


ThisWindow.TakeEvent PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receives all events
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
    IF WebWindow.TakeEvent()
      BREAK
    END
  ReturnValue = PARENT.TakeEvent()
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


BRW2.Fetch PROCEDURE(BYTE Direction)

GreenBarIndex   LONG
  CODE
  PARENT.Fetch(Direction)


BRW2.Init PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)

  CODE
  PARENT.Init(ListBox,Posit,V,Q,RM,WM)
  IF WM.Request <> ViewRecord                              ! If called for anything other than ViewMode, make the insert, change & delete controls available
    SELF.InsertControl=?Insert:3
    SELF.ChangeControl=?Change:3
    SELF.DeleteControl=?Delete:3
  END


Resizer.Init PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)


  CODE
  PARENT.Init(AppStrategy,SetWindowMinSize,SetWindowMaxSize)
  SELF.SetParentDefaults()                                 ! Calculate default control parent-child relationships based upon their positions on the window


