

   MEMBER('WEBORDER.clw')                                  ! This is a MEMBER module


   INCLUDE('ABBROWSE.INC'),ONCE
   INCLUDE('ABPOPUP.INC'),ONCE
   INCLUDE('ABRESIZE.INC'),ONCE
   INCLUDE('ABTOOLBA.INC'),ONCE
   INCLUDE('ABWINDOW.INC'),ONCE

                     MAP
                       INCLUDE('WEBOR007.INC'),ONCE        !Local module procedure declarations
                     END



SelectState PROCEDURE                                      ! Generated from procedure template - Window

CurrentTab           STRING(80)                            !
FilesOpened          BYTE                                  !
BRW1::View:Browse    VIEW(State)
                       PROJECT(ST:StateCode)
                       PROJECT(ST:StateName)
                     END
Queue:Browse:1       QUEUE                            !Queue declaration for browse/combo box using ?Browse:1
ST:StateCode           LIKE(ST:StateCode)             !List box control field - type derived from field
ST:StateName           LIKE(ST:StateName)             !List box control field - type derived from field
Mark                   BYTE                           !Entry's marked status
ViewPosition           STRING(1024)                   !Entry's view position
                     END
QuickWindow          WINDOW('Select a State Record'),AT(,,158,170),FONT('MS Sans Serif',8,COLOR:Black,),IMM,HLP('SelectState'),SYSTEM,GRAY,RESIZE,MDI
                       LIST,AT(8,20,142,142),USE(?Browse:1),IMM,HVSCROLL,MSG('Browsing Records'),FORMAT('12L(2)|M~ST~L(2)@s2@80L(2)|M~State Name~L(2)@s20@'),FROM(Queue:Browse:1)
                       BUTTON('&Select'),AT(105,166,45,14),USE(?Select:2),HIDE
                       SHEET,AT(4,4,150,162),USE(?CurrentTab)
                         TAB('By State Code'),USE(?Tab:2)
                         END
                         TAB('By State Name'),USE(?Tab:3)
                         END
                       END
                       BUTTON('Close'),AT(60,152,45,14),USE(?Close),HIDE
                       BUTTON('Help'),AT(109,152,45,14),USE(?Help),HIDE,STD(STD:Help)
                     END
WebWindow            CLASS(WebWindowClass)
                     END
IC:CurControl        &WebControlClass                      ! Temporary control pointer
IC:CurFrame          &WebFrameClass

ThisWindow           CLASS(WindowManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
Kill                   PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
TakeEvent              PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
                     END

Toolbar              ToolbarClass
BRW1                 CLASS(BrowseClass)                    ! Browse using ?Browse:1
Q                      &Queue:Browse:1                !Reference to browse queue
Fetch                  PROCEDURE(BYTE Direction),DERIVED   ! Method added to host embed code
Init                   PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM) ! Method added to host embed code
ResetSort              PROCEDURE(BYTE Force),BYTE,PROC,DERIVED ! Method added to host embed code
                     END

BRW1::Sort0:Locator  StepLocatorClass                      ! Default Locator
BRW1::Sort1:Locator  StepLocatorClass                      ! Conditional Locator - CHOICE(?CurrentTab) = 2
BRW1::Sort0:StepClass StepStringClass                      ! Default Step Manager
BRW1::Sort1:StepClass StepStringClass                      ! Conditional Step Manager - CHOICE(?CurrentTab) = 2
Resizer              CLASS(WindowResizeClass)
Init                   PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False) ! Method added to host embed code
                     END


  CODE
  GlobalResponse = ThisWindow.Run()                        ! Opens the window and starts an Accept Loop

!---------------------------------------------------------------------------
DefineListboxStyle ROUTINE
!|
!| This routine create all the styles to be shared in this window
!| It`s called after the window open
!|
!---------------------------------------------------------------------------

ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('SelectState')
  SELF.Request = GlobalRequest                             ! Store the incoming request
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?Browse:1
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors                              ! Set this windows ErrorManager to the global ErrorManager
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)                                     ! Clear GlobalRequest after storing locally
  CLEAR(GlobalResponse)
  IF SELF.Request = SelectRecord
     SELF.AddItem(?Close,RequestCancelled)                 ! Add the close control to the window manger
  ELSE
     SELF.AddItem(?Close,RequestCompleted)                 ! Add the close control to the window manger
  END
  Relate:State.Open                                        ! File State used by this procedure, so make sure it's RelationManager is open
  SELF.FilesOpened = True
  BRW1.Init(?Browse:1,Queue:Browse:1.ViewPosition,BRW1::View:Browse,Queue:Browse:1,Relate:State,SELF) ! Initialize the browse manager
  SELF.Open(QuickWindow)                                   ! Open window
  Do DefineListboxStyle
  !- Initialise the internet classes
  WebWindow.Init(WebServer, HtmlManager, QuickWindow{PROP:text} & ' (SelectState)')
  WebWindow.SetFormatOptions(2, 2, 6, 13)
  WebWindow.MenubarType = PROP:above
  WebWindow.CreateClose = CLOSE:Always
  WebWindow.SetPageBackground(12632256, 'Crumpled.gif')
  WebWindow.BorderWidth = 2
  WebWindow.SheetBorderWidth = 2
  WebWindow.OptionBorderWidth = 2
  WebWindow.GroupBorderWidth = 2
  WebWindow.CreateCaption = 1
  
  IC:CurControl &= WebWindow.AddControl(?Browse:1)
  IC:CurControl.SetQueue(Queue:Browse:1)
  
  IC:CurControl &= WebWindow.AddControl(?CurrentTab)
  IC:CurControl.SetEventAction(EVENT:Accepted, Update:Partial)
  IF (WebServer.Active)
    IC:CurFrame &= GetWebActiveFrame()
    IC:CurFrame.CopyControlsToWindow(WebWindow, TRUE, TRUE)
  END
  BRW1.Q &= Queue:Browse:1
  BRW1::Sort1:StepClass.Init(+ScrollSort:AllowAlpha,ScrollBy:Runtime) ! Moveable thumb based upon ST:StateName for sort order 1
  BRW1.AddSortOrder(BRW1::Sort1:StepClass,ST:ByState)      ! Add the sort order for ST:ByState for sort order 1
  BRW1.AddLocator(BRW1::Sort1:Locator)                     ! Browse has a locator for sort order 1
  BRW1::Sort1:Locator.Init(,ST:StateName,1,BRW1)           ! Initialize the browse locator using  using key: ST:ByState , ST:StateName
  BRW1::Sort0:StepClass.Init(+ScrollSort:AllowAlpha,ScrollBy:Runtime) ! Moveable thumb based upon ST:StateCode for sort order 2
  BRW1.AddSortOrder(BRW1::Sort0:StepClass,ST:ByCode)       ! Add the sort order for ST:ByCode for sort order 2
  BRW1.AddLocator(BRW1::Sort0:Locator)                     ! Browse has a locator for sort order 2
  BRW1::Sort0:Locator.Init(,ST:StateCode,1,BRW1)           ! Initialize the browse locator using  using key: ST:ByCode , ST:StateCode
  BRW1.AddField(ST:StateCode,BRW1.Q.ST:StateCode)          ! Field ST:StateCode is a hot field or requires assignment from browse
  BRW1.AddField(ST:StateName,BRW1.Q.ST:StateName)          ! Field ST:StateName is a hot field or requires assignment from browse
  Resizer.Init(AppStrategy:Surface,Resize:SetMinSize)      ! Controls like list boxes will resize, whilst controls like buttons will move
  SELF.AddItem(Resizer)                                    ! Add resizer to window manager
  INIMgr.Fetch('SelectState',QuickWindow)                  ! Restore window settings from non-volatile store
  Resizer.Resize                                           ! Reset required after window size altered by INI manager
  BRW1.AddToolbarTarget(Toolbar)                           ! Browse accepts toolbar control
  BRW1.ToolbarItem.HelpButton = ?Help
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:State.Close
  END
  IF SELF.Opened
    INIMgr.Update('SelectState',QuickWindow)               ! Save window data to non-volatile store
  END
  WebWindow.Kill
  IF (WebServer.Active)
    POST(EVENT:NewPage)
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.TakeEvent PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receives all events
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
    IF WebWindow.TakeEvent()
      BREAK
    END
  ReturnValue = PARENT.TakeEvent()
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


BRW1.Fetch PROCEDURE(BYTE Direction)

GreenBarIndex   LONG
  CODE
  PARENT.Fetch(Direction)


BRW1.Init PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)

  CODE
  SELF.SelectControl = ?Select:2
  SELF.HideSelect = 1                                      ! Hide the select button when disabled
  PARENT.Init(ListBox,Posit,V,Q,RM,WM)


BRW1.ResetSort PROCEDURE(BYTE Force)

ReturnValue          BYTE,AUTO

  CODE
  IF CHOICE(?CurrentTab) = 2
    RETURN SELF.SetSort(1,Force)
  ELSE
    RETURN SELF.SetSort(2,Force)
  END
  ReturnValue = PARENT.ResetSort(Force)
  RETURN ReturnValue


Resizer.Init PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)


  CODE
  PARENT.Init(AppStrategy,SetWindowMinSize,SetWindowMaxSize)
  SELF.SetParentDefaults()                                 ! Calculate default control parent-child relationships based upon their positions on the window


