

   MEMBER('WEBORDER.clw')                                  ! This is a MEMBER module


   INCLUDE('ABRESIZE.INC'),ONCE
   INCLUDE('ABTOOLBA.INC'),ONCE
   INCLUDE('ABWINDOW.INC'),ONCE

                     MAP
                       INCLUDE('WEBOR008.INC'),ONCE        !Local module procedure declarations
                       INCLUDE('WEBOR009.INC'),ONCE        !Req'd for module callout resolution
                     END



UpdateItems PROCEDURE                                      ! Generated from procedure template - Window

CurrentTab           STRING(80)                            !
FilesOpened          BYTE                                  !
ActionMessage        CSTRING(40)                           !
History::ITEM:Record LIKE(ITEM:RECORD),THREAD
QuickWindow          WINDOW('Update the Items File'),AT(,,151,126),FONT('MS Sans Serif',8,COLOR:Black,),IMM,HLP('UpdateItems'),SYSTEM,GRAY,RESIZE,MDI
                       SHEET,AT(4,4,143,100),USE(?CurrentTab)
                         TAB('General'),USE(?Tab:1)
                           PROMPT('Customer No:'),AT(8,20),USE(?ITEM:CustNo:Prompt)
                           STRING(@n05),AT(64,20,40,10),USE(ITEM:CustNo)
                           PROMPT('Order Number'),AT(8,34),USE(?ITEM:OrderNo:Prompt)
                           STRING(@n06),AT(64,34,40,10),USE(ITEM:OrderNo)
                           PROMPT('Line No:'),AT(8,48),USE(?ITEM:LineNo:Prompt)
                           STRING(@n04),AT(64,48,40,10),USE(ITEM:LineNo)
                           PROMPT('Product Code:'),AT(8,62),USE(?ITEM:ProdCode:Prompt)
                           ENTRY(@n05),AT(64,62,40,10),USE(ITEM:ProdCode),RIGHT,MSG('Item Number'),INS
                           PROMPT('Quantity:'),AT(8,76),USE(?ITEM:Quantity:Prompt)
                           SPIN(@n6),AT(64,76,43,10),USE(ITEM:Quantity),RIGHT,MSG('Quantity Ordered'),INS,RANGE(1,999990)
                           PROMPT('Unit Price:'),AT(8,90),USE(?ITEM:Price:Prompt)
                           ENTRY(@n10.2),AT(64,90,44,10),USE(ITEM:Price),DECIMAL(12),MSG('Price per Unit')
                         END
                       END
                       BUTTON('OK'),AT(53,108,45,14),USE(?OK),DEFAULT
                       BUTTON('Cancel'),AT(102,108,45,14),USE(?Cancel)
                       BUTTON('Help'),AT(102,4,45,14),USE(?Help),HIDE,STD(STD:Help)
                     END
WebWindow            CLASS(WebWindowClass)
                     END
IC:CurControl        &WebControlClass                      ! Temporary control pointer
IC:CurFrame          &WebFrameClass

ThisWindow           CLASS(WindowManager)
Ask                    PROCEDURE(),DERIVED                 ! Method added to host embed code
Init                   PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
Kill                   PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
Run                    PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
Run                    PROCEDURE(USHORT Number,BYTE Request),BYTE,PROC,DERIVED ! Method added to host embed code
TakeAccepted           PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
TakeEvent              PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
                     END

Toolbar              ToolbarClass
ToolbarForm          ToolbarUpdateClass                    ! Form Toolbar Manager
Resizer              CLASS(WindowResizeClass)
Init                   PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False) ! Method added to host embed code
                     END

CurCtrlFeq          LONG
FieldColorQueue     QUEUE
Feq                   LONG
OldColor              LONG
                    END

  CODE
  GlobalResponse = ThisWindow.Run()                        ! Opens the window and starts an Accept Loop

!---------------------------------------------------------------------------
DefineListboxStyle ROUTINE
!|
!| This routine create all the styles to be shared in this window
!| It`s called after the window open
!|
!---------------------------------------------------------------------------

ThisWindow.Ask PROCEDURE

  CODE
  CASE SELF.Request                                        ! Configure the action message text
  OF ViewRecord
    ActionMessage = 'View Record'
  OF InsertRecord
    ActionMessage = 'Adding a Items Record'
  OF ChangeRecord
    ActionMessage = 'Changing a Items Record'
  END
  QuickWindow{Prop:Text} = ActionMessage                   ! Display status message in title bar
  PARENT.Ask


ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('UpdateItems')
  SELF.Request = GlobalRequest                             ! Store the incoming request
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?ITEM:CustNo:Prompt
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors                              ! Set this windows ErrorManager to the global ErrorManager
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)                                     ! Clear GlobalRequest after storing locally
  CLEAR(GlobalResponse)
  SELF.HistoryKey = 734
  SELF.AddHistoryFile(ITEM:Record,History::ITEM:Record)
  SELF.AddHistoryField(?ITEM:CustNo,1)
  SELF.AddHistoryField(?ITEM:OrderNo,2)
  SELF.AddHistoryField(?ITEM:LineNo,3)
  SELF.AddHistoryField(?ITEM:ProdCode,4)
  SELF.AddHistoryField(?ITEM:Quantity,5)
  SELF.AddHistoryField(?ITEM:Price,6)
  SELF.AddUpdateFile(Access:Items)
  SELF.AddItem(?Cancel,RequestCancelled)                   ! Add the cancel control to the window manager
  Relate:Items.SetOpenRelated()
  Relate:Items.Open                                        ! File Items used by this procedure, so make sure it's RelationManager is open
  Access:Product.UseFile                                   ! File referenced in 'Other Files' so need to inform it's FileManager
  SELF.FilesOpened = True
  SELF.Primary &= Relate:Items
  IF SELF.Request = ViewRecord AND NOT SELF.BatchProcessing ! Setup actions for ViewOnly Mode
    SELF.InsertAction = Insert:None
    SELF.DeleteAction = Delete:None
    SELF.ChangeAction = Change:None
    SELF.CancelAction = Cancel:Cancel
    SELF.OkControl = 0
  ELSE
    SELF.ChangeAction = Change:Caller                      ! Changes allowed
    SELF.OkControl = ?OK
    IF SELF.PrimeUpdate() THEN RETURN Level:Notify.
  END
  SELF.Open(QuickWindow)                                   ! Open window
  Do DefineListboxStyle
  !- Initialise the internet classes
  WebWindow.Init(WebServer, HtmlManager, QuickWindow{PROP:text} & ' (UpdateItems)')
  WebWindow.SetFormatOptions(2, 2, 6, 13)
  WebWindow.MenubarType = PROP:above
  WebWindow.CreateClose = CLOSE:Always
  WebWindow.SetPageBackground(12632256, 'Crumpled.gif')
  WebWindow.BorderWidth = 2
  WebWindow.SheetBorderWidth = 2
  WebWindow.OptionBorderWidth = 2
  WebWindow.GroupBorderWidth = 2
  WebWindow.CreateCaption = 1
  IF (WebServer.Active)
    IC:CurFrame &= GetWebActiveFrame()
    IC:CurFrame.CopyControlsToWindow(WebWindow, TRUE, TRUE)
  END
  Resizer.Init(AppStrategy:Surface,Resize:SetMinSize)      ! Controls like list boxes will resize, whilst controls like buttons will move
  SELF.AddItem(Resizer)                                    ! Add resizer to window manager
  INIMgr.Fetch('UpdateItems',QuickWindow)                  ! Restore window settings from non-volatile store
  Resizer.Resize                                           ! Reset required after window size altered by INI manager
  ToolBarForm.HelpButton=?Help
  SELF.AddItem(ToolbarForm)
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:Items.Close
  END
  IF SELF.Opened
    INIMgr.Update('UpdateItems',QuickWindow)               ! Save window data to non-volatile store
  END
  WebWindow.Kill
  IF (WebServer.Active)
    POST(EVENT:NewPage)
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.Run PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Run()
  IF SELF.Request = ViewRecord                             ! In View Only mode always signal RequestCancelled
    ReturnValue = RequestCancelled
  END
  RETURN ReturnValue


ThisWindow.Run PROCEDURE(USHORT Number,BYTE Request)

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Run(Number,Request)
  IF SELF.Request = ViewRecord
    ReturnValue = RequestCancelled                         ! Always return RequestCancelled if the form was opened in ViewRecord mode
  ELSE
    GlobalRequest = Request
    SelectProduct
    ReturnValue = GlobalResponse
  END
  RETURN ReturnValue


ThisWindow.TakeAccepted PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receive all EVENT:Accepted's
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
  ReturnValue = PARENT.TakeAccepted()
    CASE ACCEPTED()
    OF ?ITEM:ProdCode
      PROD:ProdCode = ITEM:ProdCode
      IF Access:Product.TryFetch(PROD:ByCode)
        IF SELF.Run(1,SelectRecord) = RequestCompleted
          ITEM:ProdCode = PROD:ProdCode
        ELSE
          SELECT(?ITEM:ProdCode)
          CYCLE
        END
      END
      ThisWindow.Reset(0)
      IF Access:Items.TryValidateField(4)                  ! Attempt to validate ITEM:ProdCode in Items
        SELECT(?ITEM:ProdCode)
        QuickWindow{Prop:AcceptAll} = False
        CYCLE
      ELSE
        FieldColorQueue.Feq = ?ITEM:ProdCode
        GET(FieldColorQueue, FieldColorQueue.Feq)
        IF ~ERRORCODE()
          ?ITEM:ProdCode{Prop:FontColor} = FieldColorQueue.OldColor
          DELETE(FieldColorQueue)
        END
      END
    OF ?ITEM:Quantity
      IF Access:Items.TryValidateField(5)                  ! Attempt to validate ITEM:Quantity in Items
        SELECT(?ITEM:Quantity)
        QuickWindow{Prop:AcceptAll} = False
        CYCLE
      ELSE
        FieldColorQueue.Feq = ?ITEM:Quantity
        GET(FieldColorQueue, FieldColorQueue.Feq)
        IF ~ERRORCODE()
          ?ITEM:Quantity{Prop:FontColor} = FieldColorQueue.OldColor
          DELETE(FieldColorQueue)
        END
      END
    OF ?OK
      ThisWindow.Update
      IF SELF.Request = ViewRecord AND NOT SELF.BatchProcessing THEN
         POST(EVENT:CloseWindow)
      END
    END
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


ThisWindow.TakeEvent PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receives all events
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
    IF WebWindow.TakeEvent()
      BREAK
    END
  ReturnValue = PARENT.TakeEvent()
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


Resizer.Init PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)


  CODE
  PARENT.Init(AppStrategy,SetWindowMinSize,SetWindowMaxSize)
  SELF.SetParentDefaults()                                 ! Calculate default control parent-child relationships based upon their positions on the window


