  MEMBER('WEBORDER.clw')

  INCLUDE('ABFILE.INC'),ONCE

  MAP
WEBORBC0:DctInit    PROCEDURE
WEBORBC0:DctKill    PROCEDURE
WEBORBC0:FilesInit  PROCEDURE
  END

Hide:Access:Customer CLASS(FileManager),TYPE               ! FileManager for Customer
Init                   PROCEDURE(),DERIVED                 ! Method added to host embed code
Kill                   PROCEDURE(),DERIVED                 ! Method added to host embed code
UseFile                PROCEDURE(BYTE UseType = UseType:Uses),BYTE,PROC,DERIVED ! Method added to host embed code
ValidateFieldServer    PROCEDURE(UNSIGNED Id,BYTE HandleErrors),BYTE,PROC,DERIVED ! Method added to host embed code
                     END


Hide:Relate:Customer CLASS(RelationManager),TYPE           ! RelationManager for Customer
Init                   PROCEDURE
DeferedAddRelations    PROCEDURE(),DERIVED                 ! Method added to host embed code
Kill                   PROCEDURE(),DERIVED                 ! Method added to host embed code
                     END

Hide:Access:Items    CLASS(FileManager),TYPE               ! FileManager for Items
Init                   PROCEDURE(),DERIVED                 ! Method added to host embed code
Kill                   PROCEDURE(),DERIVED                 ! Method added to host embed code
PrimeFields            PROCEDURE(),PROC,DERIVED            ! Method added to host embed code
UseFile                PROCEDURE(BYTE UseType = UseType:Uses),BYTE,PROC,DERIVED ! Method added to host embed code
ValidateFieldServer    PROCEDURE(UNSIGNED Id,BYTE HandleErrors),BYTE,PROC,DERIVED ! Method added to host embed code
                     END


Hide:Relate:Items    CLASS(RelationManager),TYPE           ! RelationManager for Items
Init                   PROCEDURE
DeferedAddRelations    PROCEDURE(),DERIVED                 ! Method added to host embed code
Kill                   PROCEDURE(),DERIVED                 ! Method added to host embed code
                     END

Hide:Access:Orders   CLASS(FileManager),TYPE               ! FileManager for Orders
Init                   PROCEDURE(),DERIVED                 ! Method added to host embed code
Kill                   PROCEDURE(),DERIVED                 ! Method added to host embed code
PrimeFields            PROCEDURE(),PROC,DERIVED            ! Method added to host embed code
UseFile                PROCEDURE(BYTE UseType = UseType:Uses),BYTE,PROC,DERIVED ! Method added to host embed code
ValidateFieldServer    PROCEDURE(UNSIGNED Id,BYTE HandleErrors),BYTE,PROC,DERIVED ! Method added to host embed code
                     END


Hide:Relate:Orders   CLASS(RelationManager),TYPE           ! RelationManager for Orders
Init                   PROCEDURE
DeferedAddRelations    PROCEDURE(),DERIVED                 ! Method added to host embed code
Kill                   PROCEDURE(),DERIVED                 ! Method added to host embed code
                     END

Hide:Access:Product  CLASS(FileManager),TYPE               ! FileManager for Product
Init                   PROCEDURE(),DERIVED                 ! Method added to host embed code
Kill                   PROCEDURE(),DERIVED                 ! Method added to host embed code
UseFile                PROCEDURE(BYTE UseType = UseType:Uses),BYTE,PROC,DERIVED ! Method added to host embed code
                     END


Hide:Relate:Product  CLASS(RelationManager),TYPE           ! RelationManager for Product
Init                   PROCEDURE
DeferedAddRelations    PROCEDURE(),DERIVED                 ! Method added to host embed code
Kill                   PROCEDURE(),DERIVED                 ! Method added to host embed code
                     END

Hide:Access:State    CLASS(FileManager),TYPE               ! FileManager for State
Init                   PROCEDURE(),DERIVED                 ! Method added to host embed code
Kill                   PROCEDURE(),DERIVED                 ! Method added to host embed code
UseFile                PROCEDURE(BYTE UseType = UseType:Uses),BYTE,PROC,DERIVED ! Method added to host embed code
                     END


Hide:Relate:State    CLASS(RelationManager),TYPE           ! RelationManager for State
Init                   PROCEDURE
DeferedAddRelations    PROCEDURE(),DERIVED                 ! Method added to host embed code
Kill                   PROCEDURE(),DERIVED                 ! Method added to host embed code
                     END


_Hide:Access:Customer &Hide:Access:Customer,AUTO,THREAD
_Hide:Relate:Customer &Hide:Relate:Customer,AUTO,THREAD
_Hide:Access:Items   &Hide:Access:Items,AUTO,THREAD
_Hide:Relate:Items   &Hide:Relate:Items,AUTO,THREAD
_Hide:Access:Orders  &Hide:Access:Orders,AUTO,THREAD
_Hide:Relate:Orders  &Hide:Relate:Orders,AUTO,THREAD
_Hide:Access:Product &Hide:Access:Product,AUTO,THREAD
_Hide:Relate:Product &Hide:Relate:Product,AUTO,THREAD
_Hide:Access:State   &Hide:Access:State,AUTO,THREAD
_Hide:Relate:State   &Hide:Relate:State,AUTO,THREAD


WEBORBC0:DctInit PROCEDURE
  CODE
  _Hide:Access:Customer &= NEW(Hide:Access:Customer)
  _Hide:Relate:Customer &= NEW(Hide:Relate:Customer)
  _Hide:Access:Items &= NEW(Hide:Access:Items)
  _Hide:Relate:Items &= NEW(Hide:Relate:Items)
  _Hide:Access:Orders &= NEW(Hide:Access:Orders)
  _Hide:Relate:Orders &= NEW(Hide:Relate:Orders)
  _Hide:Access:Product &= NEW(Hide:Access:Product)
  _Hide:Relate:Product &= NEW(Hide:Relate:Product)
  _Hide:Access:State &= NEW(Hide:Access:State)
  _Hide:Relate:State &= NEW(Hide:Relate:State)
  Relate:Customer &= _Hide:Relate:Customer
  Relate:Items &= _Hide:Relate:Items
  Relate:Orders &= _Hide:Relate:Orders
  Relate:Product &= _Hide:Relate:Product
  Relate:State &= _Hide:Relate:State


WEBORBC0:FilesInit PROCEDURE
  CODE
  _Hide:Relate:Customer.Init
  _Hide:Relate:Items.Init
  _Hide:Relate:Orders.Init
  _Hide:Relate:Product.Init
  _Hide:Relate:State.Init


WEBORBC0:DctKill PROCEDURE
  CODE
  _Hide:Relate:Customer.Kill
  DISPOSE(_Hide:Relate:Customer)
  _Hide:Relate:Items.Kill
  DISPOSE(_Hide:Relate:Items)
  _Hide:Relate:Orders.Kill
  DISPOSE(_Hide:Relate:Orders)
  _Hide:Relate:Product.Kill
  DISPOSE(_Hide:Relate:Product)
  _Hide:Relate:State.Kill
  DISPOSE(_Hide:Relate:State)


Hide:Relate:Customer.Init PROCEDURE
  CODE
  _Hide:Access:Customer.Init
  SELF.Init(Access:Customer,1)


Hide:Access:Customer.Init PROCEDURE

  CODE
  SELF.Initialized = False
  SELF.Buffer &= CUST:Record
  SELF.FileNameValue = 'Customer'
  SELF.SetErrors(GlobalErrors)
  SELF.File &= Customer
  PARENT.Init
  Access:Customer &= SELF


Hide:Access:Customer.Kill PROCEDURE

  CODE
  PARENT.Kill
  Access:Customer &= NULL                                  ! File manager has been destroyed to assign null, it is an error to reference this after this point


Hide:Access:Customer.UseFile PROCEDURE(BYTE UseType = UseType:Uses)

ReturnValue          BYTE,AUTO

  CODE
  IF UseType ~= UseType:Initialize
    SELF.UseFile(UseType:Initialize)                       !Recursive call to ensure initialization takes place
  END
  IF UseType = UseType:Initialize AND ~SELF.Initialized
    SELF.InUseFile = True
    SELF.Init(Customer,GlobalErrors)
    SELF.Create = 1
    SELF.LockRecover = 10
    SELF.AddKey(CUST:ByNumber,'By Customer Account Number',1)
    SELF.AddKey(CUST:ByName,'By Customer Name',0)
  END
                                                           !SELF.InUseFile will be set to False in PARENT
  ReturnValue = PARENT.UseFile(UseType)
  RETURN ReturnValue


Hide:Access:Customer.ValidateFieldServer PROCEDURE(UNSIGNED Id,BYTE HandleErrors)

ReturnValue          BYTE,AUTO

Save:State5        USHORT,AUTO
  CODE
  ReturnValue = PARENT.ValidateFieldServer(Id,HandleErrors)
  CASE Id
  OF 5
    GlobalErrors.SetField('Customer State')
    Save:State5 = Access:State.SaveFile()
    ST:StateCode = CUST:State
    ReturnValue = Access:State.TryFetch(ST:ByCode)
    IF ReturnValue <> Level:Benign
      IF HandleErrors                                      ! Display message if handling errors
        ReturnValue = GlobalErrors.ThrowMessage(Msg:FieldNotInFile,'State')
      END
    END
    Access:State.RestoreFile(Save:State5)
  END
  RETURN ReturnValue


Hide:Relate:Customer.DeferedAddRelations PROCEDURE

  CODE
  DO AddRelations_1
  
  PARENT.DeferedAddRelations

AddRelations_1 ROUTINE
  SELF.AddRelation(Relate:State,RI:None,RI:None,ST:ByCode)
  SELF.AddRelationLink(CUST:State,ST:StateCode)

  SELF.AddRelation(Relate:Orders,RI:None,RI:RESTRICT,ORD:ByCustomer)
  SELF.AddRelationLink(CUST:CustNo,ORD:CustNo)


Hide:Relate:Customer.Kill PROCEDURE

  CODE
  _Hide:Access:Customer.Kill                               ! Kill the file manager
  PARENT.Kill
  Relate:Customer &= NULL                                  ! Assign NULL to the RelationManager's FileManager reference, it is an error to reference this after this point
  DISPOSE(_Hide:Access:Customer)                           ! destroy the file manager


Hide:Relate:Items.Init PROCEDURE
  CODE
  _Hide:Access:Items.Init
  SELF.Init(Access:Items,1)


Hide:Access:Items.Init PROCEDURE

  CODE
  SELF.Initialized = False
  SELF.Buffer &= ITEM:Record
  SELF.FileNameValue = 'Items'
  SELF.SetErrors(GlobalErrors)
  SELF.File &= Items
  PARENT.Init
  Access:Items &= SELF


Hide:Access:Items.Kill PROCEDURE

  CODE
  PARENT.Kill
  Access:Items &= NULL                                     ! File manager has been destroyed to assign null, it is an error to reference this after this point


Hide:Access:Items.PrimeFields PROCEDURE

  CODE
  ITEM:CustNo = ORD:CustNo                                 ! Assign initial field value
  ITEM:Price = PROD:Price                                  ! Assign initial field value
  PARENT.PrimeFields


Hide:Access:Items.UseFile PROCEDURE(BYTE UseType = UseType:Uses)

ReturnValue          BYTE,AUTO

  CODE
  IF UseType ~= UseType:Initialize
    SELF.UseFile(UseType:Initialize)                       !Recursive call to ensure initialization takes place
  END
  IF UseType = UseType:Initialize AND ~SELF.Initialized
    SELF.InUseFile = True
    SELF.Init(Items,GlobalErrors)
    SELF.Create = 1
    SELF.LockRecover = 10
    SELF.AddKey(ITEM:AsEntered,'Line Number within Order Number',3)
    SELF.AddKey(ITEM:ByProduct,'Order Number within Product Code',0)
  END
                                                           !SELF.InUseFile will be set to False in PARENT
  ReturnValue = PARENT.UseFile(UseType)
  RETURN ReturnValue


Hide:Access:Items.ValidateFieldServer PROCEDURE(UNSIGNED Id,BYTE HandleErrors)

ReturnValue          BYTE,AUTO

Save:Product4      USHORT,AUTO
  CODE
  ReturnValue = PARENT.ValidateFieldServer(Id,HandleErrors)
  CASE Id
  OF 4
    GlobalErrors.SetField('Product Code')
    Save:Product4 = Access:Product.SaveFile()
    PROD:ProdCode = ITEM:ProdCode
    ReturnValue = Access:Product.TryFetch(PROD:ByCode)
    IF ReturnValue <> Level:Benign
      IF HandleErrors                                      ! Display message if handling errors
        ReturnValue = GlobalErrors.ThrowMessage(Msg:FieldNotInFile,'Product')
      END
    END
    Access:Product.RestoreFile(Save:Product4)
  OF 5
    GlobalErrors.SetField('Quantity Ordered')
    IF NOT INRANGE(ITEM:Quantity,1,999990)
      ReturnValue = Level:Notify
    END
    IF ReturnValue <> Level:Benign
      IF HandleErrors
        ReturnValue = GlobalErrors.ThrowMessage(Msg:FieldOutOfRange,'1 .. 999990')
      END
    END
  END
  RETURN ReturnValue


Hide:Relate:Items.DeferedAddRelations PROCEDURE

  CODE
  DO AddRelations_1
  
  PARENT.DeferedAddRelations

AddRelations_1 ROUTINE
  SELF.AddRelation(Relate:Orders)

  SELF.AddRelation(Relate:Product)


Hide:Relate:Items.Kill PROCEDURE

  CODE
  _Hide:Access:Items.Kill                                  ! Kill the file manager
  PARENT.Kill
  Relate:Items &= NULL                                     ! Assign NULL to the RelationManager's FileManager reference, it is an error to reference this after this point
  DISPOSE(_Hide:Access:Items)                              ! destroy the file manager


Hide:Relate:Orders.Init PROCEDURE
  CODE
  _Hide:Access:Orders.Init
  SELF.Init(Access:Orders,1)


Hide:Access:Orders.Init PROCEDURE

  CODE
  SELF.Initialized = False
  SELF.Buffer &= ORD:Record
  SELF.FileNameValue = 'Orders'
  SELF.SetErrors(GlobalErrors)
  SELF.File &= Orders
  PARENT.Init
  Access:Orders &= SELF


Hide:Access:Orders.Kill PROCEDURE

  CODE
  PARENT.Kill
  Access:Orders &= NULL                                    ! File manager has been destroyed to assign null, it is an error to reference this after this point


Hide:Access:Orders.PrimeFields PROCEDURE

  CODE
  ORD:CustNo = CUST:CustNo                                 ! Assign initial field value
  ORD:OrderDate = TODAY()                                  ! Assign initial field value
  ORD:Reference = CUST:Contact                             ! Assign initial field value
  ORD:ShipTo = CUST:Name                                   ! Assign initial field value
  ORD:ShipAddress = CUST:Address                           ! Assign initial field value
  ORD:ShipCity = CUST:City                                 ! Assign initial field value
  ORD:ShipState = CUST:State                               ! Assign initial field value
  ORD:ShipZip = CUST:Zip                                   ! Assign initial field value
  ORD:Shipped = 0                                          ! Assign initial field value
  ORD:Carrier = 'Mail'                                     ! Assign initial field value
  PARENT.PrimeFields


Hide:Access:Orders.UseFile PROCEDURE(BYTE UseType = UseType:Uses)

ReturnValue          BYTE,AUTO

  CODE
  IF UseType ~= UseType:Initialize
    SELF.UseFile(UseType:Initialize)                       !Recursive call to ensure initialization takes place
  END
  IF UseType = UseType:Initialize AND ~SELF.Initialized
    SELF.InUseFile = True
    SELF.Init(Orders,GlobalErrors)
    SELF.Create = 1
    SELF.LockRecover = 10
    SELF.AddKey(ORD:ByCustomer,'By Order Number within Customer Number',2)
  END
                                                           !SELF.InUseFile will be set to False in PARENT
  ReturnValue = PARENT.UseFile(UseType)
  RETURN ReturnValue


Hide:Access:Orders.ValidateFieldServer PROCEDURE(UNSIGNED Id,BYTE HandleErrors)

ReturnValue          BYTE,AUTO

Save:State8        USHORT,AUTO
  CODE
  ReturnValue = PARENT.ValidateFieldServer(Id,HandleErrors)
  CASE Id
  OF 8
    GlobalErrors.SetField('Ship To State')
    Save:State8 = Access:State.SaveFile()
    ST:StateCode = ORD:ShipState
    ReturnValue = Access:State.TryFetch(ST:ByCode)
    IF ReturnValue <> Level:Benign
      IF HandleErrors                                      ! Display message if handling errors
        ReturnValue = GlobalErrors.ThrowMessage(Msg:FieldNotInFile,'State')
      END
    END
    Access:State.RestoreFile(Save:State8)
  END
  RETURN ReturnValue


Hide:Relate:Orders.DeferedAddRelations PROCEDURE

  CODE
  DO AddRelations_1
  
  PARENT.DeferedAddRelations

AddRelations_1 ROUTINE
  SELF.AddRelation(Relate:Items,RI:None,RI:CASCADE,ITEM:AsEntered)
  SELF.AddRelationLink(ORD:CustNo,ITEM:CustNo)
  SELF.AddRelationLink(ORD:OrderNo,ITEM:OrderNo)

  SELF.AddRelation(Relate:State,RI:None,RI:None,ST:ByCode)
  SELF.AddRelationLink(ORD:ShipState,ST:StateCode)

  SELF.AddRelation(Relate:Customer)


Hide:Relate:Orders.Kill PROCEDURE

  CODE
  _Hide:Access:Orders.Kill                                 ! Kill the file manager
  PARENT.Kill
  Relate:Orders &= NULL                                    ! Assign NULL to the RelationManager's FileManager reference, it is an error to reference this after this point
  DISPOSE(_Hide:Access:Orders)                             ! destroy the file manager


Hide:Relate:Product.Init PROCEDURE
  CODE
  _Hide:Access:Product.Init
  SELF.Init(Access:Product,1)


Hide:Access:Product.Init PROCEDURE

  CODE
  SELF.Initialized = False
  SELF.Buffer &= PROD:Record
  SELF.FileNameValue = 'Product'
  SELF.SetErrors(GlobalErrors)
  SELF.File &= Product
  PARENT.Init
  Access:Product &= SELF


Hide:Access:Product.Kill PROCEDURE

  CODE
  PARENT.Kill
  Access:Product &= NULL                                   ! File manager has been destroyed to assign null, it is an error to reference this after this point


Hide:Access:Product.UseFile PROCEDURE(BYTE UseType = UseType:Uses)

ReturnValue          BYTE,AUTO

  CODE
  IF UseType ~= UseType:Initialize
    SELF.UseFile(UseType:Initialize)                       !Recursive call to ensure initialization takes place
  END
  IF UseType = UseType:Initialize AND ~SELF.Initialized
    SELF.InUseFile = True
    SELF.Init(Product,GlobalErrors)
    SELF.Create = 1
    SELF.LockRecover = 10
    SELF.AddKey(PROD:ByCode,'By Product Code',1)
    SELF.AddKey(PROD:ByDesc,'By Product Description',0)
  END
                                                           !SELF.InUseFile will be set to False in PARENT
  ReturnValue = PARENT.UseFile(UseType)
  RETURN ReturnValue


Hide:Relate:Product.DeferedAddRelations PROCEDURE

  CODE
  DO AddRelations_1
  
  PARENT.DeferedAddRelations

AddRelations_1 ROUTINE
  SELF.AddRelation(Relate:Items,RI:None,RI:RESTRICT,ITEM:ByProduct)
  SELF.AddRelationLink(PROD:ProdCode,ITEM:ProdCode)


Hide:Relate:Product.Kill PROCEDURE

  CODE
  _Hide:Access:Product.Kill                                ! Kill the file manager
  PARENT.Kill
  Relate:Product &= NULL                                   ! Assign NULL to the RelationManager's FileManager reference, it is an error to reference this after this point
  DISPOSE(_Hide:Access:Product)                            ! destroy the file manager


Hide:Relate:State.Init PROCEDURE
  CODE
  _Hide:Access:State.Init
  SELF.Init(Access:State,1)


Hide:Access:State.Init PROCEDURE

  CODE
  SELF.Initialized = False
  SELF.Buffer &= ST:Record
  SELF.FileNameValue = 'State'
  SELF.SetErrors(GlobalErrors)
  SELF.File &= State
  PARENT.Init
  Access:State &= SELF


Hide:Access:State.Kill PROCEDURE

  CODE
  PARENT.Kill
  Access:State &= NULL                                     ! File manager has been destroyed to assign null, it is an error to reference this after this point


Hide:Access:State.UseFile PROCEDURE(BYTE UseType = UseType:Uses)

ReturnValue          BYTE,AUTO

  CODE
  IF UseType ~= UseType:Initialize
    SELF.UseFile(UseType:Initialize)                       !Recursive call to ensure initialization takes place
  END
  IF UseType = UseType:Initialize AND ~SELF.Initialized
    SELF.InUseFile = True
    SELF.Init(State,GlobalErrors)
    SELF.Create = 1
    SELF.LockRecover = 10
    SELF.AddKey(ST:ByCode,'By State Code',0)
    SELF.AddKey(ST:ByState,'By State Name',0)
  END
                                                           !SELF.InUseFile will be set to False in PARENT
  ReturnValue = PARENT.UseFile(UseType)
  RETURN ReturnValue


Hide:Relate:State.DeferedAddRelations PROCEDURE

  CODE
  DO AddRelations_1
  
  PARENT.DeferedAddRelations

AddRelations_1 ROUTINE
  SELF.AddRelation(Relate:Customer)

  SELF.AddRelation(Relate:Orders)


Hide:Relate:State.Kill PROCEDURE

  CODE
  _Hide:Access:State.Kill                                  ! Kill the file manager
  PARENT.Kill
  Relate:State &= NULL                                     ! Assign NULL to the RelationManager's FileManager reference, it is an error to reference this after this point
  DISPOSE(_Hide:Access:State)                              ! destroy the file manager

