

   MEMBER('WebInv.clw')                                    ! This is a MEMBER module


   INCLUDE('ABBROWSE.INC'),ONCE
   INCLUDE('ABLPROPR.INC'),ONCE
   INCLUDE('ABLWINR.INC'),ONCE
   INCLUDE('ABPOPUP.INC'),ONCE
   INCLUDE('ABRESIZE.INC'),ONCE
   INCLUDE('ABTOOLBA.INC'),ONCE
   INCLUDE('ABWINDOW.INC'),ONCE
   INCLUDE('ablwman.inc'),ONCE

                     MAP
                       INCLUDE('WEBIN001.INC'),ONCE        !Local module procedure declarations
                       INCLUDE('WEBIN002.INC'),ONCE        !Req'd for module callout resolution
                     END


SelectStates PROCEDURE                                     ! Generated from procedure template - Window

CurrentTab           STRING(80)                            !
LocalRequest         LONG                                  !
FilesOpened          BYTE                                  !
BRW1::View:Browse    VIEW(States)
                       PROJECT(STA:StateCode)
                       PROJECT(STA:Name)
                     END
Queue:Browse:1       QUEUE                            !Queue declaration for browse/combo box using ?Browse:1
STA:StateCode          LIKE(STA:StateCode)            !List box control field - type derived from field
STA:Name               LIKE(STA:Name)                 !List box control field - type derived from field
Mark                   BYTE                           !Entry's marked status
ViewPosition           STRING(1024)                   !Entry's view position
                     END
QuickWindow          WINDOW('Select a State'),AT(,,143,139),FONT('MS Sans Serif',8,,),CENTER,IMM,ICON('USA.GIF'),HLP('~SelectaState'),SYSTEM,GRAY,RESIZE,MDI
                       SHEET,AT(2,0,138,138),USE(?CurrentTab),WIZARD
                         TAB('By: State Code'),USE(?Tab1)
                           STRING('Locator: Code'),AT(7,4,57,10),USE(?String1),FONT('MS Sans Serif',8,,FONT:bold)
                           ENTRY(@s2),AT(67,4,23,10),USE(STA:StateCode),MSG('Code for State'),UPR
                         END
                       END
                       LIST,AT(6,18,128,89),USE(?Browse:1),IMM,VSCROLL,MSG('Browsing Records'),FORMAT('39C|M~State Code~L(2)@s2@80L(1)|M~State Name~@s25@'),FROM(Queue:Browse:1)
                       BUTTON,AT(11,115,19,14),USE(?Select:2),FLAT,TIP('Select selected record'),ICON('Mark.gif')
                       BUTTON,AT(103,86,13,12),USE(?Help),HIDE,TIP('Get Help'),ICON(ICON:Help),STD(STD:Help)
                       BUTTON,AT(109,115,19,14),USE(?Close),FLAT,TIP('Cancel selection and exit browse'),ICON('EXITS.GIF')
                     END
Web:CurFrame         &WbFrameClass

ThisWindow           CLASS(WindowManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
Kill                   PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
                     END

Toolbar              ToolbarClass
WebWindowManager     WbWindowManagerClass
WebWindow            CLASS(WbWindowClass)
Init                   PROCEDURE()                         ! Method added to host embed code
                     END

Web:STA:StateCode    CLASS(WbControlHtmlProperties)        ! Web Control Manager for ?STA:StateCode
Init                   PROCEDURE(SIGNED Feq,SIGNED Container) ! Method added to host embed code
                     END

WebWindowProperty    CLASS(WbWindowHtmlProperties)
GetEmbedText           PROCEDURE(ASTRING embed),STRING,DERIVED ! Method added to host embed code
                     END

BRW1                 CLASS(BrowseClass)                    ! Browse using ?Browse:1
Q                      &Queue:Browse:1                !Reference to browse queue
Fetch                  PROCEDURE(BYTE Direction),DERIVED   ! Method added to host embed code
                     END

BRW1::Sort0:Locator  IncrementalLocatorClass               ! Default Locator
BRW1::Sort0:StepClass StepStringClass                      ! Default Step Manager
Resizer              CLASS(WindowResizeClass)
Init                   PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False) ! Method added to host embed code
                     END


  CODE
? DEBUGHOOK(States:Record)
  GlobalResponse = ThisWindow.Run()                        ! Opens the window and starts an Accept Loop

!---------------------------------------------------------------------------
DefineListboxStyle ROUTINE
!|
!| This routine create all the styles to be shared in this window
!| It`s called after the window open
!|
!---------------------------------------------------------------------------

ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('SelectStates')
  SELF.Request = GlobalRequest                             ! Store the incoming request
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?String1
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors                              ! Set this windows ErrorManager to the global ErrorManager
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)                                     ! Clear GlobalRequest after storing locally
  CLEAR(GlobalResponse)
  IF SELF.Request = SelectRecord
     SELF.AddItem(?Close,RequestCancelled)                 ! Add the close control to the window manger
  ELSE
     SELF.AddItem(?Close,RequestCompleted)                 ! Add the close control to the window manger
  END
  Relate:States.Open                                       ! File States used by this procedure, so make sure it's RelationManager is open
  SELF.FilesOpened = True
  BRW1.Init(?Browse:1,Queue:Browse:1.ViewPosition,BRW1::View:Browse,Queue:Browse:1,Relate:States,SELF) ! Initialize the browse manager
  SELF.Open(QuickWindow)                                   ! Open window
  Do DefineListboxStyle
  IF (WebServer.IsEnabled())
    WebWindow.Init()
    WebWindowManager.Init(WebServer, WebWindow.IPageCreator, WebWindow.IWebResponseProcessor, 0{PROP:text} & ' (SelectStates)')
    SELF.AddItem(WebWindow.WindowComponent)
    SELF.AddItem(WebWindowManager.WindowComponent)
  END
  QuickWindow{PROP:MinWidth}=173                           ! Restrict the minimum window width
  QuickWindow{PROP:MinHeight}=203                          ! Restrict the minimum window height
  Resizer.Init(AppStrategy:Spread)                         ! Controls will spread out as the window gets bigger
  SELF.AddItem(Resizer)                                    ! Add resizer to window manager
  BRW1.Q &= Queue:Browse:1
  BRW1::Sort0:StepClass.Init(+ScrollSort:AllowAlpha,ScrollBy:Runtime) ! Moveable thumb based upon STA:StateCode for sort order 1
  BRW1.AddSortOrder(BRW1::Sort0:StepClass,STA:StateCodeKey) ! Add the sort order for STA:StateCodeKey for sort order 1
  BRW1.AddLocator(BRW1::Sort0:Locator)                     ! Browse has a locator for sort order 1
  BRW1::Sort0:Locator.Init(?STA:StateCode,STA:StateCode,1,BRW1) ! Initialize the browse locator using ?STA:StateCode using key: STA:StateCodeKey , STA:StateCode
  BRW1.AddField(STA:StateCode,BRW1.Q.STA:StateCode)        ! Field STA:StateCode is a hot field or requires assignment from browse
  BRW1.AddField(STA:Name,BRW1.Q.STA:Name)                  ! Field STA:Name is a hot field or requires assignment from browse
  BRW1.AddToolbarTarget(Toolbar)                           ! Browse accepts toolbar control
  BRW1.ToolbarItem.HelpButton = ?Help
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:States.Close
  END
  IF (WebServer.IsEnabled())
    POST(EVENT:NewPage)
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


Web:STA:StateCode.Init PROCEDURE(SIGNED Feq,SIGNED Container)

  CODE
  PARENT.Init(Feq,Container)
  SELF.SubmitOnChange = TRUE


WebWindowProperty.GetEmbedText PROCEDURE(ASTRING embed)

ReturnValue          ANY

Target                  &IHtmlWriter,AUTO
  CODE
  Target &= IHtmlWriter:Create()
  CASE embed
  OF A:EmbedBeforeWindow
    ! center table and make it 360 pixels
    TARGET.Writeln('<div align="center"><center>')
    TARGET.Writeln('<Table width="360"><TR><TD>')
  OF A:EmbedAfterWindow
    ! closing tags
    TARGET.Writeln('</td></tr></Table>')
    TARGET.Writeln('</center></div>')
  END
  ReturnValue = PARENT.GetEmbedText(embed)
  ReturnValue = Target.GetText()
  Target.Release()
  RETURN ReturnValue


WebWindow.Init PROCEDURE

  CODE
  PARENT.Init
  SELF.SetFormatOptions(2, 2, 6, 13)
  WebWindowProperty.Init()
  SELF.AddControl(WebWindowProperty.IControlToHtml)
  Web:STA:StateCode.Init(?STA:StateCode, FEQ:Unknown)
  SELF.AddControl(Web:STA:StateCode.IControlToHtml)
  IF (WebServer.IsEnabled())
    Web:CurFrame &= GetWebActiveFrame()
    Web:CurFrame.CopyControlsToWindow(TRUE, TRUE)
  END


BRW1.Fetch PROCEDURE(BYTE Direction)

GreenBarIndex   LONG
  CODE
  PARENT.Fetch(Direction)


Resizer.Init PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)


  CODE
  PARENT.Init(AppStrategy,SetWindowMinSize,SetWindowMaxSize)
  SELF.SetParentDefaults()                                 ! Calculate default control parent-child relationships based upon their positions on the window

BrowseOrders PROCEDURE                                     ! Generated from procedure template - Window

CurrentTab           STRING(80)                            !
LocalRequest         LONG                                  !
FilesOpened          BYTE                                  !
LOC:Shipped          STRING(3)                             !
TaxString            STRING(8)                             !
DiscountString       STRING(8)                             !
TotalTax             DECIMAL(7,2)                          !
TotalDiscount        DECIMAL(7,2)                          !
TotalCost            DECIMAL(7,2)                          !
LOC:CustName         STRING(45)                            !
BRW1::View:Browse    VIEW(Orders)
                       PROJECT(ORD:InvoiceNumber)
                       PROJECT(ORD:CustNumber)
                       PROJECT(ORD:OrderNumber)
                       PROJECT(ORD:OrderDate)
                       JOIN(CUS:KeyCustNumber,ORD:CustNumber)
                         PROJECT(CUS:CustNumber)
                       END
                     END
Queue:Browse:1       QUEUE                            !Queue declaration for browse/combo box using ?Browse:1
ORD:InvoiceNumber      LIKE(ORD:InvoiceNumber)        !List box control field - type derived from field
ORD:CustNumber         LIKE(ORD:CustNumber)           !List box control field - type derived from field
ORD:OrderNumber        LIKE(ORD:OrderNumber)          !List box control field - type derived from field
ORD:OrderDate          LIKE(ORD:OrderDate)            !List box control field - type derived from field
LOC:Shipped            LIKE(LOC:Shipped)              !List box control field - type derived from local data
LOC:CustName           LIKE(LOC:CustName)             !Browse hot field - type derived from local data
CUS:CustNumber         LIKE(CUS:CustNumber)           !Related join file key field - type derived from field
Mark                   BYTE                           !Entry's marked status
ViewPosition           STRING(1024)                   !Entry's view position
                     END
QuickWindow          WINDOW('Browse Orders'),AT(,,203,162),FONT('MS Sans Serif',8,,),CENTER,IMM,ICON('BOOK.GIF'),HLP('~BrowseOrdersforaCustomer'),SYSTEM,GRAY,RESIZE,MDI
                       SHEET,AT(3,2,197,154),USE(?CurrentTab),FONT('Arial',,,)
                         TAB('By: Invoice #'),USE(?Tab1)
                           PROMPT('Customer:'),AT(55,2,34,10)
                           STRING(@s45),AT(89,2,100,10),USE(LOC:CustName),FONT(,,COLOR:Green,FONT:bold,CHARSET:ANSI)
                         END
                       END
                       LIST,AT(8,21,186,106),USE(?Browse:1),IMM,VSCROLL,MSG('Browsing Records'),FORMAT('35L(1)|M~Invoice #~L(2)@n07@34L(1)|M~Cust #~L(2)@n07@37L(1)|M~Order #~L(2)@n07@4' &|
   '0L(1)|M~Order Date~@d1@32L(9)|M~Shipped~L(1)@s3@'),FROM(Queue:Browse:1)
                       BUTTON,AT(13,134,27,15),USE(?ODButton),FLAT,TIP('View Order Details'),ICON('Order.gif')
                       BUTTON,AT(89,134,28,15),USE(?PrintInv),FLAT,FONT(,,,FONT:bold),TIP('Print Selected Invoice'),ICON('Printer.gif')
                       BUTTON,AT(83,37,15,15),USE(?Help),HIDE,TIP('Get Help'),ICON(ICON:Help),STD(STD:Help)
                       BUTTON,AT(165,134,27,15),USE(?Close),FLAT,RIGHT,FONT('MS Serif',10,,FONT:bold),MSG('Close the browse'),TIP('Close the browse'),ICON('EXITS.GIF')
                     END
Web:CurFrame         &WbFrameClass

ThisWindow           CLASS(WindowManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
Kill                   PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
TakeAccepted           PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
                     END

Toolbar              ToolbarClass
WebWindowManager     WbWindowManagerClass
WebWindow            CLASS(WbWindowClass)
Init                   PROCEDURE()                         ! Method added to host embed code
                     END

Web:Browse:1         CLASS(WbControlHtmlProperties)        ! Web Control Manager for ?Browse:1
Init                   PROCEDURE(SIGNED Feq,SIGNED Container) ! Method added to host embed code
                     END

WebWindowProperty    CLASS(WbWindowHtmlProperties)
GetEmbedText           PROCEDURE(ASTRING embed),STRING,DERIVED ! Method added to host embed code
                     END

BRW1                 CLASS(BrowseClass)                    ! Browse using ?Browse:1
Q                      &Queue:Browse:1                !Reference to browse queue
Fetch                  PROCEDURE(BYTE Direction),DERIVED   ! Method added to host embed code
SetQueueRecord         PROCEDURE(),DERIVED                 ! Method added to host embed code
                     END

BRW1::Sort0:Locator  StepLocatorClass                      ! Default Locator
BRW1::Sort0:StepClass StepLongClass                        ! Default Step Manager
Resizer              CLASS(WindowResizeClass)
Init                   PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False) ! Method added to host embed code
                     END


  CODE
? DEBUGHOOK(Orders:Record)
  GlobalResponse = ThisWindow.Run()                        ! Opens the window and starts an Accept Loop

!---------------------------------------------------------------------------
DefineListboxStyle ROUTINE
!|
!| This routine create all the styles to be shared in this window
!| It`s called after the window open
!|
!---------------------------------------------------------------------------

ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('BrowseOrders')
  SELF.Request = GlobalRequest                             ! Store the incoming request
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ? 
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors                              ! Set this windows ErrorManager to the global ErrorManager
  BIND('LOC:Shipped',LOC:Shipped)                          ! Added by: BrowseBox(ABC)
  BIND('LOC:CustName',LOC:CustName)                        ! Added by: BrowseBox(ABC)
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)                                     ! Clear GlobalRequest after storing locally
  CLEAR(GlobalResponse)
  IF SELF.Request = SelectRecord
     SELF.AddItem(?Close,RequestCancelled)                 ! Add the close control to the window manger
  ELSE
     SELF.AddItem(?Close,RequestCompleted)                 ! Add the close control to the window manger
  END
  Relate:Orders.SetOpenRelated()
  Relate:Orders.Open                                       ! File Orders used by this procedure, so make sure it's RelationManager is open
  SELF.FilesOpened = True
  BRW1.Init(?Browse:1,Queue:Browse:1.ViewPosition,BRW1::View:Browse,Queue:Browse:1,Relate:Orders,SELF) ! Initialize the browse manager
  SELF.Open(QuickWindow)                                   ! Open window
  Do DefineListboxStyle
  IF (WebServer.IsEnabled())
    WebWindow.Init()
    WebWindowManager.Init(WebServer, WebWindow.IPageCreator, WebWindow.IWebResponseProcessor, 0{PROP:text} & ' (BrowseOrders)')
    SELF.AddItem(WebWindow.WindowComponent)
    SELF.AddItem(WebWindowManager.WindowComponent)
  END
  QuickWindow{PROP:MinWidth}=375                           ! Restrict the minimum window width
  QuickWindow{PROP:MinHeight}=193                          ! Restrict the minimum window height
  Resizer.Init(AppStrategy:Spread)                         ! Controls will spread out as the window gets bigger
  SELF.AddItem(Resizer)                                    ! Add resizer to window manager
  BRW1.Q &= Queue:Browse:1
  BRW1::Sort0:StepClass.Init(+ScrollSort:AllowAlpha)       ! Moveable thumb based upon ORD:InvoiceNumber for sort order 1
  BRW1.AddSortOrder(BRW1::Sort0:StepClass,ORD:InvoiceNumberKey) ! Add the sort order for ORD:InvoiceNumberKey for sort order 1
  BRW1.AddLocator(BRW1::Sort0:Locator)                     ! Browse has a locator for sort order 1
  BRW1::Sort0:Locator.Init(,ORD:InvoiceNumber,1,BRW1)      ! Initialize the browse locator using  using key: ORD:InvoiceNumberKey , ORD:InvoiceNumber
  BRW1.AddField(ORD:InvoiceNumber,BRW1.Q.ORD:InvoiceNumber) ! Field ORD:InvoiceNumber is a hot field or requires assignment from browse
  BRW1.AddField(ORD:CustNumber,BRW1.Q.ORD:CustNumber)      ! Field ORD:CustNumber is a hot field or requires assignment from browse
  BRW1.AddField(ORD:OrderNumber,BRW1.Q.ORD:OrderNumber)    ! Field ORD:OrderNumber is a hot field or requires assignment from browse
  BRW1.AddField(ORD:OrderDate,BRW1.Q.ORD:OrderDate)        ! Field ORD:OrderDate is a hot field or requires assignment from browse
  BRW1.AddField(LOC:Shipped,BRW1.Q.LOC:Shipped)            ! Field LOC:Shipped is a hot field or requires assignment from browse
  BRW1.AddField(LOC:CustName,BRW1.Q.LOC:CustName)          ! Field LOC:CustName is a hot field or requires assignment from browse
  BRW1.AddField(CUS:CustNumber,BRW1.Q.CUS:CustNumber)      ! Field CUS:CustNumber is a hot field or requires assignment from browse
  BRW1.AddToolbarTarget(Toolbar)                           ! Browse accepts toolbar control
  BRW1.ToolbarItem.HelpButton = ?Help
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:Orders.Close
  END
  IF (WebServer.IsEnabled())
    POST(EVENT:NewPage)
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.TakeAccepted PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receive all EVENT:Accepted's
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
  ReturnValue = PARENT.TakeAccepted()
    CASE ACCEPTED()
    OF ?ODButton
      ThisWindow.Update
      BrowseDetails()
      ThisWindow.Reset
    OF ?PrintInv
      ThisWindow.Update
      PrintSingleInvoice()
      ThisWindow.Reset
    END
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


Web:Browse:1.Init PROCEDURE(SIGNED Feq,SIGNED Container)

  CODE
  PARENT.Init(Feq,Container)
  SELF.SubmitOnChange = TRUE


WebWindowProperty.GetEmbedText PROCEDURE(ASTRING embed)

ReturnValue          ANY

Target                  &IHtmlWriter,AUTO
  CODE
  Target &= IHtmlWriter:Create()
  CASE embed
  OF A:EmbedBeforeWindow
    ! center table and make it 600 pixels
    TARGET.Writeln('<div align="center"><center>')
    TARGET.Writeln('<Table width="600"><TR><TD>')
  OF A:EmbedAfterWindow
    ! closing tags
    TARGET.Writeln('</td></tr></Table>')
    TARGET.Writeln('</center></div>')
  END
  ReturnValue = PARENT.GetEmbedText(embed)
  ReturnValue = Target.GetText()
  Target.Release()
  RETURN ReturnValue


WebWindow.Init PROCEDURE

  CODE
  PARENT.Init
  SELF.SetFormatOptions(2, 2, 6, 13)
  WebWindowProperty.Init()
  SELF.AddControl(WebWindowProperty.IControlToHtml)
  Web:Browse:1.Init(?Browse:1, FEQ:Unknown)
  SELF.AddControl(Web:Browse:1.IControlToHtml)
  IF (WebServer.IsEnabled())
    Web:CurFrame &= GetWebActiveFrame()
    Web:CurFrame.CopyControlsToWindow(TRUE, TRUE)
  END


BRW1.Fetch PROCEDURE(BYTE Direction)

GreenBarIndex   LONG
  CODE
  PARENT.Fetch(Direction)


BRW1.SetQueueRecord PROCEDURE

  CODE
  LOC:CustName = CLIP(CUS:FirstName) & '   ' & CLIP(CUS:LastName)
  IF (ORD:OrderShipped)
    LOC:Shipped = 'Yes'
  ELSE
    LOC:Shipped = 'No'
  END
  PARENT.SetQueueRecord
  
  SELF.Q.LOC:Shipped = LOC:Shipped                         !Assign formula result to display queue
  SELF.Q.LOC:CustName = LOC:CustName                       !Assign formula result to display queue


Resizer.Init PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)


  CODE
  PARENT.Init(AppStrategy,SetWindowMinSize,SetWindowMaxSize)
  SELF.SetParentDefaults()                                 ! Calculate default control parent-child relationships based upon their positions on the window

BrowseCustomers PROCEDURE                                  ! Generated from procedure template - Window

CurrentTab           STRING(80)                            !
LocalRequest         LONG                                  !
FilesOpened          BYTE                                  !
LOC:NameLetter       STRING(1)                             !
LOC:CompanyLetter    STRING(1)                             !
LOC:ZipNum           STRING(2)                             !
LOC:State            STRING(2)                             !
LOC:FilterString     STRING(255)                           !
BRW1::View:Browse    VIEW(Customers)
                       PROJECT(CUS:FirstName)
                       PROJECT(CUS:MI)
                       PROJECT(CUS:LastName)
                       PROJECT(CUS:Company)
                       PROJECT(CUS:State)
                     END
Queue:Browse:1       QUEUE                            !Queue declaration for browse/combo box using ?Browse:1
CUS:FirstName          LIKE(CUS:FirstName)            !List box control field - type derived from field
CUS:MI                 LIKE(CUS:MI)                   !List box control field - type derived from field
CUS:LastName           LIKE(CUS:LastName)             !List box control field - type derived from field
CUS:Company            LIKE(CUS:Company)              !List box control field - type derived from field
CUS:State              LIKE(CUS:State)                !List box control field - type derived from field
Mark                   BYTE                           !Entry's marked status
ViewPosition           STRING(1024)                   !Entry's view position
                     END
QuickWindow          WINDOW('Browse Customers'),AT(,,275,167),FONT('MS Sans Serif',8,,),CENTER,IMM,ICON('CUSTOMER.GIF'),SYSTEM,GRAY,RESIZE,MDI
                       SHEET,AT(1,1,272,164),USE(?CurrentTab)
                         TAB('FullName'),USE(?Tab:2)
                           PROMPT('&Last Name:'),AT(8,17),USE(?CUS:LastName:Prompt)
                           ENTRY(@s25),AT(49,17,74,9),USE(CUS:LastName),MSG('Enter the last name of customer'),CAP
                         END
                         TAB('Company'),USE(?Tab:3)
                           PROMPT('&Company:'),AT(6,17,35,10),USE(?CUS:Company:Prompt)
                           ENTRY(@s20),AT(43,17,74,9),USE(CUS:Company),MSG('Enter the customer''s company'),CAP
                         END
                         TAB('State'),USE(?Tab:5)
                           PROMPT('&State:'),AT(11,17),USE(?CUS:State:Prompt)
                           ENTRY(@s2),AT(35,17,20,9),USE(CUS:State),MSG('Enter state of customer'),UPR
                         END
                       END
                       LIST,AT(8,29,255,112),USE(?Browse:1),IMM,VSCROLL,MSG('Browsing Records'),FORMAT('63L(2)|M~First Name~@s20@14C|M~MI~L(1)@s1@63L(2)|M~Last Name~@s25@71L(2)|M~Compa' &|
   'ny~@s20@22L(6)|M~State~L(1)@s2@'),FROM(Queue:Browse:1)
                       BUTTON('&Select'),AT(161,55,28,14),USE(?Select:2),HIDE
                       BUTTON,AT(92,147,18,12),USE(?Insert:3),FLAT,TIP('Insert a new record'),ICON('Insert.gif')
                       BUTTON,AT(114,147,18,12),USE(?Change:3),FLAT,TIP('Edit selected record'),ICON('Edit.gif'),DEFAULT
                       BUTTON,AT(136,147,18,12),USE(?Delete:3),FLAT,TIP('Delete selected record'),ICON('Delete.gif')
                       BUTTON,AT(239,144,25,17),USE(?Close),FLAT,FONT('MS Sans Serif',8,COLOR:Navy,FONT:bold),TIP('Exit browse'),ICON('EXITS.GIF')
                     END
Web:CurFrame         &WbFrameClass

ThisWindow           CLASS(WindowManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
Kill                   PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
Run                    PROCEDURE(USHORT Number,BYTE Request),BYTE,PROC,DERIVED ! Method added to host embed code
                     END

Toolbar              ToolbarClass
WebWindowManager     WbWindowManagerClass
WebWindow            CLASS(WbWindowClass)
Init                   PROCEDURE()                         ! Method added to host embed code
                     END

Web:CUS:LastName     CLASS(WbControlHtmlProperties)        ! Web Control Manager for ?CUS:LastName
Init                   PROCEDURE(SIGNED Feq,SIGNED Container) ! Method added to host embed code
                     END

Web:CUS:Company      CLASS(WbControlHtmlProperties)        ! Web Control Manager for ?CUS:Company
Init                   PROCEDURE(SIGNED Feq,SIGNED Container) ! Method added to host embed code
                     END

Web:CUS:State        CLASS(WbControlHtmlProperties)        ! Web Control Manager for ?CUS:State
Init                   PROCEDURE(SIGNED Feq,SIGNED Container) ! Method added to host embed code
                     END

Web:Browse:1         CLASS(WbControlHtmlProperties)        ! Web Control Manager for ?Browse:1
Init                   PROCEDURE(SIGNED Feq,SIGNED Container) ! Method added to host embed code
                     END

WebWindowProperty    CLASS(WbWindowHtmlProperties)
GetEmbedText           PROCEDURE(ASTRING embed),STRING,DERIVED ! Method added to host embed code
                     END

BRW1                 CLASS(BrowseClass)                    ! Browse using ?Browse:1
Q                      &Queue:Browse:1                !Reference to browse queue
Fetch                  PROCEDURE(BYTE Direction),DERIVED   ! Method added to host embed code
Init                   PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM) ! Method added to host embed code
ResetSort              PROCEDURE(BYTE Force),BYTE,PROC,DERIVED ! Method added to host embed code
SetQueueRecord         PROCEDURE(),DERIVED                 ! Method added to host embed code
                     END

BRW1::Sort0:Locator  IncrementalLocatorClass               ! Default Locator
BRW1::Sort1:Locator  FilterLocatorClass                    ! Conditional Locator - CHOICE(?CurrentTab) = 2
BRW1::Sort3:Locator  FilterLocatorClass                    ! Conditional Locator - CHOICE(?CurrentTab) = 3
BRW1::Sort0:StepClass StepStringClass                      ! Default Step Manager
BRW1::Sort1:StepClass StepStringClass                      ! Conditional Step Manager - CHOICE(?CurrentTab) = 2
BRW1::Sort3:StepClass StepStringClass                      ! Conditional Step Manager - CHOICE(?CurrentTab) = 3
Resizer              CLASS(WindowResizeClass)
Init                   PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False) ! Method added to host embed code
                     END


  CODE
? DEBUGHOOK(Customers:Record)
  GlobalResponse = ThisWindow.Run()                        ! Opens the window and starts an Accept Loop

!---------------------------------------------------------------------------
DefineListboxStyle ROUTINE
!|
!| This routine create all the styles to be shared in this window
!| It`s called after the window open
!|
!---------------------------------------------------------------------------

ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('BrowseCustomers')
  SELF.Request = GlobalRequest                             ! Store the incoming request
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?CUS:LastName:Prompt
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors                              ! Set this windows ErrorManager to the global ErrorManager
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)                                     ! Clear GlobalRequest after storing locally
  CLEAR(GlobalResponse)
  IF SELF.Request = SelectRecord
     SELF.AddItem(?Close,RequestCancelled)                 ! Add the close control to the window manger
  ELSE
     SELF.AddItem(?Close,RequestCompleted)                 ! Add the close control to the window manger
  END
  Relate:Customers.SetOpenRelated()
  Relate:Customers.Open                                    ! File Customers used by this procedure, so make sure it's RelationManager is open
  SELF.FilesOpened = True
  BRW1.Init(?Browse:1,Queue:Browse:1.ViewPosition,BRW1::View:Browse,Queue:Browse:1,Relate:Customers,SELF) ! Initialize the browse manager
  SELF.Open(QuickWindow)                                   ! Open window
  Do DefineListboxStyle
  IF (WebServer.IsEnabled())
    WebWindow.Init()
    WebWindowManager.Init(WebServer, WebWindow.IPageCreator, WebWindow.IWebResponseProcessor, 0{PROP:text} & ' (BrowseCustomers)')
    SELF.AddItem(WebWindow.WindowComponent)
    SELF.AddItem(WebWindowManager.WindowComponent)
  END
  QuickWindow{PROP:MinWidth}=315                           ! Restrict the minimum window width
  QuickWindow{PROP:MinHeight}=209                          ! Restrict the minimum window height
  Resizer.Init(AppStrategy:NoResize)                       ! Don't change the windows controls when window resized
  SELF.AddItem(Resizer)                                    ! Add resizer to window manager
  BRW1.Q &= Queue:Browse:1
  BRW1::Sort1:StepClass.Init(+ScrollSort:AllowAlpha,ScrollBy:Runtime) ! Moveable thumb based upon CUS:Company for sort order 1
  BRW1.AddSortOrder(BRW1::Sort1:StepClass,CUS:KeyCompany)  ! Add the sort order for CUS:KeyCompany for sort order 1
  BRW1.AddLocator(BRW1::Sort1:Locator)                     ! Browse has a locator for sort order 1
  BRW1::Sort1:Locator.Init(?CUS:Company,CUS:Company,1,BRW1) ! Initialize the browse locator using ?CUS:Company using key: CUS:KeyCompany , CUS:Company
  BRW1::Sort1:Locator.FloatRight = 1
  BRW1::Sort3:StepClass.Init(+ScrollSort:AllowAlpha,ScrollBy:Runtime) ! Moveable thumb based upon CUS:State for sort order 2
  BRW1.AddSortOrder(BRW1::Sort3:StepClass,CUS:StateKey)    ! Add the sort order for CUS:StateKey for sort order 2
  BRW1.AddLocator(BRW1::Sort3:Locator)                     ! Browse has a locator for sort order 2
  BRW1::Sort3:Locator.Init(?CUS:State,CUS:State,1,BRW1)    ! Initialize the browse locator using ?CUS:State using key: CUS:StateKey , CUS:State
  BRW1::Sort3:Locator.FloatRight = 1
  BRW1::Sort0:StepClass.Init(+ScrollSort:AllowAlpha,ScrollBy:Runtime) ! Moveable thumb based upon CUS:LastName for sort order 3
  BRW1.AddSortOrder(BRW1::Sort0:StepClass,CUS:KeyFullName) ! Add the sort order for CUS:KeyFullName for sort order 3
  BRW1.AddLocator(BRW1::Sort0:Locator)                     ! Browse has a locator for sort order 3
  BRW1::Sort0:Locator.Init(?CUS:LastName,CUS:LastName,1,BRW1) ! Initialize the browse locator using ?CUS:LastName using key: CUS:KeyFullName , CUS:LastName
  BRW1.AddField(CUS:FirstName,BRW1.Q.CUS:FirstName)        ! Field CUS:FirstName is a hot field or requires assignment from browse
  BRW1.AddField(CUS:MI,BRW1.Q.CUS:MI)                      ! Field CUS:MI is a hot field or requires assignment from browse
  BRW1.AddField(CUS:LastName,BRW1.Q.CUS:LastName)          ! Field CUS:LastName is a hot field or requires assignment from browse
  BRW1.AddField(CUS:Company,BRW1.Q.CUS:Company)            ! Field CUS:Company is a hot field or requires assignment from browse
  BRW1.AddField(CUS:State,BRW1.Q.CUS:State)                ! Field CUS:State is a hot field or requires assignment from browse
  BRW1.AskProcedure = 1
  BRW1.AddToolbarTarget(Toolbar)                           ! Browse accepts toolbar control
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:Customers.Close
  END
  IF (WebServer.IsEnabled())
    POST(EVENT:NewPage)
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.Run PROCEDURE(USHORT Number,BYTE Request)

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Run(Number,Request)
  IF SELF.Request = ViewRecord
    ReturnValue = RequestCancelled                         ! Always return RequestCancelled if the form was opened in ViewRecord mode
  ELSE
    GlobalRequest = Request
    UpdateCustomers
    ReturnValue = GlobalResponse
  END
  RETURN ReturnValue


Web:CUS:LastName.Init PROCEDURE(SIGNED Feq,SIGNED Container)

  CODE
  PARENT.Init(Feq,Container)
  SELF.SubmitOnChange = TRUE


Web:CUS:Company.Init PROCEDURE(SIGNED Feq,SIGNED Container)

  CODE
  PARENT.Init(Feq,Container)
  SELF.SubmitOnChange = TRUE


Web:CUS:State.Init PROCEDURE(SIGNED Feq,SIGNED Container)

  CODE
  PARENT.Init(Feq,Container)
  SELF.SubmitOnChange = TRUE


Web:Browse:1.Init PROCEDURE(SIGNED Feq,SIGNED Container)

  CODE
  PARENT.Init(Feq,Container)
  SELF.SubmitOnChange = TRUE


WebWindowProperty.GetEmbedText PROCEDURE(ASTRING embed)

ReturnValue          ANY

Target                  &IHtmlWriter,AUTO
  CODE
  Target &= IHtmlWriter:Create()
  CASE embed
  OF A:EmbedBeforeWindow
    ! center table and make it 600 pixels
    TARGET.Writeln('<div align="center"><center>')
    TARGET.Writeln('<Table width="600"><TR><TD>')
  OF A:EmbedAfterWindow
    ! closing tags
    TARGET.Writeln('</td></tr></Table>')
    TARGET.Writeln('</center></div>')
  END
  ReturnValue = PARENT.GetEmbedText(embed)
  ReturnValue = Target.GetText()
  Target.Release()
  RETURN ReturnValue


WebWindow.Init PROCEDURE

  CODE
  PARENT.Init
  SELF.SetFormatOptions(2, 2, 6, 13)
  WebWindowProperty.Init()
  SELF.AddControl(WebWindowProperty.IControlToHtml)
  Web:CUS:LastName.Init(?CUS:LastName, FEQ:Unknown)
  SELF.AddControl(Web:CUS:LastName.IControlToHtml)
  Web:CUS:Company.Init(?CUS:Company, FEQ:Unknown)
  SELF.AddControl(Web:CUS:Company.IControlToHtml)
  Web:CUS:State.Init(?CUS:State, FEQ:Unknown)
  SELF.AddControl(Web:CUS:State.IControlToHtml)
  Web:Browse:1.Init(?Browse:1, FEQ:Unknown)
  SELF.AddControl(Web:Browse:1.IControlToHtml)
  IF (WebServer.IsEnabled())
    Web:CurFrame &= GetWebActiveFrame()
    Web:CurFrame.CopyControlsToWindow(TRUE, TRUE)
  END


BRW1.Fetch PROCEDURE(BYTE Direction)

GreenBarIndex   LONG
  CODE
  PARENT.Fetch(Direction)


BRW1.Init PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)

  CODE
  SELF.SelectControl = ?Select:2
  SELF.HideSelect = 1                                      ! Hide the select button when disabled
  PARENT.Init(ListBox,Posit,V,Q,RM,WM)
  IF WM.Request <> ViewRecord                              ! If called for anything other than ViewMode, make the insert, change & delete controls available
    SELF.InsertControl=?Insert:3
    SELF.ChangeControl=?Change:3
    SELF.DeleteControl=?Delete:3
  END


BRW1.ResetSort PROCEDURE(BYTE Force)

ReturnValue          BYTE,AUTO

  CODE
  IF CHOICE(?CurrentTab) = 2
    RETURN SELF.SetSort(1,Force)
  ELSIF CHOICE(?CurrentTab) = 3
    RETURN SELF.SetSort(2,Force)
  ELSE
    RETURN SELF.SetSort(3,Force)
  END
  ReturnValue = PARENT.ResetSort(Force)
  RETURN ReturnValue


BRW1.SetQueueRecord PROCEDURE

  CODE
  GLOT:CusCSZ = CLIP(CUS:City) & ',  ' & CUS:State & '   ' & CLIP(CUS:ZipCode)
  PARENT.SetQueueRecord
  


Resizer.Init PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)


  CODE
  PARENT.Init(AppStrategy,SetWindowMinSize,SetWindowMaxSize)
  SELF.SetParentDefaults()                                 ! Calculate default control parent-child relationships based upon their positions on the window

UpdateCustomers PROCEDURE                                  ! Generated from procedure template - Window

CurrentTab           STRING(80)                            !
LocalRequest         LONG                                  !
FilesOpened          BYTE                                  !
ActionMessage        CSTRING(40)                           !
RecordChanged        BYTE,AUTO                             !
History::CUS:Record  LIKE(CUS:RECORD),THREAD
QuickWindow          WINDOW('Update Customers'),AT(,,215,189),FONT('MS Sans Serif',8,,),CENTER,IMM,ICON('CUST.GIF'),HLP('~UpdateCustomers'),SYSTEM,GRAY,RESIZE,MDI
                       PANEL,AT(1,1,212,186),USE(?Panel1)
                       PROMPT('&Company:'),AT(9,11),USE(?CUS:Company:Prompt)
                       ENTRY(@s20),AT(65,11,84,10),USE(CUS:Company),MSG('Enter the customer''s company'),CAP
                       PROMPT('&First Name:'),AT(9,25),USE(?CUS:FirstName:Prompt)
                       ENTRY(@s20),AT(65,25,84,10),USE(CUS:FirstName),MSG('Enter the first name of customer'),REQ,CAP
                       PROMPT('MI:'),AT(9,39,23,10),USE(?CUS:MI:Prompt)
                       ENTRY(@s1),AT(65,39,21,10),USE(CUS:MI),MSG('Enter the middle initial of customer'),UPR
                       PROMPT('&Last Name:'),AT(9,53),USE(?CUS:LastName:Prompt)
                       ENTRY(@s25),AT(65,53,104,10),USE(CUS:LastName),MSG('Enter the last name of customer'),REQ,CAP
                       PROMPT('&Address1:'),AT(9,67),USE(?CUS:Address1:Prompt)
                       ENTRY(@s35),AT(65,67,139,10),USE(CUS:Address1),MSG('Enter the first line address of customer'),CAP
                       PROMPT('Address2:'),AT(9,81),USE(?CUS:Address2:Prompt)
                       ENTRY(@s35),AT(65,81,139,10),USE(CUS:Address2),MSG('Enter the second line address of customer if any'),CAP
                       PROMPT('&City:'),AT(9,95),USE(?CUS:City:Prompt)
                       ENTRY(@s25),AT(65,95,104,10),USE(CUS:City),MSG('Enter  city of customer'),CAP
                       PROMPT('&State:'),AT(9,110),USE(?CUS:State:Prompt)
                       ENTRY(@s2),AT(65,110,22,10),USE(CUS:State),MSG('Enter state of customer'),UPR
                       PROMPT('&Zip Code:'),AT(9,124),USE(?CUS:ZipCode:Prompt)
                       ENTRY(@K#####|-####KB),AT(65,124,69,10),USE(CUS:ZipCode),MSG('Enter zipcode of customer'),TIP('Enter zipcode of customer')
                       PROMPT('Phone Number:'),AT(9,138),USE(?CUS:PhoneNumber:Prompt)
                       ENTRY(@P(###) ###-####PB),AT(65,138,68,10),USE(CUS:PhoneNumber),MSG('Customer''s phone number')
                       PROMPT('Extension:'),AT(9,152),USE(?CUS:Extension:Prompt)
                       ENTRY(@P<<<#PB),AT(65,152,24,10),USE(CUS:Extension),MSG('Enter customer''s phone extension')
                       PROMPT('Phone Type:'),AT(9,166,43,10),USE(?CUS:PhoneType:Prompt)
                       LIST,AT(65,166,44,10),USE(CUS:PhoneType),MSG('Enter customer''s phone type'),DROP(5),FROM('Home|Work|Cellular|Pager|Fax|Other')
                       BUTTON,AT(152,160,21,20),USE(?OK),FLAT,MSG('Save recod and Exit'),TIP('Save recod and Exit'),CURSOR(CURSOR:None),ICON('DISK.GIF'),DEFAULT
                       BUTTON,AT(180,131,13,12),USE(?Help),FLAT,HIDE,TIP('Get Help'),ICON(ICON:Help),STD(STD:Help)
                       BUTTON,AT(180,160,21,20),USE(?Cancel),FLAT,MSG('Cancels change and Exit'),TIP('Cancels change and Exit'),ICON('Cross.GIF')
                     END
Web:CurFrame         &WbFrameClass

ThisWindow           CLASS(WindowManager)
Ask                    PROCEDURE(),DERIVED                 ! Method added to host embed code
Init                   PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
Kill                   PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
Run                    PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
Run                    PROCEDURE(USHORT Number,BYTE Request),BYTE,PROC,DERIVED ! Method added to host embed code
TakeAccepted           PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
                     END

Toolbar              ToolbarClass
WebWindowManager     WbWindowManagerClass
WebWindow            CLASS(WbWindowClass)
Init                   PROCEDURE()                         ! Method added to host embed code
                     END

WebWindowProperty    CLASS(WbWindowHtmlProperties)
GetEmbedText           PROCEDURE(ASTRING embed),STRING,DERIVED ! Method added to host embed code
                     END

ToolbarForm          ToolbarUpdateClass                    ! Form Toolbar Manager
Resizer              CLASS(WindowResizeClass)
Init                   PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False) ! Method added to host embed code
                     END

CurCtrlFeq          LONG
FieldColorQueue     QUEUE
Feq                   LONG
OldColor              LONG
                    END

  CODE
? DEBUGHOOK(Customers:Record)
? DEBUGHOOK(States:Record)
  GlobalResponse = ThisWindow.Run()                        ! Opens the window and starts an Accept Loop

!---------------------------------------------------------------------------
DefineListboxStyle ROUTINE
!|
!| This routine create all the styles to be shared in this window
!| It`s called after the window open
!|
!---------------------------------------------------------------------------

ThisWindow.Ask PROCEDURE

  CODE
  CASE SELF.Request                                        ! Configure the action message text
  OF ViewRecord
    ActionMessage = 'View Record'
  OF InsertRecord
    ActionMessage = 'Adding a Customers Record'
  OF ChangeRecord
    ActionMessage = 'Changing a Customers Record'
  END
  QuickWindow{Prop:Text} = ActionMessage                   ! Display status message in title bar
  PARENT.Ask


ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('UpdateCustomers')
  SELF.Request = GlobalRequest                             ! Store the incoming request
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?Panel1
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors                              ! Set this windows ErrorManager to the global ErrorManager
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)                                     ! Clear GlobalRequest after storing locally
  CLEAR(GlobalResponse)
  SELF.HistoryKey = 734
  SELF.AddHistoryFile(CUS:Record,History::CUS:Record)
  SELF.AddHistoryField(?CUS:Company,2)
  SELF.AddHistoryField(?CUS:FirstName,3)
  SELF.AddHistoryField(?CUS:MI,4)
  SELF.AddHistoryField(?CUS:LastName,5)
  SELF.AddHistoryField(?CUS:Address1,6)
  SELF.AddHistoryField(?CUS:Address2,7)
  SELF.AddHistoryField(?CUS:City,8)
  SELF.AddHistoryField(?CUS:State,9)
  SELF.AddHistoryField(?CUS:ZipCode,10)
  SELF.AddHistoryField(?CUS:PhoneNumber,11)
  SELF.AddHistoryField(?CUS:Extension,12)
  SELF.AddHistoryField(?CUS:PhoneType,13)
  SELF.AddUpdateFile(Access:Customers)
  SELF.AddItem(?Cancel,RequestCancelled)                   ! Add the cancel control to the window manager
  Relate:Customers.SetOpenRelated()
  Relate:Customers.Open                                    ! File Customers used by this procedure, so make sure it's RelationManager is open
  Relate:States.Open                                       ! File States used by this procedure, so make sure it's RelationManager is open
  SELF.FilesOpened = True
  SELF.Primary &= Relate:Customers
  IF SELF.Request = ViewRecord AND NOT SELF.BatchProcessing ! Setup actions for ViewOnly Mode
    SELF.InsertAction = Insert:None
    SELF.DeleteAction = Delete:None
    SELF.ChangeAction = Change:None
    SELF.CancelAction = Cancel:Cancel
    SELF.OkControl = 0
  ELSE
    SELF.InsertAction = Insert:Query
    SELF.ChangeAction = Change:Caller                      ! Changes allowed
    SELF.OkControl = ?OK
    IF SELF.PrimeUpdate() THEN RETURN Level:Notify.
  END
  SELF.Open(QuickWindow)                                   ! Open window
  Do DefineListboxStyle
  IF (WebServer.IsEnabled())
    WebWindow.Init()
    WebWindowManager.Init(WebServer, WebWindow.IPageCreator, WebWindow.IWebResponseProcessor, 0{PROP:text} & ' (UpdateCustomers)')
    SELF.AddItem(WebWindow.WindowComponent)
    SELF.AddItem(WebWindowManager.WindowComponent)
  END
  QuickWindow{PROP:MinWidth}=214                           ! Restrict the minimum window width
  QuickWindow{PROP:MinHeight}=188                          ! Restrict the minimum window height
  Resizer.Init(AppStrategy:Spread)                         ! Controls will spread out as the window gets bigger
  SELF.AddItem(Resizer)                                    ! Add resizer to window manager
  ToolBarForm.HelpButton=?Help
  SELF.AddItem(ToolbarForm)
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:Customers.Close
    Relate:States.Close
  END
  IF (WebServer.IsEnabled())
    POST(EVENT:NewPage)
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.Run PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Run()
  IF SELF.Request = ViewRecord                             ! In View Only mode always signal RequestCancelled
    ReturnValue = RequestCancelled
  END
  RETURN ReturnValue


ThisWindow.Run PROCEDURE(USHORT Number,BYTE Request)

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Run(Number,Request)
  IF SELF.Request = ViewRecord
    ReturnValue = RequestCancelled                         ! Always return RequestCancelled if the form was opened in ViewRecord mode
  ELSE
    GlobalRequest = Request
    SelectStates
    ReturnValue = GlobalResponse
  END
  RETURN ReturnValue


ThisWindow.TakeAccepted PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receive all EVENT:Accepted's
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
  ReturnValue = PARENT.TakeAccepted()
    CASE ACCEPTED()
    OF ?CUS:State
      STA:StateCode = CUS:State
      IF Access:States.TryFetch(STA:StateCodeKey)
        IF SELF.Run(1,SelectRecord) = RequestCompleted
          CUS:State = STA:StateCode
        ELSE
          SELECT(?CUS:State)
          CYCLE
        END
      END
      ThisWindow.Reset(0)
      IF Access:Customers.TryValidateField(9)              ! Attempt to validate CUS:State in Customers
        SELECT(?CUS:State)
        QuickWindow{Prop:AcceptAll} = False
        CYCLE
      ELSE
        FieldColorQueue.Feq = ?CUS:State
        GET(FieldColorQueue, FieldColorQueue.Feq)
        IF ~ERRORCODE()
          ?CUS:State{Prop:FontColor} = FieldColorQueue.OldColor
          DELETE(FieldColorQueue)
        END
      END
    OF ?OK
      ThisWindow.Update
      IF SELF.Request = ViewRecord AND NOT SELF.BatchProcessing THEN
         POST(EVENT:CloseWindow)
      END
    END
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


WebWindowProperty.GetEmbedText PROCEDURE(ASTRING embed)

ReturnValue          ANY

Target                  &IHtmlWriter,AUTO
  CODE
  Target &= IHtmlWriter:Create()
  CASE embed
  OF A:EmbedBeforeWindow
    ! center table and make it 400 pixels
    TARGET.Writeln('<div align="center"><center>')
    TARGET.Writeln('<Table width="400"><TR><TD>')
  OF A:EmbedAfterWindow
    ! closing tags
    TARGET.Writeln('</td></tr></Table>')
    TARGET.Writeln('</center></div>')
  END
  ReturnValue = PARENT.GetEmbedText(embed)
  ReturnValue = Target.GetText()
  Target.Release()
  RETURN ReturnValue


WebWindow.Init PROCEDURE

  CODE
  PARENT.Init
  SELF.SetFormatOptions(2, 2, 6, 13)
  WebWindowProperty.Init()
  SELF.AddControl(WebWindowProperty.IControlToHtml)
  IF (WebServer.IsEnabled())
    Web:CurFrame &= GetWebActiveFrame()
    Web:CurFrame.CopyControlsToWindow(TRUE, TRUE)
  END


Resizer.Init PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)


  CODE
  PARENT.Init(AppStrategy,SetWindowMinSize,SetWindowMaxSize)
  SELF.SetParentDefaults()                                 ! Calculate default control parent-child relationships based upon their positions on the window

