

   MEMBER('WebInv.clw')                                    ! This is a MEMBER module


   INCLUDE('ABBROWSE.INC'),ONCE
   INCLUDE('ABLPROPR.INC'),ONCE
   INCLUDE('ABLWINR.INC'),ONCE
   INCLUDE('ABPOPUP.INC'),ONCE
   INCLUDE('ABREPORT.INC'),ONCE
   INCLUDE('ABRESIZE.INC'),ONCE
   INCLUDE('ABTOOLBA.INC'),ONCE
   INCLUDE('ABWINDOW.INC'),ONCE
   INCLUDE('WBFRAME.INC'),ONCE
   INCLUDE('ablwman.inc'),ONCE

                     MAP
                       INCLUDE('WEBIN002.INC'),ONCE        !Local module procedure declarations
                       INCLUDE('WEBIN001.INC'),ONCE        !Req'd for module callout resolution
                       INCLUDE('WEBIN003.INC'),ONCE        !Req'd for module callout resolution
                     END


Main PROCEDURE                                             ! Generated from procedure template - Frame

SplashProcedureThread LONG
AppFrame             APPLICATION('Invoice Manager'),AT(,,422,266),FONT('MS Sans Serif',8,,),CENTER,STATUS(-1,80,120,45),SYSTEM,MAX,RESIZE,IMM
                       MENUBAR,USE(?Menubar)
                         MENU('&Browse'),USE(?Browse)
                           ITEM('Customers'),USE(?Customers)
                           ITEM('Products'),USE(?Products)
                           ITEM('Orders'),USE(?Orders)
                         END
                         MENU('Report'),USE(?Report)
                           ITEM('Print Invoice'),USE(?ReportPrintInvoice)
                         END
                       END
                       TOOLBAR,AT(0,0,400,19)
                         BUTTON,AT(4,2,16,14),USE(?Toolbar:Top,Toolbar:Top),DISABLE,FLAT,TIP('Go to the First Page'),ICON('VCRFIRST.GIF')
                         BUTTON,AT(20,2,16,14),USE(?Toolbar:PageUp,Toolbar:PageUp),DISABLE,FLAT,TIP('Go to the Prior Page'),ICON('VCRPRIOR.GIF')
                         BUTTON,AT(36,2,16,14),USE(?Toolbar:Up,Toolbar:Up),DISABLE,FLAT,TIP('Go to the Prior Record'),ICON('VCRUP.GIF')
                         BUTTON,AT(52,2,16,14),USE(?Toolbar:Locate,Toolbar:Locate),DISABLE,FLAT,TIP('Locate record'),ICON('FIND.GIF')
                         BUTTON,AT(68,2,16,14),USE(?Toolbar:Down,Toolbar:Down),DISABLE,FLAT,TIP('Go to the Next Record'),ICON('VCRDOWN.GIF')
                         BUTTON,AT(84,2,16,14),USE(?Toolbar:PageDown,Toolbar:PageDown),DISABLE,FLAT,TIP('Go to the Next Page'),ICON('VCRNEXT.GIF')
                         BUTTON,AT(100,2,16,14),USE(?Toolbar:Bottom,Toolbar:Bottom),DISABLE,FLAT,TIP('Go to the Last Page'),ICON('VCRLAST.GIF')
                         BUTTON,AT(120,2,16,14),USE(?Toolbar:Select,Toolbar:Select),DISABLE,FLAT,TIP('Select This Record'),ICON('MARK.GIF')
                         BUTTON,AT(136,2,16,14),USE(?Toolbar:Insert,Toolbar:Insert),DISABLE,FLAT,TIP('Insert a New Record'),ICON('INSERT.GIF')
                         BUTTON,AT(152,2,16,14),USE(?Toolbar:Change,Toolbar:Change),DISABLE,FLAT,TIP('Edit This Record'),ICON('EDIT.GIF')
                         BUTTON,AT(168,2,16,14),USE(?Toolbar:Delete,Toolbar:Delete),DISABLE,FLAT,TIP('Delete This Record'),ICON('DELETE.GIF')
                         BUTTON,AT(188,2,16,14),USE(?Toolbar:History,Toolbar:History),DISABLE,FLAT,TIP('Previous value'),ICON('DITTO.GIF')
                         BUTTON,AT(204,2,16,14),USE(?Toolbar:Help,Toolbar:Help),DISABLE,FLAT,TIP('Get Help'),ICON('HELP.GIF')
                       END
                     END
Web:CurFrame         &WbFrameClass

ThisWindow           CLASS(WindowManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
Kill                   PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
TakeAccepted           PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
TakeWindowEvent        PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
                     END

Toolbar              ToolbarClass
WebWindowManager     WbWindowManagerClass
WebWindow            CLASS(WbWindowClass)
Init                   PROCEDURE()                         ! Method added to host embed code
                     END

WebFrame             CLASS(WbFrameClass)
TakeEvent              PROCEDURE(),SIGNED,PROC,DERIVED     ! Method added to host embed code
                     END


  CODE
  GlobalResponse = ThisWindow.Run()                        ! Opens the window and starts an Accept Loop

!---------------------------------------------------------------------------
DefineListboxStyle ROUTINE
!|
!| This routine create all the styles to be shared in this window
!| It`s called after the window open
!|
!---------------------------------------------------------------------------
Menu::Menubar ROUTINE                                      ! Code for menu items on ?Menubar
Menu::Browse ROUTINE                                       ! Code for menu items on ?Browse
  CASE ACCEPTED()
  OF ?Customers
    START(BrowseCustomers, 50000)
  OF ?Products
    START(BrowseProducts, 50000)
  OF ?Orders
    START(BrowseOrders, 50000)
  END
Menu::Report ROUTINE                                       ! Code for menu items on ?Report
  CASE ACCEPTED()
  OF ?ReportPrintInvoice
    START(PrintInvoice, 50000)
  END

ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('Main')
  WebFrame.FrameWindow &= AppFrame
  SELF.Request = GlobalRequest                             ! Store the incoming request
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = 1
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors                              ! Set this windows ErrorManager to the global ErrorManager
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)                                     ! Clear GlobalRequest after storing locally
  CLEAR(GlobalResponse)
  SELF.Open(AppFrame)                                      ! Open window
  Do DefineListboxStyle
  IF (WebServer.IsEnabled())
    WebWindow.Init()
    WebWindowManager.Init(WebServer, WebWindow.IPageCreator, WebWindow.IWebResponseProcessor, 0{PROP:text} & ' (Main)')
    SELF.AddItem(WebWindow.WindowComponent)
    SELF.AddItem(WebWindowManager.WindowComponent)
  END
  SELF.SetAlerts()
  COMPILE ('**CW7**',_CWVER_=7000)
      AppFrame{PROP:TabBarVisible}  = False
  !**CW7**
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  SetWebActiveFrame()
  IF (WebServer.IsEnabled())
    POST(EVENT:NewPage)
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.TakeAccepted PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receive all EVENT:Accepted's
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
    CASE ACCEPTED()
    OF ?Toolbar:Top
    OROF ?Toolbar:PageUp
    OROF ?Toolbar:Up
    OROF ?Toolbar:Locate
    OROF ?Toolbar:Down
    OROF ?Toolbar:PageDown
    OROF ?Toolbar:Bottom
    OROF ?Toolbar:Select
    OROF ?Toolbar:Insert
    OROF ?Toolbar:Change
    OROF ?Toolbar:Delete
    OROF ?Toolbar:History
    OROF ?Toolbar:Help
      IF SYSTEM{PROP:Active} <> THREAD()
        POST(EVENT:Accepted,ACCEPTED(),SYSTEM{Prop:Active} )
        CYCLE
      END
    ELSE
      DO Menu::Menubar                                     ! Process menu items on ?Menubar menu
      DO Menu::Browse                                      ! Process menu items on ?Browse menu
      DO Menu::Report                                      ! Process menu items on ?Report menu
    END
  ReturnValue = PARENT.TakeAccepted()
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


ThisWindow.TakeWindowEvent PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receives all window specific events
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
  ReturnValue = PARENT.TakeWindowEvent()
    CASE EVENT()
    OF EVENT:OpenWindow
      SplashProcedureThread = START(SplashScreen)          ! Run the splash window procedure
    ELSE
      IF SplashProcedureThread
        IF EVENT() = Event:Accepted
          POST(Event:CloseWindow,,SplashProcedureThread)   ! Close the splash window
          SplashPRocedureThread = 0
        END
     END
    END
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


WebWindow.Init PROCEDURE

  CODE
  PARENT.Init
  SELF.SetFormatOptions(2, 2, 6, 13)
  SetWebActiveFrame(WebFrame)


WebFrame.TakeEvent PROCEDURE

ReturnValue          SIGNED,AUTO

FirstIteration       SIGNED(1)
  CODE
  ReturnValue = PARENT.TakeEvent()
  LOOP
    RETURN REPLY:NONE
  END
  ReturnValue = REPLY:BREAK
  RETURN ReturnValue

BrowseProducts PROCEDURE                                   ! Generated from procedure template - Window

CurrentTab           STRING(80)                            !
LocalRequest         LONG                                  !
FilesOpened          BYTE                                  !
BRW1::View:Browse    VIEW(Products)
                       PROJECT(PRO:Description)
                       PROJECT(PRO:ProductSKU)
                       PROJECT(PRO:PictureFile)
                       PROJECT(PRO:ProductNumber)
                     END
Queue:Browse:1       QUEUE                            !Queue declaration for browse/combo box using ?Browse:1
PRO:Description        LIKE(PRO:Description)          !List box control field - type derived from field
PRO:ProductSKU         LIKE(PRO:ProductSKU)           !List box control field - type derived from field
PRO:PictureFile        LIKE(PRO:PictureFile)          !Browse hot field - type derived from field
PRO:ProductNumber      LIKE(PRO:ProductNumber)        !Primary key field - type derived from field
Mark                   BYTE                           !Entry's marked status
ViewPosition           STRING(1024)                   !Entry's view position
                     END
QuickWindow          WINDOW('Browse Products '),AT(,,277,166),FONT('MS Sans Serif',8,,),CENTER,IMM,HVSCROLL,ICON('FLOW04.GIF'),HLP('~BrowseProducts'),PALETTE(254),SYSTEM,GRAY,RESIZE,MDI
                       SHEET,AT(2,0,274,164),USE(?CurrentTab)
                         TAB('Description')
                           PROMPT('Description:'),AT(13,16),USE(?PRO:Description:Prompt)
                           ENTRY(@s35),AT(55,16,85,10),USE(PRO:Description),MSG('Enter Product''s Description'),CAP
                         END
                         TAB('ProductSKU')
                           PROMPT('Product SKU:'),AT(8,16),USE(?PRO:ProductSKU:Prompt)
                           ENTRY(@s10),AT(58,16,55,10),USE(PRO:ProductSKU),MSG('User defined Product Number')
                         END
                       END
                       LIST,AT(10,28,151,115),USE(?Browse:1),IMM,VSCROLL,MSG('Browsing Records'),FORMAT('93L(2)|M~Description~@s35@45L(3)|M~Product SKU~L(1)@s10@'),FROM(Queue:Browse:1)
                       IMAGE,AT(172,28,97,115),USE(?Image1),CENTERED
                       BUTTON,AT(12,149,31,12),USE(?Print),FLAT,FONT(,,,FONT:bold),TIP('Print Selected Product'),ICON('Printer.gif')
                       BUTTON,AT(98,63,13,12),USE(?Help),HIDE,TIP('Get Help'),ICON(ICON:Help),STD(STD:Help)
                       BUTTON,AT(238,149,26,12),USE(?Close),FLAT,MSG('Exit Browse'),TIP('Exit Browse'),ICON('EXITS.GIF')
                     END
Web:CurFrame         &WbFrameClass

ThisWindow           CLASS(WindowManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
Kill                   PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
Run                    PROCEDURE(USHORT Number,BYTE Request),BYTE,PROC,DERIVED ! Method added to host embed code
                     END

Toolbar              ToolbarClass
WebWindowManager     WbWindowManagerClass
WebWindow            CLASS(WbWindowClass)
Init                   PROCEDURE()                         ! Method added to host embed code
                     END

Web:PRO:Description  CLASS(WbControlHtmlProperties)        ! Web Control Manager for ?PRO:Description
Init                   PROCEDURE(SIGNED Feq,SIGNED Container) ! Method added to host embed code
                     END

Web:PRO:ProductSKU   CLASS(WbControlHtmlProperties)        ! Web Control Manager for ?PRO:ProductSKU
Init                   PROCEDURE(SIGNED Feq,SIGNED Container) ! Method added to host embed code
                     END

Web:Browse:1         CLASS(WbControlHtmlProperties)        ! Web Control Manager for ?Browse:1
Init                   PROCEDURE(SIGNED Feq,SIGNED Container) ! Method added to host embed code
                     END

WebWindowProperty    CLASS(WbWindowHtmlProperties)
GetEmbedText           PROCEDURE(ASTRING embed),STRING,DERIVED ! Method added to host embed code
                     END

BRW1                 CLASS(BrowseClass)                    ! Browse using ?Browse:1
Q                      &Queue:Browse:1                !Reference to browse queue
Fetch                  PROCEDURE(BYTE Direction),DERIVED   ! Method added to host embed code
ResetSort              PROCEDURE(BYTE Force),BYTE,PROC,DERIVED ! Method added to host embed code
TakeNewSelection       PROCEDURE(),DERIVED                 ! Method added to host embed code
                     END

BRW1::Sort0:Locator  FilterLocatorClass                    ! Default Locator
BRW1::Sort1:Locator  IncrementalLocatorClass               ! Conditional Locator - CHOICE(?CurrentTab) = 2
BRW1::Sort0:StepClass StepStringClass                      ! Default Step Manager
BRW1::Sort1:StepClass StepStringClass                      ! Conditional Step Manager - CHOICE(?CurrentTab) = 2
Resizer              CLASS(WindowResizeClass)
Init                   PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False) ! Method added to host embed code
                     END


  CODE
? DEBUGHOOK(Products:Record)
  GlobalResponse = ThisWindow.Run()                        ! Opens the window and starts an Accept Loop

!---------------------------------------------------------------------------
DefineListboxStyle ROUTINE
!|
!| This routine create all the styles to be shared in this window
!| It`s called after the window open
!|
!---------------------------------------------------------------------------

ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('BrowseProducts')
  SELF.Request = GlobalRequest                             ! Store the incoming request
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?PRO:Description:Prompt
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors                              ! Set this windows ErrorManager to the global ErrorManager
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)                                     ! Clear GlobalRequest after storing locally
  CLEAR(GlobalResponse)
  IF SELF.Request = SelectRecord
     SELF.AddItem(?Close,RequestCancelled)                 ! Add the close control to the window manger
  ELSE
     SELF.AddItem(?Close,RequestCompleted)                 ! Add the close control to the window manger
  END
  Relate:Products.Open                                     ! File Products used by this procedure, so make sure it's RelationManager is open
  SELF.FilesOpened = True
  BRW1.Init(?Browse:1,Queue:Browse:1.ViewPosition,BRW1::View:Browse,Queue:Browse:1,Relate:Products,SELF) ! Initialize the browse manager
  SELF.Open(QuickWindow)                                   ! Open window
  Do DefineListboxStyle
  IF (WebServer.IsEnabled())
    WebWindow.Init()
    WebWindowManager.Init(WebServer, WebWindow.IPageCreator, WebWindow.IWebResponseProcessor, 0{PROP:text} & ' (BrowseProducts)')
    SELF.AddItem(WebWindow.WindowComponent)
    SELF.AddItem(WebWindowManager.WindowComponent)
  END
  QuickWindow{PROP:MinWidth}=403                           ! Restrict the minimum window width
  QuickWindow{PROP:MinHeight}=180                          ! Restrict the minimum window height
  Resizer.Init(AppStrategy:Spread)                         ! Controls will spread out as the window gets bigger
  SELF.AddItem(Resizer)                                    ! Add resizer to window manager
  BRW1.Q &= Queue:Browse:1
  BRW1::Sort1:StepClass.Init(+ScrollSort:AllowAlpha,ScrollBy:Runtime) ! Moveable thumb based upon PRO:ProductSKU for sort order 1
  BRW1.AddSortOrder(BRW1::Sort1:StepClass,PRO:KeyProductSKU) ! Add the sort order for PRO:KeyProductSKU for sort order 1
  BRW1.AddLocator(BRW1::Sort1:Locator)                     ! Browse has a locator for sort order 1
  BRW1::Sort1:Locator.Init(?PRO:ProductSKU,PRO:ProductSKU,1,BRW1) ! Initialize the browse locator using ?PRO:ProductSKU using key: PRO:KeyProductSKU , PRO:ProductSKU
  BRW1::Sort0:StepClass.Init(+ScrollSort:AllowAlpha,ScrollBy:Runtime) ! Moveable thumb based upon PRO:Description for sort order 2
  BRW1.AddSortOrder(BRW1::Sort0:StepClass,PRO:KeyDescription) ! Add the sort order for PRO:KeyDescription for sort order 2
  BRW1.AddLocator(BRW1::Sort0:Locator)                     ! Browse has a locator for sort order 2
  BRW1::Sort0:Locator.Init(?PRO:Description,PRO:Description,1,BRW1) ! Initialize the browse locator using ?PRO:Description using key: PRO:KeyDescription , PRO:Description
  BRW1::Sort0:Locator.FloatRight = 1
  BRW1.AddField(PRO:Description,BRW1.Q.PRO:Description)    ! Field PRO:Description is a hot field or requires assignment from browse
  BRW1.AddField(PRO:ProductSKU,BRW1.Q.PRO:ProductSKU)      ! Field PRO:ProductSKU is a hot field or requires assignment from browse
  BRW1.AddField(PRO:PictureFile,BRW1.Q.PRO:PictureFile)    ! Field PRO:PictureFile is a hot field or requires assignment from browse
  BRW1.AddField(PRO:ProductNumber,BRW1.Q.PRO:ProductNumber) ! Field PRO:ProductNumber is a hot field or requires assignment from browse
  BRW1.AddToolbarTarget(Toolbar)                           ! Browse accepts toolbar control
  BRW1.ToolbarItem.HelpButton = ?Help
  BRW1.PrintProcedure = 1
  BRW1.PrintControl = ?Print
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:Products.Close
  END
  IF (WebServer.IsEnabled())
    POST(EVENT:NewPage)
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.Run PROCEDURE(USHORT Number,BYTE Request)

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Run(Number,Request)
  IF SELF.Request = ViewRecord
    ReturnValue = RequestCancelled                         ! Always return RequestCancelled if the form was opened in ViewRecord mode
  ELSE
    GlobalRequest = Request
    PrintSelectProduct
    ReturnValue = GlobalResponse
  END
  RETURN ReturnValue


Web:PRO:Description.Init PROCEDURE(SIGNED Feq,SIGNED Container)

  CODE
  PARENT.Init(Feq,Container)
  SELF.SubmitOnChange = TRUE


Web:PRO:ProductSKU.Init PROCEDURE(SIGNED Feq,SIGNED Container)

  CODE
  PARENT.Init(Feq,Container)
  SELF.SubmitOnChange = TRUE


Web:Browse:1.Init PROCEDURE(SIGNED Feq,SIGNED Container)

  CODE
  PARENT.Init(Feq,Container)
  SELF.SubmitOnChange = TRUE


WebWindowProperty.GetEmbedText PROCEDURE(ASTRING embed)

ReturnValue          ANY

Target                  &IHtmlWriter,AUTO
  CODE
  Target &= IHtmlWriter:Create()
  CASE embed
  OF A:EmbedBeforeWindow
    ! center table and make it 600 pixels
    TARGET.Writeln('<div align="center"><center>')
    TARGET.Writeln('<Table width="600"><TR><TD>')
  OF A:EmbedAfterWindow
    ! closing tags
    TARGET.Writeln('</td></tr></Table>')
    TARGET.Writeln('</center></div>')
  END
  ReturnValue = PARENT.GetEmbedText(embed)
  ReturnValue = Target.GetText()
  Target.Release()
  RETURN ReturnValue


WebWindow.Init PROCEDURE

  CODE
  PARENT.Init
  SELF.SetFormatOptions(2, 2, 6, 13)
  WebWindowProperty.Init()
  SELF.AddControl(WebWindowProperty.IControlToHtml)
  Web:PRO:Description.Init(?PRO:Description, FEQ:Unknown)
  SELF.AddControl(Web:PRO:Description.IControlToHtml)
  Web:PRO:ProductSKU.Init(?PRO:ProductSKU, FEQ:Unknown)
  SELF.AddControl(Web:PRO:ProductSKU.IControlToHtml)
  Web:Browse:1.Init(?Browse:1, FEQ:Unknown)
  SELF.AddControl(Web:Browse:1.IControlToHtml)
  IF (WebServer.IsEnabled())
    Web:CurFrame &= GetWebActiveFrame()
    Web:CurFrame.CopyControlsToWindow(TRUE, TRUE)
  END


BRW1.Fetch PROCEDURE(BYTE Direction)

GreenBarIndex   LONG
  CODE
  PARENT.Fetch(Direction)


BRW1.ResetSort PROCEDURE(BYTE Force)

ReturnValue          BYTE,AUTO

  CODE
  IF CHOICE(?CurrentTab) = 2
    RETURN SELF.SetSort(1,Force)
  ELSE
    RETURN SELF.SetSort(2,Force)
  END
  ReturnValue = PARENT.ResetSort(Force)
  RETURN ReturnValue


BRW1.TakeNewSelection PROCEDURE

  CODE
  PARENT.TakeNewSelection
  !Display image
  ?Image1{PROP:TEXT} = Products.Record.PictureFile


Resizer.Init PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)


  CODE
  PARENT.Init(AppStrategy,SetWindowMinSize,SetWindowMaxSize)
  SELF.SetParentDefaults()                                 ! Calculate default control parent-child relationships based upon their positions on the window

SplashScreen PROCEDURE                                     ! Generated from procedure template - Splash

LocalRequest         LONG                                  !
FilesOpened          BYTE                                  !
window               WINDOW,AT(,,145,134),FONT('MS Sans Serif',8,,FONT:regular),COLOR(080FFFFH),CENTER,PALETTE(256),GRAY,NOFRAME,MDI
                       STRING('INVOICE SYSTEM'),AT(11,7,125,17),USE(?String3),TRN,CENTER,FONT('MS Sans Serif',16,,,CHARSET:ANSI)
                       IMAGE('SSANTHUR.GIF'),AT(25,29,88,84),USE(?Image1)
                       STRING('Created using Clarion'),AT(5,117,135,12),USE(?String1),TRN,CENTER,FONT('MS Sans Serif',10,,FONT:regular,CHARSET:ANSI)
                     END
Web:CurFrame         &WbFrameClass

ThisWindow           CLASS(WindowManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
Kill                   PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
TakeWindowEvent        PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
                     END

Toolbar              ToolbarClass
WebWindowManager     WbWindowManagerClass
WebWindow            CLASS(WbWindowClass)
GenerateHTML           PROCEDURE(STRING Filename),DERIVED  ! Method added to host embed code
Init                   PROCEDURE()                         ! Method added to host embed code
                     END

Web:String3          CLASS(WbControlHtmlProperties)        ! Web Control Manager for ?String3
GetEmbedText           PROCEDURE(ASTRING embed),STRING,DERIVED ! Method added to host embed code
                     END

Web:String1          CLASS(WbControlHtmlProperties)        ! Web Control Manager for ?String1
GetEmbedText           PROCEDURE(ASTRING embed),STRING,DERIVED ! Method added to host embed code
                     END

WebWindowProperty    CLASS(WbWindowHtmlProperties)
GetEmbedText           PROCEDURE(ASTRING embed),STRING,DERIVED ! Method added to host embed code
GetSkeletonAttr        PROCEDURE(SIGNED whichAttr),STRING,DERIVED ! Method added to host embed code
Init                   PROCEDURE()                         ! Method added to host embed code
                     END


  CODE
  GlobalResponse = ThisWindow.Run()                        ! Opens the window and starts an Accept Loop

!---------------------------------------------------------------------------
DefineListboxStyle ROUTINE
!|
!| This routine create all the styles to be shared in this window
!| It`s called after the window open
!|
!---------------------------------------------------------------------------

ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('SplashScreen')
  SELF.Request = GlobalRequest                             ! Store the incoming request
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?String3
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors                              ! Set this windows ErrorManager to the global ErrorManager
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)                                     ! Clear GlobalRequest after storing locally
  CLEAR(GlobalResponse)
  SELF.Open(window)                                        ! Open window
  Do DefineListboxStyle
  IF (WebServer.IsEnabled())
    WebWindow.Init()
    WebWindowManager.Init(WebServer, WebWindow.IPageCreator, WebWindow.IWebResponseProcessor, 0{PROP:text} & ' (SplashScreen)')
    SELF.AddItem(WebWindow.WindowComponent)
    SELF.AddItem(WebWindowManager.WindowComponent)
  END
  TARGET{Prop:Timer} = 1000                                ! Close window on timer event, so configure timer
  TARGET{Prop:Alrt,255} = MouseLeft                        ! Alert mouse clicks that will close window
  TARGET{Prop:Alrt,254} = MouseLeft2
  TARGET{Prop:Alrt,253} = MouseRight
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF (WebServer.IsEnabled())
    POST(EVENT:NewPage)
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.TakeWindowEvent PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receives all window specific events
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
  ReturnValue = PARENT.TakeWindowEvent()
    CASE EVENT()
    OF EVENT:AlertKey
      CASE KEYCODE()
      OF MouseLeft
      OROF MouseLeft2
      OROF MouseRight
        POST(Event:CloseWindow)                            ! Splash window will close on mouse click
      END
    OF EVENT:LoseFocus
        POST(Event:CloseWindow)                            ! Splash window will close when focus is lost
    OF Event:Timer
      POST(Event:CloseWindow)                              ! Splash window will close on event timer
    OF Event:AlertKey
      CASE KEYCODE()                                       ! Splash window will close on mouse click
      OF MouseLeft
      OROF MouseLeft2
      OROF MouseRight
        POST(Event:CloseWindow)
      END
    ELSE
    END
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


Web:String3.GetEmbedText PROCEDURE(ASTRING embed)

ReturnValue          ANY

Target                  &IHtmlWriter,AUTO
  CODE
  Target &= IHtmlWriter:Create()
  CASE embed
  OF A:EmbedBeforeControl
      Target.Writeln('<<CENTER><<FONT="MS SANS SERIF"><<B>')
  OF A:EmbedAfterControl
      Target.Writeln('<</CENTER><</FONT><</B>')
  END
  ReturnValue = PARENT.GetEmbedText(embed)
  ReturnValue = Target.GetText()
  Target.Release()
  RETURN ReturnValue


Web:String1.GetEmbedText PROCEDURE(ASTRING embed)

ReturnValue          ANY

Target                  &IHtmlWriter,AUTO
  CODE
  Target &= IHtmlWriter:Create()
  CASE embed
  OF A:EmbedBeforeControl
      Target.Writeln('<<CENTER><<FONT="MS SANS SERIF">')
  OF A:EmbedAfterControl
      Target.Writeln('<</CENTER><</FONT>')
  END
  ReturnValue = PARENT.GetEmbedText(embed)
  ReturnValue = Target.GetText()
  Target.Release()
  RETURN ReturnValue


WebWindowProperty.GetEmbedText PROCEDURE(ASTRING embed)

ReturnValue          ANY

Target                  &IHtmlWriter,AUTO
  CODE
  Target &= IHtmlWriter:Create()
  CASE embed
  OF A:EmbedBeforeWindow
    ! center table and make it 400 pixels
    TARGET.Writeln('<div align="center"><center>')
    TARGET.Writeln('<Table width="400"><TR><TD>')
  OF A:EmbedAfterWindow
    ! closing tags
    TARGET.Writeln('</td></tr></Table>')
    TARGET.Writeln('</center></div>')
  END
  ReturnValue = PARENT.GetEmbedText(embed)
  ReturnValue = Target.GetText()
  Target.Release()
  RETURN ReturnValue


WebWindowProperty.GetSkeletonAttr PROCEDURE(SIGNED whichAttr)

ReturnValue          ANY

  CODE
  ReturnValue = PARENT.GetSkeletonAttr(whichAttr)
  CASE whichAttr
  OF SkeletonAttr:Capabilities
    ReturnValue = ReturnValue & ',splash'
  END
  RETURN ReturnValue


WebWindowProperty.Init PROCEDURE

  CODE
  PARENT.Init
  SELF.SetTimeOut(10)


WebWindow.GenerateHTML PROCEDURE(STRING Filename)

  CODE
  PARENT.GenerateHTML(Filename)
  POST(EVENT:CloseWindow)


WebWindow.Init PROCEDURE

  CODE
  PARENT.Init
  SELF.SetFormatOptions(2, 2, 6, 13)
  WebWindowProperty.Init()
  SELF.AddControl(WebWindowProperty.IControlToHtml)
  Web:String3.Init(?String3, FEQ:Unknown)
  SELF.AddControl(Web:String3.IControlToHtml)
  Web:String1.Init(?String1, FEQ:Unknown)
  SELF.AddControl(Web:String1.IControlToHtml)

BrowseDetails PROCEDURE                                    ! Generated from procedure template - Window

CurrentTab           STRING(80)                            !
LocalRequest         LONG                                  !
FilesOpened          BYTE                                  !
LOC:Backorder        STRING(3)                             !
TaxString            STRING(8)                             !
DiscountString       STRING(8)                             !
TotalTax             DECIMAL(7,2)                          !
TotalDiscount        DECIMAL(7,2)                          !
TotalCost            DECIMAL(7,2)                          !
LOC:CustName         STRING(45)                            !
BRW5::View:Browse    VIEW(Detail)
                       PROJECT(DTL:QuantityOrdered)
                       PROJECT(DTL:Price)
                       PROJECT(DTL:OrderNumber)
                       PROJECT(DTL:CustNumber)
                       PROJECT(DTL:LineNumber)
                       PROJECT(DTL:ProductNumber)
                       JOIN(ORD:KeyCustOrderNumber,DTL:CustNumber,DTL:OrderNumber)
                         PROJECT(ORD:OrderNumber)
                         PROJECT(ORD:CustNumber)
                         JOIN(CUS:KeyCustNumber,ORD:CustNumber)
                           PROJECT(CUS:CustNumber)
                         END
                       END
                       JOIN(PRO:KeyProductNumber,DTL:ProductNumber)
                         PROJECT(PRO:Description)
                         PROJECT(PRO:ProductNumber)
                       END
                     END
Queue:Browse         QUEUE                            !Queue declaration for browse/combo box using ?List
PRO:Description        LIKE(PRO:Description)          !List box control field - type derived from field
DTL:QuantityOrdered    LIKE(DTL:QuantityOrdered)      !List box control field - type derived from field
DTL:Price              LIKE(DTL:Price)                !List box control field - type derived from field
LOC:Backorder          LIKE(LOC:Backorder)            !List box control field - type derived from local data
GLOT:CustName          LIKE(GLOT:CustName)            !Browse hot field - type derived from global data
ORD:OrderNumber        LIKE(ORD:OrderNumber)          !Browse hot field - type derived from field
DTL:OrderNumber        LIKE(DTL:OrderNumber)          !Browse hot field - type derived from field
DTL:CustNumber         LIKE(DTL:CustNumber)           !Primary key field - type derived from field
DTL:LineNumber         LIKE(DTL:LineNumber)           !Primary key field - type derived from field
ORD:CustNumber         LIKE(ORD:CustNumber)           !Related join file key field - type derived from field
CUS:CustNumber         LIKE(CUS:CustNumber)           !Related join file key field - type derived from field
PRO:ProductNumber      LIKE(PRO:ProductNumber)        !Related join file key field - type derived from field
Mark                   BYTE                           !Entry's marked status
ViewPosition           STRING(1024)                   !Entry's view position
                     END
QuickWindow          WINDOW('Browse Order Detail'),AT(,,225,109),FONT('MS Sans Serif',8,,),CENTER,IMM,ICON('BOOK.GIF'),HLP('~BrowseOrdersforaCustomer'),SYSTEM,GRAY,RESIZE,MDI
                       GROUP,AT(3,0,219,16),USE(?Group3),BOXED,BEVEL(1,-1)
                         STRING('Customer:'),AT(5,3,34,10),USE(?String16)
                         STRING(@s45),AT(39,3,106,10),USE(LOC:CustName)
                         STRING('Order #:'),AT(152,3,29,10),USE(?String22)
                         STRING(@n07),AT(182,3),USE(ORD:OrderNumber)
                       END
                       SHEET,AT(3,16,220,89),USE(?Sheet3),WIZARD
                         TAB('By: Order Line #'),USE(?Tab1)
                         END
                       END
                       LIST,AT(8,22,210,58),USE(?List),IMM,VSCROLL,MSG('Browsing Records'),FORMAT('89L(2)|M~Description~L(1)@s35@36L|M~Quantity~@n9.2B@40L|M~Price~@n$10.2B@37L(11)' &|
   '|M~Backorder~L(1)@s3@'),FROM(Queue:Browse)
                       BUTTON,AT(192,86,27,14),USE(?Close),FLAT,RIGHT,FONT('MS Serif',10,,FONT:bold),MSG('Close the browse'),TIP('Close the browse'),ICON('EXITS.GIF')
                     END
Web:CurFrame         &WbFrameClass

ThisWindow           CLASS(WindowManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
Kill                   PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
                     END

Toolbar              ToolbarClass
WebWindowManager     WbWindowManagerClass
WebWindow            CLASS(WbWindowClass)
Init                   PROCEDURE()                         ! Method added to host embed code
                     END

Web:List             CLASS(WbControlHtmlProperties)        ! Web Control Manager for ?List
Init                   PROCEDURE(SIGNED Feq,SIGNED Container) ! Method added to host embed code
                     END

WebWindowProperty    CLASS(WbWindowHtmlProperties)
GetEmbedText           PROCEDURE(ASTRING embed),STRING,DERIVED ! Method added to host embed code
                     END

BRW5                 CLASS(BrowseClass)                    ! Browse using ?List
Q                      &Queue:Browse                  !Reference to browse queue
Fetch                  PROCEDURE(BYTE Direction),DERIVED   ! Method added to host embed code
ResetFromView          PROCEDURE(),DERIVED                 ! Method added to host embed code
SetQueueRecord         PROCEDURE(),DERIVED                 ! Method added to host embed code
                     END

BRW5::Sort0:Locator  StepLocatorClass                      ! Default Locator
Resizer              CLASS(WindowResizeClass)
Init                   PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False) ! Method added to host embed code
                     END


  CODE
? DEBUGHOOK(Detail:Record)
  GlobalResponse = ThisWindow.Run()                        ! Opens the window and starts an Accept Loop

!---------------------------------------------------------------------------
DefineListboxStyle ROUTINE
!|
!| This routine create all the styles to be shared in this window
!| It`s called after the window open
!|
!---------------------------------------------------------------------------

ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('BrowseDetails')
  SELF.Request = GlobalRequest                             ! Store the incoming request
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?String16
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors                              ! Set this windows ErrorManager to the global ErrorManager
  BIND('LOC:Backorder',LOC:Backorder)                      ! Added by: BrowseBox(ABC)
  BIND('GLOT:CustName',GLOT:CustName)                      ! Added by: BrowseBox(ABC)
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)                                     ! Clear GlobalRequest after storing locally
  CLEAR(GlobalResponse)
  IF SELF.Request = SelectRecord
     SELF.AddItem(?Close,RequestCancelled)                 ! Add the close control to the window manger
  ELSE
     SELF.AddItem(?Close,RequestCompleted)                 ! Add the close control to the window manger
  END
  Relate:Detail.Open                                       ! File Detail used by this procedure, so make sure it's RelationManager is open
  SELF.FilesOpened = True
  BRW5.Init(?List,Queue:Browse.ViewPosition,BRW5::View:Browse,Queue:Browse,Relate:Detail,SELF) ! Initialize the browse manager
  SELF.Open(QuickWindow)                                   ! Open window
  Do DefineListboxStyle
  IF (WebServer.IsEnabled())
    WebWindow.Init()
    WebWindowManager.Init(WebServer, WebWindow.IPageCreator, WebWindow.IWebResponseProcessor, 0{PROP:text} & ' (BrowseDetails)')
    SELF.AddItem(WebWindow.WindowComponent)
    SELF.AddItem(WebWindowManager.WindowComponent)
  END
  QuickWindow{PROP:MinWidth}=375                           ! Restrict the minimum window width
  QuickWindow{PROP:MinHeight}=193                          ! Restrict the minimum window height
  Resizer.Init(AppStrategy:Spread)                         ! Controls will spread out as the window gets bigger
  SELF.AddItem(Resizer)                                    ! Add resizer to window manager
  BRW5.Q &= Queue:Browse
  BRW5.AddSortOrder(,DTL:KeyDetails)                       ! Add the sort order for DTL:KeyDetails for sort order 1
  BRW5.AddRange(DTL:CustNumber,Relate:Detail,Relate:Orders) ! Add file relationship range limit for sort order 1
  BRW5.AddLocator(BRW5::Sort0:Locator)                     ! Browse has a locator for sort order 1
  BRW5::Sort0:Locator.Init(,DTL:OrderNumber,1,BRW5)        ! Initialize the browse locator using  using key: DTL:KeyDetails , DTL:OrderNumber
  BRW5.SetFilter('(DTL:OrderNumber = ORD:OrderNumber)')    ! Apply filter expression to browse
  BRW5.AddField(PRO:Description,BRW5.Q.PRO:Description)    ! Field PRO:Description is a hot field or requires assignment from browse
  BRW5.AddField(DTL:QuantityOrdered,BRW5.Q.DTL:QuantityOrdered) ! Field DTL:QuantityOrdered is a hot field or requires assignment from browse
  BRW5.AddField(DTL:Price,BRW5.Q.DTL:Price)                ! Field DTL:Price is a hot field or requires assignment from browse
  BRW5.AddField(LOC:Backorder,BRW5.Q.LOC:Backorder)        ! Field LOC:Backorder is a hot field or requires assignment from browse
  BRW5.AddField(GLOT:CustName,BRW5.Q.GLOT:CustName)        ! Field GLOT:CustName is a hot field or requires assignment from browse
  BRW5.AddField(ORD:OrderNumber,BRW5.Q.ORD:OrderNumber)    ! Field ORD:OrderNumber is a hot field or requires assignment from browse
  BRW5.AddField(DTL:OrderNumber,BRW5.Q.DTL:OrderNumber)    ! Field DTL:OrderNumber is a hot field or requires assignment from browse
  BRW5.AddField(DTL:CustNumber,BRW5.Q.DTL:CustNumber)      ! Field DTL:CustNumber is a hot field or requires assignment from browse
  BRW5.AddField(DTL:LineNumber,BRW5.Q.DTL:LineNumber)      ! Field DTL:LineNumber is a hot field or requires assignment from browse
  BRW5.AddField(ORD:CustNumber,BRW5.Q.ORD:CustNumber)      ! Field ORD:CustNumber is a hot field or requires assignment from browse
  BRW5.AddField(CUS:CustNumber,BRW5.Q.CUS:CustNumber)      ! Field CUS:CustNumber is a hot field or requires assignment from browse
  BRW5.AddField(PRO:ProductNumber,BRW5.Q.PRO:ProductNumber) ! Field PRO:ProductNumber is a hot field or requires assignment from browse
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:Detail.Close
  END
  IF (WebServer.IsEnabled())
    POST(EVENT:NewPage)
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


Web:List.Init PROCEDURE(SIGNED Feq,SIGNED Container)

  CODE
  PARENT.Init(Feq,Container)
  SELF.SubmitOnChange = TRUE


WebWindowProperty.GetEmbedText PROCEDURE(ASTRING embed)

ReturnValue          ANY

Target                  &IHtmlWriter,AUTO
  CODE
  Target &= IHtmlWriter:Create()
  CASE embed
  OF A:EmbedBeforeWindow
    ! center table and make it 600 pixels
    TARGET.Writeln('<div align="center"><center>')
    TARGET.Writeln('<Table width="600"><TR><TD>')
  OF A:EmbedAfterWindow
    ! closing tags
    TARGET.Writeln('</td></tr></Table>')
    TARGET.Writeln('</center></div>')
  END
  ReturnValue = PARENT.GetEmbedText(embed)
  ReturnValue = Target.GetText()
  Target.Release()
  RETURN ReturnValue


WebWindow.Init PROCEDURE

  CODE
  PARENT.Init
  SELF.SetFormatOptions(2, 2, 6, 13)
  WebWindowProperty.Init()
  SELF.AddControl(WebWindowProperty.IControlToHtml)
  Web:List.Init(?List, FEQ:Unknown)
  SELF.AddControl(Web:List.IControlToHtml)
  IF (WebServer.IsEnabled())
    Web:CurFrame &= GetWebActiveFrame()
    Web:CurFrame.CopyControlsToWindow(TRUE, TRUE)
  END


BRW5.Fetch PROCEDURE(BYTE Direction)

GreenBarIndex   LONG
  CODE
  PARENT.Fetch(Direction)


BRW5.ResetFromView PROCEDURE

TotalTax:Sum         REAL                                  ! Sum variable for browse totals
TotalDiscount:Sum    REAL                                  ! Sum variable for browse totals
TotalCost:Sum        REAL                                  ! Sum variable for browse totals
  CODE
  SETCURSOR(Cursor:Wait)
  Relate:Detail.SetQuickScan(1)
  SELF.Reset
  IF SELF.UseMRP
     IF SELF.View{PROP:IPRequestCount} = 0
          SELF.View{PROP:IPRequestCount} = 60
     END
  END
  LOOP
    IF SELF.UseMRP
       IF SELF.View{PROP:IPRequestCount} = 0
            SELF.View{PROP:IPRequestCount} = 60
       END
    END
    CASE SELF.Next()
    OF Level:Notify
      BREAK
    OF Level:Fatal
      SETCURSOR()
      RETURN
    END
    SELF.SetQueueRecord
    TotalTax:Sum += DTL:TaxPaid
    TotalDiscount:Sum += DTL:Discount
    TotalCost:Sum += DTL:TotalCost
  END
  SELF.View{PROP:IPRequestCount} = 0
  TotalTax = TotalTax:Sum
  TotalDiscount = TotalDiscount:Sum
  TotalCost = TotalCost:Sum
  PARENT.ResetFromView
  Relate:Detail.SetQuickScan(0)
  SETCURSOR()


BRW5.SetQueueRecord PROCEDURE

  CODE
  IF (DTL:BackOrdered)
    LOC:Backorder = 'Yes'
  ELSE
    LOC:Backorder = 'No'
  END
  LOC:CustName = CLIP(CUS:FirstName) & ' ' & CLIP(CUS:LastName)
  PARENT.SetQueueRecord
  
  SELF.Q.LOC:Backorder = LOC:Backorder                     !Assign formula result to display queue


Resizer.Init PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)


  CODE
  PARENT.Init(AppStrategy,SetWindowMinSize,SetWindowMaxSize)
  SELF.SetParentDefaults()                                 ! Calculate default control parent-child relationships based upon their positions on the window

PrintInvoice PROCEDURE                                     ! Generated from procedure template - Report

LocalRequest         LONG                                  !
FilesOpened          BYTE                                  !
ExtendPrice          DECIMAL(7,2)                          !
LOC:CCSZ             STRING(35)                            !
Progress:Thermometer BYTE                                  !
PageNo               STRING(4)                             !
Process:View         VIEW(Orders)
                       PROJECT(ORD:CustNumber)
                       PROJECT(ORD:InvoiceNumber)
                       PROJECT(ORD:OrderDate)
                       PROJECT(ORD:OrderNumber)
                       PROJECT(ORD:ShipAddress1)
                       PROJECT(ORD:ShipAddress2)
                       PROJECT(ORD:ShipCity)
                       PROJECT(ORD:ShipState)
                       PROJECT(ORD:ShipToName)
                       PROJECT(ORD:ShipZip)
                       JOIN(CUS:KeyCustNumber,ORD:CustNumber)
                         PROJECT(CUS:Address1)
                         PROJECT(CUS:Address2)
                         PROJECT(CUS:City)
                         PROJECT(CUS:FirstName)
                         PROJECT(CUS:LastName)
                         PROJECT(CUS:State)
                         PROJECT(CUS:ZipCode)
                       END
                       JOIN(DTL:KeyDetails,ORD:CustNumber,ORD:OrderNumber)
                         PROJECT(DTL:CustNumber)
                         PROJECT(DTL:Discount)
                         PROJECT(DTL:OrderNumber)
                         PROJECT(DTL:Price)
                         PROJECT(DTL:QuantityOrdered)
                         PROJECT(DTL:TaxPaid)
                         PROJECT(DTL:TotalCost)
                         PROJECT(DTL:ProductNumber)
                         JOIN(PRO:KeyProductNumber,DTL:ProductNumber)
                           PROJECT(PRO:Description)
                           PROJECT(PRO:Price)
                           PROJECT(PRO:ProductSKU)
                         END
                       END
                     END
ProgressWindow       WINDOW('Report Progress...'),AT(,,142,59),CENTER,TIMER(1),GRAY,DOUBLE
                       PROGRESS,USE(Progress:Thermometer),AT(15,15,111,12),RANGE(0,100)
                       STRING(''),AT(0,3,141,10),USE(?Progress:UserString),CENTER
                       STRING(''),AT(0,30,141,10),USE(?Progress:PctText),CENTER
                       BUTTON('Cancel'),AT(45,42,48,15),USE(?Progress:Cancel),FLAT,LEFT,TIP('Cancel printing'),ICON(ICON:NoPrint)
                     END

Report               REPORT,AT(500,4500,7000,4475),PRE(RPT),FONT('MS Sans Serif',10,,FONT:regular),THOUS
                       HEADER,AT(500,917,7000,3583),USE(?unnamed:2)
                         BOX,AT(2552,10,1750,354),USE(?Box7),ROUND,COLOR(COLOR:Black),LINEWIDTH(10)
                         BOX,AT(52,1458,3885,260),USE(?Box4),ROUND,COLOR(COLOR:Black),LINEWIDTH(5)
                         IMAGE('RANTHUR.GIF'),AT(4781,208,1583,1490),USE(?Image1)
                         LINE,AT(2656,365,1458,0),USE(?Line7),COLOR(COLOR:Black),LINEWIDTH(3)
                         BOX,AT(52,625,3167,323),USE(?Box8),ROUND,COLOR(COLOR:Black),LINEWIDTH(5)
                         STRING('INVOICE'),AT(2594,31,1625,302),USE(?String35),CENTER,FONT('MS Sans Serif',24,COLOR:Navy,FONT:bold,CHARSET:ANSI)
                         STRING(@s20),AT(83,646,3104,271),USE(COM:Name),FONT('MS Sans Serif',18,,FONT:bold)
                         BOX,AT(52,948,3885,260),USE(?Box9),ROUND,COLOR(COLOR:Black),LINEWIDTH(5)
                         STRING(@s35),AT(83,990,3760,188),USE(COM:Address),FONT('MS Sans Serif',12,,FONT:bold)
                         BOX,AT(52,1208,3885,260),USE(?Box10),ROUND,COLOR(COLOR:Black),LINEWIDTH(5)
                         STRING(@s35),AT(83,1250,3792,188),USE(LOC:CCSZ),FONT('MS Sans Serif',12,,FONT:bold)
                         STRING(@P(###) ###-####P),AT(833,1479,1469,229),USE(COM:Phone),CENTER,FONT('MS Sans Serif',12,,FONT:bold,CHARSET:ANSI)
                         GROUP,AT(115,1844,6844,438),USE(?Group1),BOXED,TRN
                         END
                         STRING('Phone:'),AT(83,1479,719,229),USE(?String41),TRN,FONT('MS Sans Serif',12,,FONT:bold,CHARSET:ANSI)
                         STRING('Product SKU'),AT(104,3333,917,198),USE(?String17),TRN
                         STRING('Product Description'),AT(1042,3333,2083,198),USE(?String18),TRN
                         STRING('Quantity'),AT(4875,3333,729,198),USE(?String20),TRN,RIGHT(50)
                         STRING('Extension'),AT(5854,3333,781,198),USE(?String21),TRN,RIGHT(50)
                         LINE,AT(83,3542,6865,0),USE(?Line2),COLOR(COLOR:Black),LINEWIDTH(3)
                         STRING('Price'),AT(4083,3333,406,198),USE(?String19),TRN
                         STRING('Invoice #:'),AT(177,1958,990,250),USE(?String15),TRN,FONT('MS Sans Serif',14,COLOR:Maroon,FONT:bold,CHARSET:ANSI)
                         STRING('Order Date:'),AT(3781,1958,1219,250),USE(?String33),TRN,FONT('MS Sans Serif',14,COLOR:Maroon,FONT:bold,CHARSET:ANSI)
                         STRING(@d1),AT(4990,2021,729,177),USE(ORD:OrderDate),TRN,CENTER
                         STRING(@n07),AT(1125,2021,729,177),USE(ORD:InvoiceNumber),TRN,CENTER
                         STRING(@s35),AT(3760,2604,2948,167),USE(GLOT:ShipName)
                         STRING(@s45),AT(3760,2771,3125,167),USE(GLOT:ShipAddress)
                         STRING(@s40),AT(3760,2927,3125,167),USE(GLOT:ShipCSZ)
                         LINE,AT(3656,3135,3302,0),USE(?Line8:2),COLOR(COLOR:Black)
                         LINE,AT(125,3135,3302,0),USE(?Line8:4),COLOR(COLOR:Black)
                         STRING(@s35),AT(208,2604,3083,167),USE(GLOT:CustName)
                         LINE,AT(-31880,2625,0,604),USE(?Line12),COLOR(COLOR:Black)
                         STRING(@s45),AT(208,2771,3125,167),USE(GLOT:CustAddress)
                         STRING(@s40),AT(208,2927,3000,167),USE(GLOT:CusCSZ)
                         LINE,AT(83,3281,6865,0),USE(?Line1),COLOR(COLOR:Black),LINEWIDTH(3)
                         STRING('Ship To:'),AT(3760,2313,750,198),USE(?String31),FONT(,11,,FONT:bold)
                         LINE,AT(3417,2521,0,625),USE(?Line13),COLOR(COLOR:Black)
                         LINE,AT(125,2521,0,625),USE(?Line13:2),COLOR(COLOR:Black)
                         LINE,AT(125,2521,3302,0),USE(?Line8:3),COLOR(COLOR:Black)
                         LINE,AT(3656,2521,3302,0),USE(?Line8),COLOR(COLOR:Black)
                         LINE,AT(6958,2521,0,625),USE(?Line13:4),COLOR(COLOR:Black)
                         LINE,AT(3656,2521,0,625),USE(?Line13:3),COLOR(COLOR:Black)
                         STRING('Sold To:'),AT(208,2313,750,198),USE(?String32),FONT(,11,,FONT:bold)
                       END
break1                 BREAK(ORD:InvoiceNumber),USE(?unnamed:4)
detail                   DETAIL,AT(,,,242),USE(?detail)
                           STRING(@n$14.2B),AT(5406,21,83,52),USE(DTL:TotalCost),TRN,HIDE
                           STRING(@n$10.2B),AT(5500,10,135,52),USE(DTL:Discount),TRN,HIDE
                           STRING(@s10),AT(115,42,896,167),USE(PRO:ProductSKU)
                           STRING(@s35),AT(1083,42,2594,167),USE(PRO:Description)
                           STRING(@n7),AT(5073,42,635,167),USE(DTL:QuantityOrdered),RIGHT(100)
                           STRING(@n$10.2),AT(5896,42,823,167),USE(ExtendPrice),DECIMAL(250)
                           STRING(@n$10.2),AT(3990,42,771,167),USE(PRO:Price),DECIMAL(250)
                           STRING(@n$10.2B),AT(5635,10,63,52),USE(DTL:TaxPaid),TRN,HIDE
                         END
                         FOOTER,PAGEAFTER(-1),AT(,,,1025),USE(?unnamed:3)
                           LINE,AT(63,31,6865,0),USE(?Line3),COLOR(COLOR:Black),LINEWIDTH(3)
                           STRING('Sub-total:'),AT(4948,83,813,198),USE(?String23),TRN,LEFT(50),FONT(,,,FONT:bold)
                           STRING(@n$10.2),AT(5958,83,844,198),SUM,RESET(break1),USE(ExtendPrice,,?ExtendPrice:2),TRN,DECIMAL(250)
                           STRING('Discount:'),AT(4948,271,781,167),USE(?String24),LEFT(50)
                           STRING(@n$10.2B),AT(5948,271,844,167),SUM,RESET(break1),USE(DTL:Discount,,?DTL:Discount:2),DECIMAL(250)
                           STRING('NOTE:   Product on Back-Order will be available in 4 days.'),AT(94,354,3844,240),USE(?NoteString),CENTER,FONT('MS Sans Serif',10,,)
                           STRING('Tax:'),AT(4948,438,760,167),USE(?String27),LEFT(50)
                           STRING(@n$10.2),AT(5948,438,844,167),SUM,RESET(break1),USE(DTL:TaxPaid,,?DTL:TaxPaid:2),DECIMAL(250)
                           LINE,AT(5802,677,962,0),USE(?Line4),COLOR(COLOR:Black),LINEWIDTH(3)
                           STRING('Total:'),AT(4948,708,583,198),USE(?String30),TRN,LEFT(50),FONT(,,,FONT:bold)
                           STRING(@n$14.2),AT(5729,708,1063,208),SUM,RESET(break1),USE(DTL:TotalCost,,?DTL:TotalCost:2),TRN,DECIMAL(250)
                           LINE,AT(5792,917,962,0),USE(?Line5),COLOR(COLOR:Black),LINEWIDTH(3)
                           LINE,AT(5781,958,962,0),USE(?Line6),COLOR(COLOR:Black),LINEWIDTH(3)
                         END
                       END
                       FOOTER,AT(500,8969,7000,383),USE(?unnamed)
                         STRING('Page No:'),AT(6063,83),USE(?String43),TRN
                         STRING('Thank You For Your Order, Please Call Again.'),AT(1677,83,3490,198),USE(?String22),CENTER,FONT('MS Sans Serif',10,,FONT:bold)
                         STRING(@s4),AT(6677,83,219,208),PAGENO,USE(?PageNo)
                         BOX,AT(1604,52,3625,260),USE(?Box11),ROUND,COLOR(COLOR:Black),LINEWIDTH(5)
                       END
                     END
ThisWindow           CLASS(ReportManager)
AskPreview             PROCEDURE(),DERIVED                 ! Method added to host embed code
Init                   PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
Kill                   PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
Next                   PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
TakeCloseEvent         PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
                     END

ThisReport           CLASS(ProcessClass)                   ! Process Manager
TakeRecord             PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
                     END

ProgressMgr          StepLongClass                         ! Progress Manager
Previewer            PrintPreviewClass                     ! Print Previewer

  CODE
? DEBUGHOOK(Company:Record)
? DEBUGHOOK(Orders:Record)
  GlobalResponse = ThisWindow.Run()                        ! Opens the window and starts an Accept Loop

!---------------------------------------------------------------------------
DefineListboxStyle ROUTINE
!|
!| This routine create all the styles to be shared in this window
!| It`s called after the window open
!|
!---------------------------------------------------------------------------

ThisWindow.AskPreview PROCEDURE

  CODE
  IF (WebServer.IsEnabled())
    ENDPAGE(SELF.Report)
    WebPreview(WebServer,SELF.PreviewQueue,'',0,0)
    RETURN
  END
  PARENT.AskPreview


ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('PrintInvoice')
  WebFilesManager.SelectTarget(Secure:None)
  SELF.Request = GlobalRequest                             ! Store the incoming request
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?Progress:Thermometer
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors                              ! Set this windows ErrorManager to the global ErrorManager
  BIND('GLOT:CustName',GLOT:CustName)                      ! Added by: Report
  BIND('GLOT:CustAddress',GLOT:CustAddress)                ! Added by: Report
  BIND('GLOT:CusCSZ',GLOT:CusCSZ)                          ! Added by: Report
  CLEAR(GlobalRequest)                                     ! Clear GlobalRequest after storing locally
  CLEAR(GlobalResponse)
  Relate:Company.Open                                      ! File Company used by this procedure, so make sure it's RelationManager is open
  Relate:Orders.SetOpenRelated()
  Relate:Orders.Open                                       ! File Orders used by this procedure, so make sure it's RelationManager is open
  SELF.FilesOpened = True
  SELF.Open(ProgressWindow)                                ! Open window
  Do DefineListboxStyle
  ProgressWindow{Prop:Timer} = 10                          ! Assign timer interval
  ProgressMgr.Init(ScrollSort:AllowNumeric,)
  ThisReport.Init(Process:View, Relate:Orders, ?Progress:PctText, Progress:Thermometer, ProgressMgr, ORD:InvoiceNumber)
  ThisReport.AddSortOrder(ORD:InvoiceNumberKey)
  SELF.AddItem(?Progress:Cancel,RequestCancelled)
  SELF.Init(ThisReport,Report,Previewer)
  ?Progress:UserString{Prop:Text}=''
  Relate:Orders.SetQuickScan(1,Propagate:OneMany)
  SELF.SkipPreview = False
  SELF.Zoom = PageWidth
  Previewer.SetINIManager(INIMgr)
  Previewer.AllowUserZoom=True
  Previewer.Maximize=True
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:Company.Close
    Relate:Orders.Close
  END
  ProgressMgr.Kill()
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.Next PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
    !Process company record
    SET(Company)
    Access:Company.Next()
    LOC:CCSZ = CLIP(Company.Record.City) & ', ' & Company.Record.State|
                & '  ' & CLIP(Company.Record.Zipcode)
  ReturnValue = PARENT.Next()
  RETURN ReturnValue


ThisWindow.TakeCloseEvent PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  !Print second Detail band
  ! PRINT(RPT:Detail1)
  ReturnValue = PARENT.TakeCloseEvent()
  RETURN ReturnValue


ThisReport.TakeRecord PROCEDURE

ReturnValue          BYTE,AUTO

SkipDetails BYTE
  CODE
  ExtendPrice = DTL:Price * DTL:QuantityOrdered
  GLOT:CustName = CLIP(CUS:FirstName) & '   ' & CLIP(CUS:LastName)
  GLOT:CustAddress = CLIP(CUS:Address1) & '    ' & CLIP(CUS:Address2)
  GLOT:CusCSZ = CLIP(CUS:City) & ',  ' & CUS:State & '     ' & CLIP(CUS:ZipCode)
  GLOT:ShipName = CLIP(ORD:ShipToName)
  GLOT:ShipAddress = CLIP(ORD:ShipAddress1) & '    ' & CLIP(ORD:ShipAddress2)
  GLOT:ShipCSZ = CLIP(ORD:ShipCity) & ',  ' & ORD:ShipState & '    ' & CLIP(ORD:ShipZip)
  ReturnValue = PARENT.TakeRecord()
  PRINT(RPT:detail)
  RETURN ReturnValue

PrintSingleInvoice PROCEDURE                               ! Generated from procedure template - Report

LocalRequest         LONG                                  !
FilesOpened          BYTE                                  !
ExtendPrice          DECIMAL(7,2)                          !
LOC:CCSZ             STRING(35)                            !
Progress:Thermometer BYTE                                  !
PageNo               STRING(4)                             !
Process:View         VIEW(Orders)
                       PROJECT(ORD:CustNumber)
                       PROJECT(ORD:InvoiceNumber)
                       PROJECT(ORD:OrderDate)
                       PROJECT(ORD:OrderNumber)
                       PROJECT(ORD:ShipAddress1)
                       PROJECT(ORD:ShipAddress2)
                       PROJECT(ORD:ShipCity)
                       PROJECT(ORD:ShipState)
                       PROJECT(ORD:ShipToName)
                       PROJECT(ORD:ShipZip)
                       JOIN(CUS:KeyCustNumber,ORD:CustNumber)
                         PROJECT(CUS:Address1)
                         PROJECT(CUS:Address2)
                         PROJECT(CUS:City)
                         PROJECT(CUS:FirstName)
                         PROJECT(CUS:LastName)
                         PROJECT(CUS:State)
                         PROJECT(CUS:ZipCode)
                       END
                       JOIN(DTL:KeyDetails,ORD:CustNumber,ORD:OrderNumber)
                         PROJECT(DTL:CustNumber)
                         PROJECT(DTL:Discount)
                         PROJECT(DTL:OrderNumber)
                         PROJECT(DTL:Price)
                         PROJECT(DTL:QuantityOrdered)
                         PROJECT(DTL:TaxPaid)
                         PROJECT(DTL:TotalCost)
                         PROJECT(DTL:ProductNumber)
                         JOIN(PRO:KeyProductNumber,DTL:ProductNumber)
                           PROJECT(PRO:Description)
                           PROJECT(PRO:Price)
                           PROJECT(PRO:ProductSKU)
                         END
                       END
                     END
ProgressWindow       WINDOW('Report Progress...'),AT(,,142,59),CENTER,TIMER(1),GRAY,DOUBLE
                       PROGRESS,USE(Progress:Thermometer),AT(15,15,111,12),RANGE(0,100)
                       STRING(''),AT(0,3,141,10),USE(?Progress:UserString),CENTER
                       STRING(''),AT(0,30,141,10),USE(?Progress:PctText),CENTER
                       BUTTON('Cancel'),AT(45,42,48,15),USE(?Progress:Cancel),FLAT,LEFT,TIP('Cancel printing'),ICON(ICON:NoPrint)
                     END

Report               REPORT,AT(500,4500,7000,4475),PRE(RPT),FONT('MS Sans Serif',10,,FONT:regular),THOUS
                       HEADER,AT(500,917,7000,3583),USE(?unnamed:2)
                         BOX,AT(2552,10,1750,354),USE(?Box7),ROUND,COLOR(COLOR:Black),LINEWIDTH(10)
                         BOX,AT(52,1458,3885,260),USE(?Box4),ROUND,COLOR(COLOR:Black),LINEWIDTH(5)
                         IMAGE('RANTHUR.GIF'),AT(4781,208,1583,1490),USE(?Image1)
                         LINE,AT(2656,365,1458,0),USE(?Line7),COLOR(COLOR:Black),LINEWIDTH(3)
                         BOX,AT(52,625,3167,323),USE(?Box8),ROUND,COLOR(COLOR:Black),LINEWIDTH(5)
                         STRING('INVOICE'),AT(2594,31,1625,302),USE(?String35),CENTER,FONT('MS Sans Serif',24,COLOR:Navy,FONT:bold,CHARSET:ANSI)
                         STRING(@s20),AT(83,646,3104,271),USE(COM:Name),FONT('MS Sans Serif',18,,FONT:bold)
                         BOX,AT(52,948,3885,260),USE(?Box9),ROUND,COLOR(COLOR:Black),LINEWIDTH(5)
                         STRING(@s35),AT(83,990,3760,188),USE(COM:Address),FONT('MS Sans Serif',12,,FONT:bold)
                         BOX,AT(52,1208,3885,260),USE(?Box10),ROUND,COLOR(COLOR:Black),LINEWIDTH(5)
                         STRING(@s35),AT(83,1250,3792,188),USE(LOC:CCSZ),FONT('MS Sans Serif',12,,FONT:bold)
                         STRING(@P(###) ###-####P),AT(833,1479,1469,229),USE(COM:Phone),CENTER,FONT('MS Sans Serif',12,,FONT:bold,CHARSET:ANSI)
                         GROUP,AT(115,1844,6844,438),USE(?Group1),BOXED,TRN
                         END
                         STRING('Phone:'),AT(83,1479,719,229),USE(?String41),TRN,FONT('MS Sans Serif',12,,FONT:bold,CHARSET:ANSI)
                         STRING('Product SKU'),AT(104,3333,917,198),USE(?String17),TRN
                         STRING('Product Description'),AT(1042,3333,2083,198),USE(?String18),TRN
                         STRING('Quantity'),AT(4875,3333,729,198),USE(?String20),TRN,RIGHT(50)
                         STRING('Extension'),AT(5854,3333,781,198),USE(?String21),TRN,RIGHT(50)
                         LINE,AT(83,3542,6865,0),USE(?Line2),COLOR(COLOR:Black),LINEWIDTH(3)
                         STRING('Price'),AT(4083,3333,406,198),USE(?String19),TRN
                         STRING('Invoice #:'),AT(177,1958,990,250),USE(?String15),TRN,FONT('MS Sans Serif',14,COLOR:Maroon,FONT:bold,CHARSET:ANSI)
                         STRING('Order Date:'),AT(3781,1958,1219,250),USE(?String33),TRN,FONT('MS Sans Serif',14,COLOR:Maroon,FONT:bold,CHARSET:ANSI)
                         STRING(@d1),AT(4990,2021,729,177),USE(ORD:OrderDate),TRN,CENTER
                         STRING(@n07),AT(1125,2021,729,177),USE(ORD:InvoiceNumber),TRN,CENTER
                         STRING(@s35),AT(3760,2604,2948,167),USE(GLOT:ShipName)
                         STRING(@s45),AT(3760,2771,3125,167),USE(GLOT:ShipAddress)
                         STRING(@s40),AT(3760,2927,3125,167),USE(GLOT:ShipCSZ)
                         LINE,AT(3656,3135,3302,0),USE(?Line8:2),COLOR(COLOR:Black)
                         LINE,AT(125,3135,3302,0),USE(?Line8:4),COLOR(COLOR:Black)
                         STRING(@s35),AT(208,2604,3083,167),USE(GLOT:CustName)
                         LINE,AT(-31880,2625,0,604),USE(?Line12),COLOR(COLOR:Black)
                         STRING(@s45),AT(208,2771,3125,167),USE(GLOT:CustAddress)
                         STRING(@s40),AT(208,2927,3000,167),USE(GLOT:CusCSZ)
                         LINE,AT(83,3281,6865,0),USE(?Line1),COLOR(COLOR:Black),LINEWIDTH(3)
                         STRING('Ship To:'),AT(3760,2313,750,198),USE(?String31),FONT(,11,,FONT:bold)
                         LINE,AT(3417,2521,0,625),USE(?Line13),COLOR(COLOR:Black)
                         LINE,AT(125,2521,0,625),USE(?Line13:2),COLOR(COLOR:Black)
                         LINE,AT(125,2521,3302,0),USE(?Line8:3),COLOR(COLOR:Black)
                         LINE,AT(3656,2521,3302,0),USE(?Line8),COLOR(COLOR:Black)
                         LINE,AT(6958,2521,0,625),USE(?Line13:4),COLOR(COLOR:Black)
                         LINE,AT(3656,2521,0,625),USE(?Line13:3),COLOR(COLOR:Black)
                         STRING('Sold To:'),AT(208,2313,750,198),USE(?String32),FONT(,11,,FONT:bold)
                       END
break1                 BREAK(ORD:InvoiceNumber),USE(?unnamed:4)
detail                   DETAIL,AT(,,,242),USE(?detail)
                           STRING(@n$14.2B),AT(5406,21,83,52),USE(DTL:TotalCost),TRN,HIDE
                           STRING(@n$10.2B),AT(5500,10,135,52),USE(DTL:Discount),TRN,HIDE
                           STRING(@s10),AT(115,42,896,167),USE(PRO:ProductSKU)
                           STRING(@s35),AT(1083,42,2594,167),USE(PRO:Description)
                           STRING(@n7),AT(5073,42,635,167),USE(DTL:QuantityOrdered),RIGHT(100)
                           STRING(@n$10.2),AT(5896,42,823,167),USE(ExtendPrice),DECIMAL(250)
                           STRING(@n$10.2),AT(3990,42,771,167),USE(PRO:Price),DECIMAL(250)
                           STRING(@n$10.2B),AT(5635,10,63,52),USE(DTL:TaxPaid),TRN,HIDE
                         END
                         FOOTER,PAGEAFTER(-1),AT(0,0,,1025),USE(?unnamed:3)
                           LINE,AT(63,31,6865,0),USE(?Line3),COLOR(COLOR:Black),LINEWIDTH(3)
                           STRING('Sub-total:'),AT(4948,83,813,198),USE(?String23),TRN,LEFT(50),FONT(,,,FONT:bold)
                           STRING(@n$10.2),AT(5958,83,844,198),SUM,RESET(break1),USE(ExtendPrice,,?ExtendPrice:2),TRN,DECIMAL(250)
                           STRING('Discount:'),AT(4948,271,781,167),USE(?String24),LEFT(50)
                           STRING(@n$10.2B),AT(5948,271,844,167),SUM,RESET(break1),USE(DTL:Discount,,?DTL:Discount:2),DECIMAL(250)
                           STRING('NOTE:   Product on Back-Order will be available in 4 days.'),AT(94,354,3844,240),USE(?NoteString),CENTER,FONT('MS Sans Serif',10,,)
                           STRING('Tax:'),AT(4948,438,760,167),USE(?String27),LEFT(50)
                           STRING(@n$10.2),AT(5948,438,844,167),SUM,RESET(break1),USE(DTL:TaxPaid,,?DTL:TaxPaid:2),DECIMAL(250)
                           LINE,AT(5802,677,962,0),USE(?Line4),COLOR(COLOR:Black),LINEWIDTH(3)
                           STRING('Total:'),AT(4948,708,583,198),USE(?String30),TRN,LEFT(50),FONT(,,,FONT:bold)
                           STRING(@n$14.2),AT(5729,708,1063,208),SUM,RESET(break1),USE(DTL:TotalCost,,?DTL:TotalCost:2),TRN,DECIMAL(250)
                           LINE,AT(5792,917,962,0),USE(?Line5),COLOR(COLOR:Black),LINEWIDTH(3)
                           LINE,AT(5781,958,962,0),USE(?Line6),COLOR(COLOR:Black),LINEWIDTH(3)
                         END
                       END
                       FOOTER,AT(500,8969,7000,383),USE(?unnamed)
                         STRING('Page No:'),AT(6063,83),USE(?String43),TRN
                         STRING('Thank You For Your Order, Please Call Again.'),AT(1677,83,3490,198),USE(?String22),CENTER,FONT('MS Sans Serif',10,,FONT:bold)
                         STRING(@s4),AT(6677,83,219,208),PAGENO,USE(?PageNo)
                         BOX,AT(1604,52,3625,260),USE(?Box11),ROUND,COLOR(COLOR:Black),LINEWIDTH(5)
                       END
                     END
ThisWindow           CLASS(ReportManager)
AskPreview             PROCEDURE(),DERIVED                 ! Method added to host embed code
Init                   PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
Kill                   PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
Next                   PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
TakeCloseEvent         PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
                     END

ThisReport           CLASS(ProcessClass)                   ! Process Manager
TakeRecord             PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
                     END

ProgressMgr          StepLongClass                         ! Progress Manager
Previewer            PrintPreviewClass                     ! Print Previewer

  CODE
? DEBUGHOOK(Company:Record)
? DEBUGHOOK(Orders:Record)
  GlobalResponse = ThisWindow.Run()                        ! Opens the window and starts an Accept Loop

!---------------------------------------------------------------------------
DefineListboxStyle ROUTINE
!|
!| This routine create all the styles to be shared in this window
!| It`s called after the window open
!|
!---------------------------------------------------------------------------

ThisWindow.AskPreview PROCEDURE

  CODE
  IF (WebServer.IsEnabled())
    ENDPAGE(SELF.Report)
    WebPreview(WebServer,SELF.PreviewQueue,'',0,0)
    RETURN
  END
  PARENT.AskPreview


ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('PrintSingleInvoice')
  WebFilesManager.SelectTarget(Secure:None)
  SELF.Request = GlobalRequest                             ! Store the incoming request
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?Progress:Thermometer
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors                              ! Set this windows ErrorManager to the global ErrorManager
  BIND('GLOT:CustName',GLOT:CustName)                      ! Added by: Report
  BIND('GLOT:CustAddress',GLOT:CustAddress)                ! Added by: Report
  BIND('GLOT:CusCSZ',GLOT:CusCSZ)                          ! Added by: Report
  CLEAR(GlobalRequest)                                     ! Clear GlobalRequest after storing locally
  CLEAR(GlobalResponse)
  Relate:Company.Open                                      ! File Company used by this procedure, so make sure it's RelationManager is open
  Relate:Orders.SetOpenRelated()
  Relate:Orders.Open                                       ! File Orders used by this procedure, so make sure it's RelationManager is open
  SELF.FilesOpened = True
  SELF.Open(ProgressWindow)                                ! Open window
  Do DefineListboxStyle
  ProgressWindow{Prop:Timer} = 10                          ! Assign timer interval
  ProgressMgr.Init(ScrollSort:AllowNumeric,)
  ThisReport.Init(Process:View, Relate:Orders, ?Progress:PctText, Progress:Thermometer, ProgressMgr, ORD:InvoiceNumber)
  ThisReport.AddSortOrder(ORD:InvoiceNumberKey)
  ThisReport.AddRange(ORD:InvoiceNumber)
  SELF.AddItem(?Progress:Cancel,RequestCancelled)
  SELF.Init(ThisReport,Report,Previewer)
  ?Progress:UserString{Prop:Text}=''
  Relate:Orders.SetQuickScan(1,Propagate:OneMany)
  SELF.SkipPreview = False
  SELF.Zoom = PageWidth
  Previewer.SetINIManager(INIMgr)
  Previewer.AllowUserZoom=True
  Previewer.Maximize=True
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:Company.Close
    Relate:Orders.Close
  END
  ProgressMgr.Kill()
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.Next PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
    !Process company record
    SET(Company)
    Access:Company.Next()
    LOC:CCSZ = CLIP(Company.Record.City) & ', ' & Company.Record.State|
                & '  ' & CLIP(Company.Record.Zipcode)
  ReturnValue = PARENT.Next()
  RETURN ReturnValue


ThisWindow.TakeCloseEvent PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  !Print second Detail band
  ! PRINT(RPT:Detail1)
  ReturnValue = PARENT.TakeCloseEvent()
  RETURN ReturnValue


ThisReport.TakeRecord PROCEDURE

ReturnValue          BYTE,AUTO

SkipDetails BYTE
  CODE
  ExtendPrice = DTL:Price * DTL:QuantityOrdered
  GLOT:CustName = CLIP(CUS:FirstName) & '   ' & CLIP(CUS:LastName)
  GLOT:CustAddress = CLIP(CUS:Address1) & '    ' & CLIP(CUS:Address2)
  GLOT:CusCSZ = CLIP(CUS:City) & ',  ' & CUS:State & '     ' & CLIP(CUS:ZipCode)
  GLOT:ShipName = CLIP(ORD:ShipToName)
  GLOT:ShipAddress = CLIP(ORD:ShipAddress1) & '    ' & CLIP(ORD:ShipAddress2)
  GLOT:ShipCSZ = CLIP(ORD:ShipCity) & ',  ' & ORD:ShipState & '    ' & CLIP(ORD:ShipZip)
  ReturnValue = PARENT.TakeRecord()
  PRINT(RPT:detail)
  RETURN ReturnValue

