   PROGRAM


   INCLUDE('WBFILE.INC'),ONCE

   INCLUDE('ABERROR.INC'),ONCE
   INCLUDE('ABFILE.INC'),ONCE
   INCLUDE('ABLSYM.INC'),ONCE
   INCLUDE('ABUTIL.INC'),ONCE
   INCLUDE('ERRORS.CLW'),ONCE
   INCLUDE('KEYCODES.CLW'),ONCE
   INCLUDE('WBFILE.INC'),ONCE
   INCLUDE('WBFRAME.INC'),ONCE
   INCLUDE('WBSTD.EQU'),ONCE
   INCLUDE('WBSTD.INC'),ONCE
   INCLUDE('WBBROKER.INC'),ONCE
   INCLUDE('WBFILES.INC'),ONCE
   INCLUDE('WBHTML.INC'),ONCE
   INCLUDE('WBSERVER.INC'),ONCE
   INCLUDE('LAYHTML.INT'),ONCE
   INCLUDE('LAYBUILD.INT'),ONCE

   MAP
     MODULE('WEBINBC.CLW')
DctInit     PROCEDURE                                      ! Initializes the dictionary definition module
DctKill     PROCEDURE                                      ! Kills the dictionary definition module
     END
!--- Application Global and Exported Procedure Definitions --------------------------------------------
     MODULE('WEBIN002.CLW')
Main                   PROCEDURE   !C6 Application for C:\clarion5\examples\cwic\invoice\Invoice.dct
     END
     INCLUDE('WBPREVIEW.INC')
     Web:Initialise()
   END

GLOT:CustName        STRING(35),THREAD
GLOT:ShipName        STRING(35),THREAD
GLOT:CustAddress     STRING(45),THREAD
GLOT:ShipAddress     STRING(45),THREAD
GLOT:CusCSZ          STRING(40),THREAD
GLOT:ShipCSZ         STRING(40),THREAD
GLO:Pathname         STRING(50)
SilentRunning        BYTE(0)                               ! Set true when application is running in 'silent mode'

States               FILE,DRIVER('TOPSPEED'),PRE(STA),CREATE,BINDABLE,THREAD
StateCodeKey             KEY(STA:StateCode),NOCASE,OPT
Record                   RECORD,PRE()
StateCode                   STRING(2)
Name                        STRING(25)
                         END
                     END                       

Company              FILE,DRIVER('TOPSPEED'),PRE(COM),CREATE,BINDABLE,THREAD
Record                   RECORD,PRE()
Name                        STRING(20)
Address                     STRING(35)
City                        STRING(25)
State                       STRING(2)
Zipcode                     STRING(10)
Phone                       STRING(10)
                         END
                     END                       

Products             FILE,DRIVER('TOPSPEED'),PRE(PRO),CREATE,BINDABLE,THREAD
KeyProductNumber         KEY(PRO:ProductNumber),NOCASE,OPT,PRIMARY
KeyProductSKU            KEY(PRO:ProductSKU),NOCASE,OPT
KeyDescription           KEY(PRO:Description),DUP,NOCASE,OPT
Record                   RECORD,PRE()
ProductNumber               LONG
ProductSKU                  STRING(10)
Description                 STRING(35)
Price                       DECIMAL(7,2)
QuantityInStock             DECIMAL(7,2)
ReorderQuantity             DECIMAL(7,2)
Cost                        DECIMAL(7,2)
PictureFile                 STRING(64)
                         END
                     END                       

Detail               FILE,DRIVER('TOPSPEED'),PRE(DTL),CREATE,BINDABLE,THREAD
KeyDetails               KEY(DTL:CustNumber,DTL:OrderNumber,DTL:LineNumber),NOCASE,OPT,PRIMARY
Record                   RECORD,PRE()
CustNumber                  LONG
OrderNumber                 LONG
LineNumber                  SHORT
ProductNumber               LONG
QuantityOrdered             DECIMAL(7,2)
BackOrdered                 BYTE
Price                       DECIMAL(7,2)
TaxRate                     DECIMAL(6,4)
TaxPaid                     DECIMAL(7,2)
DiscountRate                DECIMAL(6,4)
Discount                    DECIMAL(7,2)
Savings                     DECIMAL(7,2)
TotalCost                   DECIMAL(10,2)
                         END
                     END                       

Orders               FILE,DRIVER('TOPSPEED'),PRE(ORD),CREATE,BINDABLE,THREAD
KeyCustOrderNumber       KEY(ORD:CustNumber,ORD:OrderNumber),DUP,NOCASE,OPT
InvoiceNumberKey         KEY(ORD:InvoiceNumber),NOCASE,OPT
Record                   RECORD,PRE()
CustNumber                  LONG
OrderNumber                 LONG
InvoiceNumber               LONG
OrderDate                   LONG
SameName                    BYTE
ShipToName                  STRING(45)
SameAdd                     BYTE
ShipAddress1                STRING(35)
ShipAddress2                STRING(35)
ShipCity                    STRING(25)
ShipState                   STRING(2)
ShipZip                     STRING(10)
OrderShipped                BYTE
OrderNote                   STRING(80)
                         END
                     END                       

Customers            FILE,DRIVER('TOPSPEED'),PRE(CUS),CREATE,BINDABLE,THREAD
KeyCustNumber            KEY(CUS:CustNumber),NOCASE,OPT
KeyFullName              KEY(CUS:LastName,CUS:FirstName,CUS:MI),DUP,NOCASE,OPT
KeyCompany               KEY(CUS:Company),DUP,NOCASE
KeyZipCode               KEY(CUS:ZipCode),DUP,NOCASE
StateKey                 KEY(CUS:State),DUP,NOCASE,OPT
Record                   RECORD,PRE()
CustNumber                  LONG
Company                     STRING(20)
FirstName                   STRING(20)
MI                          STRING(1)
LastName                    STRING(25)
Address1                    STRING(35)
Address2                    STRING(35)
City                        STRING(25)
State                       STRING(2)
ZipCode                     STRING(10)
PhoneNumber                 STRING(10)
Extension                   STRING(4)
PhoneType                   STRING(8)
                         END
                     END                       


Broker               WbBrokerClass                         ! Application broker
HtmlManager          WbHtmlClass
WebServer            WbServerClass
WebFilesManager      WbFilesClass
ShutDownManager      CLASS(WbShutDownClass)
Close                  PROCEDURE(),DERIVED                 ! Method added to host embed code
                     END

WebFileAccess        WbFileProperties
Access:States        &FileManager,THREAD                   ! FileManager for States
Relate:States        &RelationManager,THREAD               ! RelationManager for States

WebTableProperties:States WbTableProperties

Access:Company       &FileManager,THREAD                   ! FileManager for Company
Relate:Company       &RelationManager,THREAD               ! RelationManager for Company

WebTableProperties:Company WbTableProperties

Access:Products      &FileManager,THREAD                   ! FileManager for Products
Relate:Products      &RelationManager,THREAD               ! RelationManager for Products

WebTableProperties:Products WbTableProperties

Access:Detail        &FileManager,THREAD                   ! FileManager for Detail
Relate:Detail        &RelationManager,THREAD               ! RelationManager for Detail

WebTableProperties:Detail WbTableProperties

Access:Orders        &FileManager,THREAD                   ! FileManager for Orders
Relate:Orders        &RelationManager,THREAD               ! RelationManager for Orders

WebTableProperties:Orders WbTableProperties

Access:Customers     &FileManager,THREAD                   ! FileManager for Customers
Relate:Customers     &RelationManager,THREAD               ! RelationManager for Customers

WebTableProperties:Customers WbTableProperties


GlobalErrorStatus    ErrorStatusClass,THREAD
GlobalErrors         ErrorClass                            ! Global error manager
INIMgr               INIClass                              ! Global non-volatile storage manager
GlobalRequest        BYTE(0),THREAD                        ! Set when a browse calls a form, to let it know action to perform
GlobalResponse       BYTE(0),THREAD                        ! Set to the response from the form
VCRRequest           LONG(0),THREAD                        ! Set to the request from the VCR buttons

Dictionary           CLASS,THREAD
Construct              PROCEDURE
Destruct               PROCEDURE
                     END


  CODE
  GlobalErrors.Init(GlobalErrorStatus)
  INIMgr.Init('.\WebInv.INI', NVD_INI)                     ! Configure INIManager to use INI file
  DctInit
  Web:Initialise
  Main
  INIMgr.Update
  WebServer.Halt
  INIMgr.Kill                                              ! Destroy INI manager
    
Web:Initialise          PROCEDURE
  CODE
  SetWebActiveFrame
  WebFilesManager.Init(1, '')
  WbFilesClass::Set(WebFilesManager)
  Broker.Init('WebInv', WebFilesManager)
  SetSkeletonTheme('')
  IF (Broker.GetEnabled())
    IF (IC:GetEnvironmentVariable('WEBPLATE'))
      AddSkeletonDirectory(IC:GetEnvironmentVariable('WEBPLATE'))
    END
    AddSkeletonDirectory('Skeleton\WebInv')
    AddSkeletonDirectory('Skeleton')
  END
  WbBrowserProperties.Init(Broker)
  RegisterGlobalProperties('Browser',WbBrowserProperties.IProperties)
  HtmlManager.Init(WebFilesManager)
  WebServer.Init(Broker, ShutDownManager, '', 600, '', WebFilesManager)

ShutDownManager.Close PROCEDURE

  CODE
  PARENT.Close
  WebServer.Kill
  HtmlManager.Kill
  Broker.Kill
  WebFilesManager.Kill
  IC:UnloadBroker()



Dictionary.Construct PROCEDURE

  CODE
  IF THREAD()<>1
     DctInit()
  END


Dictionary.Destruct PROCEDURE

  CODE
  DctKill()

