

   MEMBER('WEBORDER.clw')                                  ! This is a MEMBER module


   INCLUDE('ABBROWSE.INC'),ONCE
   INCLUDE('ABPOPUP.INC'),ONCE
   INCLUDE('ABRESIZE.INC'),ONCE
   INCLUDE('ABTOOLBA.INC'),ONCE
   INCLUDE('ABWINDOW.INC'),ONCE

                     MAP
                       INCLUDE('WEBOR005.INC'),ONCE        !Local module procedure declarations
                       INCLUDE('WEBOR008.INC'),ONCE        !Req'd for module callout resolution
                     END



UpdateProduct PROCEDURE                                    ! Generated from procedure template - Window

CurrentTab           STRING(80)                            !
FilesOpened          BYTE                                  !
ActionMessage        CSTRING(40)                           !
BRW2::View:Browse    VIEW(Items)
                       PROJECT(ITEM:CustNo)
                       PROJECT(ITEM:OrderNo)
                       PROJECT(ITEM:LineNo)
                       PROJECT(ITEM:ProdCode)
                       PROJECT(ITEM:Quantity)
                       PROJECT(ITEM:Price)
                     END
Queue:Browse:2       QUEUE                            !Queue declaration for browse/combo box using ?Browse:2
ITEM:CustNo            LIKE(ITEM:CustNo)              !List box control field - type derived from field
ITEM:OrderNo           LIKE(ITEM:OrderNo)             !List box control field - type derived from field
ITEM:LineNo            LIKE(ITEM:LineNo)              !List box control field - type derived from field
ITEM:ProdCode          LIKE(ITEM:ProdCode)            !List box control field - type derived from field
ITEM:Quantity          LIKE(ITEM:Quantity)            !List box control field - type derived from field
ITEM:Price             LIKE(ITEM:Price)               !List box control field - type derived from field
Mark                   BYTE                           !Entry's marked status
ViewPosition           STRING(1024)                   !Entry's view position
                     END
History::PROD:Record LIKE(PROD:RECORD),THREAD
QuickWindow          WINDOW('Update the Product File'),AT(,,276,138),FONT('MS Sans Serif',8,COLOR:Black,),IMM,HLP('UpdateProduct'),SYSTEM,GRAY,RESIZE,MDI
                       SHEET,AT(4,4,268,112),USE(?CurrentTab)
                         TAB('General'),USE(?Tab:1)
                           PROMPT('Product Code:'),AT(8,20),USE(?PROD:ProdCode:Prompt)
                           STRING(@n05),AT(64,20,40,10),USE(PROD:ProdCode)
                           PROMPT('Description'),AT(8,34),USE(?PROD:Description:Prompt)
                           ENTRY(@s50),AT(64,34,204,10),USE(PROD:Description),MSG('Pproduct Description'),INS
                           PROMPT('Unit price'),AT(8,48),USE(?PROD:Price:Prompt)
                           ENTRY(@n10.2),AT(64,48,44,10),USE(PROD:Price),DECIMAL(12),MSG('Unit Price'),INS
                         END
                         TAB('Items'),USE(?Tab:2)
                           LIST,AT(8,20,260,92),USE(?Browse:2),IMM,HVSCROLL,MSG('Browsing Records'),FORMAT('24R(2)|M~Cust~C(0)@n05@36R(2)|M~Order No~C(0)@n06@32R(2)|M~Line No~C(0)@n04@24R(' &|
   '2)|M~Prod~C(0)@n05@28R(2)|M~Qty~C(0)@n6@44D(18)|M~Price~C(0)@n10.2@'),FROM(Queue:Browse:2)
                           BUTTON('&Insert'),AT(125,80,45,14),USE(?Insert:3),HIDE
                           BUTTON('&Change'),AT(174,80,45,14),USE(?Change:3),HIDE
                           BUTTON('&Delete'),AT(223,80,45,14),USE(?Delete:3),HIDE
                         END
                       END
                       BUTTON('OK'),AT(178,120,45,14),USE(?OK),DEFAULT
                       BUTTON('Cancel'),AT(227,120,45,14),USE(?Cancel)
                       BUTTON('Help'),AT(227,4,45,14),USE(?Help),HIDE,STD(STD:Help)
                     END
WebWindow            CLASS(WebWindowClass)
                     END
IC:CurControl        &WebControlClass                      ! Temporary control pointer
IC:CurFrame          &WebFrameClass

ThisWindow           CLASS(WindowManager)
Ask                    PROCEDURE(),DERIVED                 ! Method added to host embed code
Init                   PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
Kill                   PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
Run                    PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
Run                    PROCEDURE(USHORT Number,BYTE Request),BYTE,PROC,DERIVED ! Method added to host embed code
TakeAccepted           PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
TakeEvent              PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
                     END

Toolbar              ToolbarClass
BRW2                 CLASS(BrowseClass)                    ! Browse using ?Browse:2
Q                      &Queue:Browse:2                !Reference to browse queue
Fetch                  PROCEDURE(BYTE Direction),DERIVED   ! Method added to host embed code
Init                   PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM) ! Method added to host embed code
                     END

BRW2::Sort0:Locator  StepLocatorClass                      ! Default Locator
BRW2::Sort0:StepClass StepLongClass                        ! Default Step Manager
ToolbarForm          ToolbarUpdateClass                    ! Form Toolbar Manager
Resizer              CLASS(WindowResizeClass)
Init                   PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False) ! Method added to host embed code
                     END

CurCtrlFeq          LONG
FieldColorQueue     QUEUE
Feq                   LONG
OldColor              LONG
                    END

  CODE
  GlobalResponse = ThisWindow.Run()                        ! Opens the window and starts an Accept Loop

!---------------------------------------------------------------------------
DefineListboxStyle ROUTINE
!|
!| This routine create all the styles to be shared in this window
!| It`s called after the window open
!|
!---------------------------------------------------------------------------

ThisWindow.Ask PROCEDURE

  CODE
  CASE SELF.Request                                        ! Configure the action message text
  OF ViewRecord
    ActionMessage = 'View Record'
  OF InsertRecord
    ActionMessage = 'Adding a Product Record'
  OF ChangeRecord
    ActionMessage = 'Changing a Product Record'
  END
  QuickWindow{Prop:Text} = ActionMessage                   ! Display status message in title bar
  PARENT.Ask


ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('UpdateProduct')
  SELF.Request = GlobalRequest                             ! Store the incoming request
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?PROD:ProdCode:Prompt
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors                              ! Set this windows ErrorManager to the global ErrorManager
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)                                     ! Clear GlobalRequest after storing locally
  CLEAR(GlobalResponse)
  SELF.HistoryKey = 734
  SELF.AddHistoryFile(PROD:Record,History::PROD:Record)
  SELF.AddHistoryField(?PROD:ProdCode,1)
  SELF.AddHistoryField(?PROD:Description,2)
  SELF.AddHistoryField(?PROD:Price,3)
  SELF.AddUpdateFile(Access:Product)
  SELF.AddItem(?Cancel,RequestCancelled)                   ! Add the cancel control to the window manager
  Relate:Items.SetOpenRelated()
  Relate:Items.Open                                        ! File Items used by this procedure, so make sure it's RelationManager is open
  Access:Product.UseFile                                   ! File referenced in 'Other Files' so need to inform it's FileManager
  SELF.FilesOpened = True
  SELF.Primary &= Relate:Product
  IF SELF.Request = ViewRecord AND NOT SELF.BatchProcessing ! Setup actions for ViewOnly Mode
    SELF.InsertAction = Insert:None
    SELF.DeleteAction = Delete:None
    SELF.ChangeAction = Change:None
    SELF.CancelAction = Cancel:Cancel
    SELF.OkControl = 0
  ELSE
    SELF.ChangeAction = Change:Caller                      ! Changes allowed
    SELF.OkControl = ?OK
    IF SELF.PrimeUpdate() THEN RETURN Level:Notify.
  END
  BRW2.Init(?Browse:2,Queue:Browse:2.ViewPosition,BRW2::View:Browse,Queue:Browse:2,Relate:Items,SELF) ! Initialize the browse manager
  SELF.Open(QuickWindow)                                   ! Open window
  Do DefineListboxStyle
  !- Initialise the internet classes
  WebWindow.Init(WebServer, HtmlManager, QuickWindow{PROP:text} & ' (UpdateProduct)')
  WebWindow.SetFormatOptions(2, 2, 6, 13)
  WebWindow.MenubarType = PROP:above
  WebWindow.CreateClose = CLOSE:Always
  WebWindow.SetPageBackground(12632256, 'Crumpled.gif')
  WebWindow.BorderWidth = 2
  WebWindow.SheetBorderWidth = 2
  WebWindow.OptionBorderWidth = 2
  WebWindow.GroupBorderWidth = 2
  WebWindow.CreateCaption = 1
  
  IC:CurControl &= WebWindow.AddControl(?Browse:2)
  IC:CurControl.SetQueue(Queue:Browse:2)
  IF (WebServer.Active)
    IC:CurFrame &= GetWebActiveFrame()
    IC:CurFrame.CopyControlsToWindow(WebWindow, TRUE, TRUE)
  END
  BRW2.Q &= Queue:Browse:2
  BRW2::Sort0:StepClass.Init(+ScrollSort:AllowAlpha)       ! Moveable thumb based upon ITEM:OrderNo for sort order 1
  BRW2.AddSortOrder(BRW2::Sort0:StepClass,ITEM:ByProduct)  ! Add the sort order for ITEM:ByProduct for sort order 1
  BRW2.AddRange(ITEM:ProdCode,Relate:Items,Relate:Product) ! Add file relationship range limit for sort order 1
  BRW2.AddLocator(BRW2::Sort0:Locator)                     ! Browse has a locator for sort order 1
  BRW2::Sort0:Locator.Init(,ITEM:OrderNo,1,BRW2)           ! Initialize the browse locator using  using key: ITEM:ByProduct , ITEM:OrderNo
  BRW2.AddField(ITEM:CustNo,BRW2.Q.ITEM:CustNo)            ! Field ITEM:CustNo is a hot field or requires assignment from browse
  BRW2.AddField(ITEM:OrderNo,BRW2.Q.ITEM:OrderNo)          ! Field ITEM:OrderNo is a hot field or requires assignment from browse
  BRW2.AddField(ITEM:LineNo,BRW2.Q.ITEM:LineNo)            ! Field ITEM:LineNo is a hot field or requires assignment from browse
  BRW2.AddField(ITEM:ProdCode,BRW2.Q.ITEM:ProdCode)        ! Field ITEM:ProdCode is a hot field or requires assignment from browse
  BRW2.AddField(ITEM:Quantity,BRW2.Q.ITEM:Quantity)        ! Field ITEM:Quantity is a hot field or requires assignment from browse
  BRW2.AddField(ITEM:Price,BRW2.Q.ITEM:Price)              ! Field ITEM:Price is a hot field or requires assignment from browse
  Resizer.Init(AppStrategy:Surface,Resize:SetMinSize)      ! Controls like list boxes will resize, whilst controls like buttons will move
  SELF.AddItem(Resizer)                                    ! Add resizer to window manager
  INIMgr.Fetch('UpdateProduct',QuickWindow)                ! Restore window settings from non-volatile store
  Resizer.Resize                                           ! Reset required after window size altered by INI manager
  BRW2.AskProcedure = 1
  ToolBarForm.HelpButton=?Help
  SELF.AddItem(ToolbarForm)
  BRW2.AddToolbarTarget(Toolbar)                           ! Browse accepts toolbar control
  BRW2.ToolbarItem.HelpButton = ?Help
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:Items.Close
  END
  IF SELF.Opened
    INIMgr.Update('UpdateProduct',QuickWindow)             ! Save window data to non-volatile store
  END
  WebWindow.Kill
  IF (WebServer.Active)
    POST(EVENT:NewPage)
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.Run PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Run()
  IF SELF.Request = ViewRecord                             ! In View Only mode always signal RequestCancelled
    ReturnValue = RequestCancelled
  END
  RETURN ReturnValue


ThisWindow.Run PROCEDURE(USHORT Number,BYTE Request)

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Run(Number,Request)
  IF SELF.Request = ViewRecord
    ReturnValue = RequestCancelled                         ! Always return RequestCancelled if the form was opened in ViewRecord mode
  ELSE
    GlobalRequest = Request
    UpdateItems
    ReturnValue = GlobalResponse
  END
  RETURN ReturnValue


ThisWindow.TakeAccepted PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receive all EVENT:Accepted's
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
  ReturnValue = PARENT.TakeAccepted()
    CASE ACCEPTED()
    OF ?OK
      ThisWindow.Update
      IF SELF.Request = ViewRecord AND NOT SELF.BatchProcessing THEN
         POST(EVENT:CloseWindow)
      END
    END
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


ThisWindow.TakeEvent PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receives all events
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
    IF WebWindow.TakeEvent()
      BREAK
    END
  ReturnValue = PARENT.TakeEvent()
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


BRW2.Fetch PROCEDURE(BYTE Direction)

GreenBarIndex   LONG
  CODE
  PARENT.Fetch(Direction)


BRW2.Init PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)

  CODE
  PARENT.Init(ListBox,Posit,V,Q,RM,WM)
  IF WM.Request <> ViewRecord                              ! If called for anything other than ViewMode, make the insert, change & delete controls available
    SELF.InsertControl=?Insert:3
    SELF.ChangeControl=?Change:3
    SELF.DeleteControl=?Delete:3
  END


Resizer.Init PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)


  CODE
  PARENT.Init(AppStrategy,SetWindowMinSize,SetWindowMaxSize)
  SELF.SetParentDefaults()                                 ! Calculate default control parent-child relationships based upon their positions on the window


