

   MEMBER('WEBORDER.clw')                                  ! This is a MEMBER module


   INCLUDE('ABBROWSE.INC'),ONCE
   INCLUDE('ABPOPUP.INC'),ONCE
   INCLUDE('ABRESIZE.INC'),ONCE
   INCLUDE('ABTOOLBA.INC'),ONCE
   INCLUDE('ABWINDOW.INC'),ONCE

                     MAP
                       INCLUDE('WEBOR006.INC'),ONCE        !Local module procedure declarations
                       INCLUDE('WEBOR007.INC'),ONCE        !Req'd for module callout resolution
                       INCLUDE('WEBOR008.INC'),ONCE        !Req'd for module callout resolution
                     END



UpdateOrders PROCEDURE                                     ! Generated from procedure template - Window

CurrentTab           STRING(80)                            !
FilesOpened          BYTE                                  !
ActionMessage        CSTRING(40)                           !
BRW2::View:Browse    VIEW(Items)
                       PROJECT(ITEM:CustNo)
                       PROJECT(ITEM:OrderNo)
                       PROJECT(ITEM:LineNo)
                       PROJECT(ITEM:ProdCode)
                       PROJECT(ITEM:Quantity)
                       PROJECT(ITEM:Price)
                     END
Queue:Browse:2       QUEUE                            !Queue declaration for browse/combo box using ?Browse:2
ITEM:CustNo            LIKE(ITEM:CustNo)              !List box control field - type derived from field
ITEM:OrderNo           LIKE(ITEM:OrderNo)             !List box control field - type derived from field
ITEM:LineNo            LIKE(ITEM:LineNo)              !List box control field - type derived from field
ITEM:ProdCode          LIKE(ITEM:ProdCode)            !List box control field - type derived from field
ITEM:Quantity          LIKE(ITEM:Quantity)            !List box control field - type derived from field
ITEM:Price             LIKE(ITEM:Price)               !List box control field - type derived from field
Mark                   BYTE                           !Entry's marked status
ViewPosition           STRING(1024)                   !Entry's view position
                     END
History::ORD:Record  LIKE(ORD:RECORD),THREAD
QuickWindow          WINDOW('Update the Orders File'),AT(,,204,162),FONT('MS Sans Serif',8,COLOR:Black,),IMM,HLP('UpdateOrders'),SYSTEM,GRAY,RESIZE,MDI
                       SHEET,AT(4,4,196,136),USE(?CurrentTab)
                         TAB('General'),USE(?Tab:1)
                           PROMPT('Cust No:'),AT(8,20),USE(?ORD:CustNo:Prompt)
                           STRING(@n06),AT(64,20,40,10),USE(ORD:CustNo)
                           PROMPT('Order Number:'),AT(8,34),USE(?ORD:OrderNo:Prompt)
                           STRING(@n06),AT(64,34,40,10),USE(ORD:OrderNo)
                           PROMPT('Order date:'),AT(8,48),USE(?ORD:OrderDate:Prompt)
                           ENTRY(@d1),AT(64,48,104,10),USE(ORD:OrderDate),MSG('Order Date'),INS
                           PROMPT('Reference:'),AT(8,62),USE(?ORD:Reference:Prompt)
                           ENTRY(@s24),AT(64,62,100,10),USE(ORD:Reference),INS,MSG('Special Order Info')
                           CHECK('Order Has Been Shipped'),AT(64,76,100,8),USE(ORD:Shipped),MSG('Checkbox Field')
                           OPTION('Carrier'),AT(64,88,50,48),USE(ORD:Carrier),BOXED,MSG('Shipping Instructions')
                             RADIO('Mail'),AT(68,98),USE(?ORD:Carrier:Radio1)
                             RADIO('UPS'),AT(68,110),USE(?ORD:Carrier:Radio2)
                             RADIO('Other'),AT(68,122),USE(?ORD:Carrier:Radio3)
                           END
                         END
                         TAB('Ship To'),USE(?Tab:2)
                           PROMPT('Ship To:'),AT(8,20),USE(?ORD:ShipTo:Prompt)
                           ENTRY(@s32),AT(64,20,132,10),USE(ORD:ShipTo),MSG('Ship To Name'),INS
                           PROMPT('Address:'),AT(8,34),USE(?ORD:ShipAddress:Prompt)
                           ENTRY(@s32),AT(64,34,132,10),USE(ORD:ShipAddress),MSG('Ship To Address 1'),INS
                           PROMPT('City:'),AT(8,48),USE(?ORD:ShipCity:Prompt)
                           ENTRY(@s22),AT(64,48,92,10),USE(ORD:ShipCity),MSG('Ship To City'),INS
                           PROMPT('State:'),AT(8,62),USE(?ORD:ShipState:Prompt)
                           ENTRY(@s2),AT(64,62,40,10),USE(ORD:ShipState),MSG('Ship To State'),INS
                           PROMPT('Zip Code:'),AT(8,76),USE(?ORD:ShipZip:Prompt)
                           ENTRY(@n05),AT(64,76,40,10),USE(ORD:ShipZip),MSG('Ship To Zip Code'),INS
                         END
                         TAB('Items'),USE(?Tab:3)
                           LIST,AT(8,20,188,116),USE(?Browse:2),IMM,HVSCROLL,MSG('Browsing Records'),FORMAT('24R(2)|M~Cust~C(0)@n05@36R(2)|M~Order No~C(0)@n06@32R(2)|M~Line No~C(0)@n04@24R(' &|
   '2)|M~Prod~C(0)@n05@28R(2)|M~Qty~C(0)@n6@44D(18)|M~Price~C(0)@n10.2@'),FROM(Queue:Browse:2)
                           BUTTON('&Insert'),AT(53,104,45,14),USE(?Insert:3),HIDE
                           BUTTON('&Change'),AT(102,104,45,14),USE(?Change:3),HIDE
                           BUTTON('&Delete'),AT(151,104,45,14),USE(?Delete:3),HIDE
                         END
                       END
                       BUTTON('OK'),AT(106,144,45,14),USE(?OK),DEFAULT
                       BUTTON('Cancel'),AT(155,144,45,14),USE(?Cancel)
                       BUTTON('Help'),AT(155,4,45,14),USE(?Help),HIDE,STD(STD:Help)
                     END
WebWindow            CLASS(WebWindowClass)
                     END
IC:CurControl        &WebControlClass                      ! Temporary control pointer
IC:CurFrame          &WebFrameClass

ThisWindow           CLASS(WindowManager)
Ask                    PROCEDURE(),DERIVED                 ! Method added to host embed code
Init                   PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
Kill                   PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
Run                    PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
Run                    PROCEDURE(USHORT Number,BYTE Request),BYTE,PROC,DERIVED ! Method added to host embed code
TakeAccepted           PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
TakeEvent              PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
                     END

Toolbar              ToolbarClass
BRW2                 CLASS(BrowseClass)                    ! Browse using ?Browse:2
Q                      &Queue:Browse:2                !Reference to browse queue
Fetch                  PROCEDURE(BYTE Direction),DERIVED   ! Method added to host embed code
Init                   PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM) ! Method added to host embed code
                     END

BRW2::Sort0:Locator  StepLocatorClass                      ! Default Locator
BRW2::Sort0:StepClass StepLongClass                        ! Default Step Manager
ToolbarForm          ToolbarUpdateClass                    ! Form Toolbar Manager
Resizer              CLASS(WindowResizeClass)
Init                   PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False) ! Method added to host embed code
                     END

CurCtrlFeq          LONG
FieldColorQueue     QUEUE
Feq                   LONG
OldColor              LONG
                    END

  CODE
  GlobalResponse = ThisWindow.Run()                        ! Opens the window and starts an Accept Loop

!---------------------------------------------------------------------------
DefineListboxStyle ROUTINE
!|
!| This routine create all the styles to be shared in this window
!| It`s called after the window open
!|
!---------------------------------------------------------------------------

ThisWindow.Ask PROCEDURE

  CODE
  CASE SELF.Request                                        ! Configure the action message text
  OF ViewRecord
    ActionMessage = 'View Record'
  OF InsertRecord
    ActionMessage = 'Adding a Orders Record'
  OF ChangeRecord
    ActionMessage = 'Changing a Orders Record'
  END
  QuickWindow{Prop:Text} = ActionMessage                   ! Display status message in title bar
  PARENT.Ask


ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('UpdateOrders')
  SELF.Request = GlobalRequest                             ! Store the incoming request
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?ORD:CustNo:Prompt
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors                              ! Set this windows ErrorManager to the global ErrorManager
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)                                     ! Clear GlobalRequest after storing locally
  CLEAR(GlobalResponse)
  SELF.HistoryKey = 734
  SELF.AddHistoryFile(ORD:Record,History::ORD:Record)
  SELF.AddHistoryField(?ORD:CustNo,1)
  SELF.AddHistoryField(?ORD:OrderNo,2)
  SELF.AddHistoryField(?ORD:OrderDate,3)
  SELF.AddHistoryField(?ORD:Reference,4)
  SELF.AddHistoryField(?ORD:Shipped,10)
  SELF.AddHistoryField(?ORD:Carrier,11)
  SELF.AddHistoryField(?ORD:ShipTo,5)
  SELF.AddHistoryField(?ORD:ShipAddress,6)
  SELF.AddHistoryField(?ORD:ShipCity,7)
  SELF.AddHistoryField(?ORD:ShipState,8)
  SELF.AddHistoryField(?ORD:ShipZip,9)
  SELF.AddUpdateFile(Access:Orders)
  SELF.AddItem(?Cancel,RequestCancelled)                   ! Add the cancel control to the window manager
  Relate:Items.SetOpenRelated()
  Relate:Items.Open                                        ! File Items used by this procedure, so make sure it's RelationManager is open
  Relate:State.Open                                        ! File State used by this procedure, so make sure it's RelationManager is open
  Access:Orders.UseFile                                    ! File referenced in 'Other Files' so need to inform it's FileManager
  SELF.FilesOpened = True
  SELF.Primary &= Relate:Orders
  IF SELF.Request = ViewRecord AND NOT SELF.BatchProcessing ! Setup actions for ViewOnly Mode
    SELF.InsertAction = Insert:None
    SELF.DeleteAction = Delete:None
    SELF.ChangeAction = Change:None
    SELF.CancelAction = Cancel:Cancel
    SELF.OkControl = 0
  ELSE
    SELF.ChangeAction = Change:Caller                      ! Changes allowed
    SELF.OkControl = ?OK
    IF SELF.PrimeUpdate() THEN RETURN Level:Notify.
  END
  BRW2.Init(?Browse:2,Queue:Browse:2.ViewPosition,BRW2::View:Browse,Queue:Browse:2,Relate:Items,SELF) ! Initialize the browse manager
  SELF.Open(QuickWindow)                                   ! Open window
  Do DefineListboxStyle
  !- Initialise the internet classes
  WebWindow.Init(WebServer, HtmlManager, QuickWindow{PROP:text} & ' (UpdateOrders)')
  WebWindow.SetFormatOptions(2, 2, 6, 13)
  WebWindow.MenubarType = PROP:above
  WebWindow.CreateClose = CLOSE:Always
  WebWindow.SetPageBackground(12632256, 'Crumpled.gif')
  WebWindow.BorderWidth = 2
  WebWindow.SheetBorderWidth = 2
  WebWindow.OptionBorderWidth = 2
  WebWindow.GroupBorderWidth = 2
  WebWindow.CreateCaption = 1
  
  IC:CurControl &= WebWindow.AddControl(?Browse:2)
  IC:CurControl.SetQueue(Queue:Browse:2)
  IF (WebServer.Active)
    IC:CurFrame &= GetWebActiveFrame()
    IC:CurFrame.CopyControlsToWindow(WebWindow, TRUE, TRUE)
  END
  BRW2.Q &= Queue:Browse:2
  BRW2::Sort0:StepClass.Init(+ScrollSort:AllowAlpha)       ! Moveable thumb based upon ITEM:LineNo for sort order 1
  BRW2.AddSortOrder(BRW2::Sort0:StepClass,ITEM:AsEntered)  ! Add the sort order for ITEM:AsEntered for sort order 1
  BRW2.AddRange(ITEM:OrderNo,Relate:Items,Relate:Orders)   ! Add file relationship range limit for sort order 1
  BRW2.AddLocator(BRW2::Sort0:Locator)                     ! Browse has a locator for sort order 1
  BRW2::Sort0:Locator.Init(,ITEM:LineNo,1,BRW2)            ! Initialize the browse locator using  using key: ITEM:AsEntered , ITEM:LineNo
  BRW2.AddField(ITEM:CustNo,BRW2.Q.ITEM:CustNo)            ! Field ITEM:CustNo is a hot field or requires assignment from browse
  BRW2.AddField(ITEM:OrderNo,BRW2.Q.ITEM:OrderNo)          ! Field ITEM:OrderNo is a hot field or requires assignment from browse
  BRW2.AddField(ITEM:LineNo,BRW2.Q.ITEM:LineNo)            ! Field ITEM:LineNo is a hot field or requires assignment from browse
  BRW2.AddField(ITEM:ProdCode,BRW2.Q.ITEM:ProdCode)        ! Field ITEM:ProdCode is a hot field or requires assignment from browse
  BRW2.AddField(ITEM:Quantity,BRW2.Q.ITEM:Quantity)        ! Field ITEM:Quantity is a hot field or requires assignment from browse
  BRW2.AddField(ITEM:Price,BRW2.Q.ITEM:Price)              ! Field ITEM:Price is a hot field or requires assignment from browse
  Resizer.Init(AppStrategy:Surface,Resize:SetMinSize)      ! Controls like list boxes will resize, whilst controls like buttons will move
  SELF.AddItem(Resizer)                                    ! Add resizer to window manager
  INIMgr.Fetch('UpdateOrders',QuickWindow)                 ! Restore window settings from non-volatile store
  Resizer.Resize                                           ! Reset required after window size altered by INI manager
  BRW2.AskProcedure = 2
  ToolBarForm.HelpButton=?Help
  SELF.AddItem(ToolbarForm)
  BRW2.AddToolbarTarget(Toolbar)                           ! Browse accepts toolbar control
  BRW2.ToolbarItem.HelpButton = ?Help
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:Items.Close
    Relate:State.Close
  END
  IF SELF.Opened
    INIMgr.Update('UpdateOrders',QuickWindow)              ! Save window data to non-volatile store
  END
  WebWindow.Kill
  IF (WebServer.Active)
    POST(EVENT:NewPage)
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.Run PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Run()
  IF SELF.Request = ViewRecord                             ! In View Only mode always signal RequestCancelled
    ReturnValue = RequestCancelled
  END
  RETURN ReturnValue


ThisWindow.Run PROCEDURE(USHORT Number,BYTE Request)

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Run(Number,Request)
  IF SELF.Request = ViewRecord
    ReturnValue = RequestCancelled                         ! Always return RequestCancelled if the form was opened in ViewRecord mode
  ELSE
    GlobalRequest = Request
    EXECUTE Number
      SelectState
      UpdateItems
    END
    ReturnValue = GlobalResponse
  END
  RETURN ReturnValue


ThisWindow.TakeAccepted PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receive all EVENT:Accepted's
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
  ReturnValue = PARENT.TakeAccepted()
    CASE ACCEPTED()
    OF ?ORD:ShipState
      ST:StateCode = ORD:ShipState
      IF Access:State.TryFetch(ST:ByCode)
        IF SELF.Run(1,SelectRecord) = RequestCompleted
          ORD:ShipState = ST:StateCode
        ELSE
          SELECT(?ORD:ShipState)
          CYCLE
        END
      END
      ThisWindow.Reset(0)
      IF Access:Orders.TryValidateField(8)                 ! Attempt to validate ORD:ShipState in Orders
        SELECT(?ORD:ShipState)
        QuickWindow{Prop:AcceptAll} = False
        CYCLE
      ELSE
        FieldColorQueue.Feq = ?ORD:ShipState
        GET(FieldColorQueue, FieldColorQueue.Feq)
        IF ~ERRORCODE()
          ?ORD:ShipState{Prop:FontColor} = FieldColorQueue.OldColor
          DELETE(FieldColorQueue)
        END
      END
    OF ?OK
      ThisWindow.Update
      IF SELF.Request = ViewRecord AND NOT SELF.BatchProcessing THEN
         POST(EVENT:CloseWindow)
      END
    END
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


ThisWindow.TakeEvent PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receives all events
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
    IF WebWindow.TakeEvent()
      BREAK
    END
  ReturnValue = PARENT.TakeEvent()
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


BRW2.Fetch PROCEDURE(BYTE Direction)

GreenBarIndex   LONG
  CODE
  PARENT.Fetch(Direction)


BRW2.Init PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)

  CODE
  PARENT.Init(ListBox,Posit,V,Q,RM,WM)
  IF WM.Request <> ViewRecord                              ! If called for anything other than ViewMode, make the insert, change & delete controls available
    SELF.InsertControl=?Insert:3
    SELF.ChangeControl=?Change:3
    SELF.DeleteControl=?Delete:3
  END


Resizer.Init PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)


  CODE
  PARENT.Init(AppStrategy,SetWindowMinSize,SetWindowMaxSize)
  SELF.SetParentDefaults()                                 ! Calculate default control parent-child relationships based upon their positions on the window


