  MEMBER

BaseClassDllMode     EQUATE(0)

  INCLUDE('ICWINDOW.INC')
  INCLUDE('ICCNTRLS.INC')
  INCLUDE('ICSTD.EQU')

  MAP
    WebControlFactory(SIGNED Feq),*WebControlClass
  END

WebControlFactory PROCEDURE(SIGNED Type)

NewControl      &WebControlClass           ! Initialised to NULL

  CODE

  CASE (Type)
  OF 0
  OROF 23
  OF CREATE:Button
    NewControl &= NEW WebJavaButtonClass
  OF CREATE:Caption
    NewControl &= NEW WebCaptionClass
  OF CREATE:Check
    NewControl &= NEW WebHtmlCheckClass
  OF CREATE:ClientArea
    NewControl &= NEW WebClientAreaClass
  OF CREATE:Close
    NewControl &= NEW WebCloseButtonClass
  OF CREATE:Combo
    NewControl &= NEW WebHtmlEntryClass
  OF CREATE:DropList
    NewControl &= NEW WebHtmlListClass
  OF CREATE:Entry
    NewControl &= NEW WebHtmlEntryClass
  OF CREATE:Group
    NewControl &= NEW WebHtmlGroupClass
  OF CREATE:Image
    NewControl &= NEW WebHtmlImageClass
  OF CREATE:Item
    NewControl &= NEW WebHtmlItemClass
  OF CREATE:List
    NewControl &= NEW WebJavaListClass
  OF CREATE:Menu
    NewControl &= NEW WebHtmlMenuClass
  OF CREATE:Menubar
    NewControl &= NEW WebMenubarClass
  OF CREATE:Option
    NewControl &= NEW WebHtmlOptionClass
  OF CREATE:Prompt
    NewControl &= NEW WebHtmlPromptClass
  OF CREATE:Radio
    NewControl &= NEW WebHtmlRadioClass
  OF CREATE:Region
    NewControl &= NEW WebHtmlRegionClass
  OF CREATE:SString
    NewControl &= NEW WebJavaStringClass
  OF CREATE:Sheet
    NewControl &= NEW WebHtmlSheetClass
  OF CREATE:Spin
    NewControl &= NEW WebHtmlEntryClass
  OF CREATE:String
    NewControl &= NEW WebHtmlStringClass
  OF CREATE:Tab
    NewControl &= NEW WebHtmlTabClass
  OF CREATE:Text
    NewControl &= NEW WebHtmlTextClass
  OF CREATE:TextButton
    NewControl &= NEW WebHtmlButtonClass
  OF CREATE:ToolButton
    NewControl &= NEW WebJavaToolButtonClass
  OF CREATE:Toolbar
    NewControl &= NEW WebToolbarClass
  END
  IF (~NewControl &= NULL)
    NewControl.IsDynamic = TRUE
  END
  RETURN NewControl

